package dataqulity.webservices.dataqulity.webservices;

import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;

@WebService
public class DataQualityClassicModels {

	/**
	 * Base de datos
	 * 
	 * @param url
	 * @return Porcentaje de registros duplicados
	 * @throws Exception
	 */
	@WebMethod
	public double duplicateRegisters(@WebParam(name = "url") String url, @WebParam(name = "prueba") double double2 ) throws Exception {
		try {

			int registerDuplicateCount = 0;

			Class.forName("com.mysql.jdbc.Driver");

			Connection con = DriverManager
					.getConnection("jdbc:mysql://localhost:3306/employees?user=root&password=admin");
			Statement s = con.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_READ_ONLY);
			Statement s2 = con.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_READ_ONLY);
			String sql1 = "SELECT  first_name, last_name, birth_date, gender FROM employees";
			ResultSet rs1 = s.executeQuery(sql1);

		
			List<ArrayList<String>> employees = new ArrayList<>();

			while (rs1.next()) {
				ArrayList<String> employee = new ArrayList<String>();
				employee.add(rs1.getString(1));
				employee.add(rs1.getString(2));
				employee.add(rs1.getString(3));
				employee.add(rs1.getString(4));
				employees.add(employee);
			}

			for (List<String> a1 : employees) {
				int cantidad = 0;
				for (List<String> a2 : employees) {
					if (a1.containsAll(a2)) {
						cantidad++;
					}
				}
				if (cantidad > 1)
					registerDuplicateCount++;
			}

			return registerDuplicateCount;
		} catch (ClassNotFoundException |

				SQLException e) {
			//
			e.printStackTrace();
			throw new Exception(e.getMessage());
		}
	}

	/**
	 * Porcentaje de registros de la columna 2 estan en la columna 1 La tabla table2 debe tener
	 * solo un valor de pk
	 * 
	 * @param url
	 *            Url de la base de datos
	 * @param table1
	 *            Nombre de la tabla a la cual pertenece la columna 1
	 * @param column1
	 *            Nombre de la columna que se desea verificar si los datos de la columna 2 estan en dicha columna.
	 * @param table2
	 *            Nombre de la tabla a la cual pertenece la columna 2
	 * @param column2
	 * @return retorna un map que contine como clave la pk de la tabla 2, y como valor si el dato de
	 *         la columna 2 correspondiente al registro de la pk esta en la columna 1.
	 * @throws Exception
	 * 
	 */
	@WebMethod
	public double interRelationIntegrity(@WebParam(name = "url") String url,
			@WebParam(name = "referencedTable") String referencedTable, @WebParam(name = "referencedColumn") String referencedColumn,
			@WebParam(name = "table") String table, @WebParam(name = "column") String column) throws Exception {

		try {

			Class.forName("com.mysql.jdbc.Driver");

			Connection con = DriverManager
					.getConnection("jdbc:mysql://localhost:3306/classicmodels?user=root&password=admin");
			Statement s1 = con.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_READ_ONLY);
			Statement s2 = con.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_READ_ONLY);

			String sql1 = "SELECT  " + referencedColumn + " FROM " + referencedTable;
			String sql2 = "SELECT  " + column + " FROM " + table;

			List<String> column1Data = new ArrayList<String>();
			List<String> column2Data = new ArrayList<String>();

			// TODO: obtener la pk de la tabla2 y agregarlo al select para ponerlo en el map
			ResultSet rs1 = s1.executeQuery(sql1);

			while (rs1.next()) {
				column1Data.add(rs1.getString(1));
			}

			ResultSet rs2 = s2.executeQuery(sql2);
			while (rs2.next()) {
				column2Data.add(rs2.getString(1));
			}

			int resultado = 0;

			for (String a2 : column2Data) {

				Boolean contains = column1Data.contains(a2);
				if(contains) {
					resultado++;
				}
			}

			return (double) ((resultado*100)/column2Data.size());
		} catch (ClassNotFoundException | SQLException e) {
			//
			e.printStackTrace();
			throw new Exception(e.getMessage());
		}

	}
	
	/** Correctitud sintáctica
	 * Valida si el numero de telefono tiene largo correcto y si son solo numeros
	 * @param phone
	 * @param longPhoneNumber
	 * @return
	 */
	@WebMethod
	public boolean validatePhone(@WebParam(name = "phone") String phone, @WebParam(name = "longPhoneNumber") int longPhoneNumber) {
		
		if(phone.length() != longPhoneNumber) {
			return false;
		}
		
		try{
			Integer.parseInt(phone);
		}catch (Exception e) {
			return false;
		}
			
		return true;
	}

}
