package com.kiuplus.logic.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.Table;
import javax.validation.constraints.Size;

import org.hibernate.validator.constraints.NotBlank;


@Entity
@Table(name = "attributes")
@Inheritance(strategy = InheritanceType.JOINED)
public class Attribute implements java.io.Serializable {

	private static final long serialVersionUID = 1L;

	public enum EnumAttributeType {
		UNDEFINED, TABLES, COLUMNS, DATABASE,
	}

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "id")
	private int id;

	@NotBlank
	@Size(max = 45)
	private String name;

	public Attribute() {

	}
	
	public Attribute(Integer id) {
		this.id = id;
	}


	public Attribute(Integer id, String name) {
		this.id = id;
		this.name = name;
	}

	public Attribute(String name) {
		this.name = name;
	}


	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public EnumAttributeType getTypeAttribute() {
		return EnumAttributeType.UNDEFINED;
	}

	
	public Integer tableIDGet() {
		return -1;
	}
	

//	public String getFullName() {
//		return this.getName();
//	}
//
//	public void setFullName(String fullName) {
//		// Esto no deberia ser asi, pero cuando edito una metrica instanciada puede venir el
//		// attributeColumn null
//		this.setName(fullName);
//
//	}

//	/** 
//	 * @return el nombre de la tabla cuando no se ha casteado al tipo correspondiente
//	 */
//	public String getTableName() {
//		if (this.getFullName().split(" ").length > 1) {
//				return this.getFullName().split(" ")[1];
//		}
//		return this.name;
//	}

//	public void setTableName(String name) {
//
//	}

	/** 
	 * @return el nombre de la tabla cuando no se ha casteado al tipo correspondiente
//	 */
//	public String getColumnName() {
//		if (this.getFullName().split(" ").length > 0) {
//			return this.getFullName().split(" ")[0];
//	}
//	return this.name;
//	}

//	public void setColumnName(String name) {
//
//	}

	// Castea el attributo al tipo que corresponda
	/**
	 * @param database
	 *            Database obtenida de la base de datos
	 * @param databaseOriginal
	 *            Database obtenida de la base de datos original
	 * @param tableName
	 *            nombre de la tabla
	 * @param columnName
	 *            nombre de la columna
	 * @param attributeType
	 *            tipo de atributo
	 * @return
	 */
//	public Attribute getAttribute(AttributeDatabase database, AttributeDatabase databaseOriginal, InstancedMetric instancedMetric, EnumAttributeType attributeType) {
//		
//		// En la vista no pude hacer el bean con AttributeColumn por lo tanto en el
//		// nombre del atributo esta compuesto por nombreTabla + " " + nombreColumna
//		String columnName = "";
//		String tableName;
//
//		switch (instancedMetric.getMethod().getMetrics().getTypeAttribute()) {
//
//		case COLUMNS:
//
//			columnName = this.getFullName().split(" ")[1];
//			tableName = this.getFullName().split(" ")[0];
//			break;
//
//		case TABLES:
//			tableName = this.getName();
//			break;
//
//		default:
//			tableName = this.getName();
//			break;
//		}
//		
//		// Si selecciona la misma tabla varias se crea una sola y se asocia la misma
//		// tabla a varias columnas
//		AttributeTable attributeTable = database.findAttributesTable(tableName);
//
//		if (attributeTable.getId() == 0) {
//			attributeTable = new AttributeTable(0, tableName, database);
//		}
//
//		// Crea el atributo de la metrica instanciada
//		Attribute attribute;
//
//		switch (attributeType) {
//		case COLUMNS:
//
//			AttributeColumn attributeColumn = attributeTable.findAttributesColumn(columnName);
//
//			if (attributeColumn.getId() == 0) {
////				AttributeTable tableOriginal = (AttributeTable)databaseOriginal.getAttributesTable().stream()
////						.filter(a -> a.getName().equals(tableName)).toArray()[0];
//				
//				AttributeTable tableOriginal = databaseOriginal.findAttributesTable(tableName);
////				AttributeColumn columnOriginal = (AttributeColumn) tableOriginal.getAttributesColumns().stream()
////						.filter(a -> a.getName().equals(columnName)).toArray()[0];
//				AttributeColumn columnOriginal = tableOriginal.findAttributesColumn(columnName);
//				attributeColumn = new AttributeColumn(0, columnName, columnOriginal.getType(), attributeTable);
//			}
//			attribute = attributeColumn;
//			break;
//
//		case TABLES:
//
//			attribute = attributeTable;
//			break;
//
//		case DATABASE:
//			attribute = database;
//
//		default:
//			attribute = new Attribute();
//			break;
//		}
//
//		return attribute;
//	}

}
