package com.kiuplus.logic.model;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.PrimaryKeyJoinColumn;
import javax.persistence.Table;

@Entity
@Table(name = "attributes_table")
@PrimaryKeyJoinColumn(name = "idAttribute")
public class AttributeTable extends Attribute {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

//	@JsonIgnore
	@ManyToOne(optional = false, fetch = FetchType.EAGER)
	@JoinColumn(name = "idAttributeDatabase", insertable = true, updatable = true)
	private AttributeDatabase attributeDatabase;

	@OneToMany(targetEntity = AttributeColumn.class, fetch = FetchType.EAGER, orphanRemoval=true, cascade = CascadeType.ALL)
	@JoinColumn(name = "idAttributeTable", insertable = false, updatable = false)
	private List<AttributeColumn> attributesColumns;

	public AttributeTable(Integer id) {
		super(id);
		this.attributesColumns = new ArrayList<>();
		
	};
	
	public AttributeTable() {
		this.attributesColumns = new ArrayList<>();
	};

	// public AttributeTable(int id, String name, InstancedMetric instancedMetric,
	// ParameterAttribute parameterAttribute, AttributeDatabase attributeDatabase) {
	// super(id, name, instancedMetric, EnumAttributeType.TABLES, parameterAttribute);
	// this.attributeDatabase = attributeDatabase;
	// }

	// public AttributeTable(int id, String name, InstancedMetric instancedMetric, AttributeDatabase
	// attributeDatabase) {
	// super(id, name, instancedMetric, EnumAttributeType.TABLES);
	// this.attributeDatabase = attributeDatabase;
	// }

	public AttributeTable(Integer id, String name, AttributeDatabase attributeDatabase) {
		super(id, name);
		this.attributeDatabase = attributeDatabase;
		this.attributesColumns = new ArrayList<>();
	}
	
	public AttributeTable(String name, AttributeDatabase attributeDatabase) {
		super(name);
		this.attributeDatabase = attributeDatabase;
		this.attributesColumns = new ArrayList<>();
	}

	// public AttributeTable(int id, String name, InstancedMetric instancedMetric) {
	// super(id, name, instancedMetric, EnumAttributeType.TABLES);
	// //this.attributeDatabase = attributeDatabase;
	// }

	public AttributeTable(Integer id, String name) {
		super(id, name);
		this.attributesColumns = new ArrayList<>();
	}

	public AttributeDatabase getAttributeDatabase() {
		return attributeDatabase;
	}

	public void setAttributeDatabase(AttributeDatabase attributeDatabase) {
		this.attributeDatabase = attributeDatabase;
	}

	public List<AttributeColumn> getAttributesColumns() {
		return attributesColumns;
	}

	public void setAttributesColumns(List<AttributeColumn> attributesColumns) {
		this.attributesColumns = attributesColumns;
	}

	public EnumAttributeType getTypeAttribute() {
		return EnumAttributeType.TABLES;
	}

	public Integer databaseIDGet() {
		return this.attributeDatabase.getId();
	}
	
	public Integer tableIDGet() {
		return this.getId();
	}
	
//	public String getTableName() {
//		return this.getName();
//	}
//
//	public void setTableName(String name) {
//		this.setName(name);
//	}


	public AttributeColumn findAttributeColumn(String name) {

		for (AttributeColumn attributeColumn : this.attributesColumns) {
			if (attributeColumn.getName().equals(name)) {
				return attributeColumn;
			}
		}

		return null;
	}


}
