package com.kiuplus.logic.model;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.Size;

import org.hibernate.validator.constraints.NotBlank;

import com.fasterxml.jackson.annotation.JsonBackReference;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonManagedReference;

/**
 * Factor generated by hbm2java
 */
@Entity
@Table(name = "FACTORS")
public class Factor implements java.io.Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "ID")
	private int id;
	
	@Size(max=45)
	@NotBlank
	private String name;
	
	
	@OneToMany(targetEntity=Metrics.class,  cascade = CascadeType.ALL, fetch=FetchType.LAZY)
	@JoinColumn(name="idfactor", insertable = false, updatable = false)
	@JsonIgnore
	@JsonManagedReference
	private List<Metrics> metrics;

	
	
	@JsonBackReference 
	@ManyToOne(optional = false,  fetch=FetchType.EAGER)
	@JoinColumn(name = "iddimension")	
	private Dimension dimension;

	public Factor() {
		this.dimension = new Dimension();
		this.metrics = new ArrayList<Metrics>();
	}

	public Factor(int id, String name, List<Metrics> metrics, Dimension dimension) {
		this.id = id;
		this.name = name;
		this.metrics = metrics;
		this.dimension = dimension;
	}

	public Factor(int id, String name) {
		this.id = id;
		this.name = name;
		this.metrics = new ArrayList<Metrics>();
	}
	
	public Factor(Dimension dimension) {
		this.dimension = dimension;
		this.metrics = new ArrayList<Metrics>();
	}


	public int getId() {
		return this.id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getName() {
		return this.name;
	}

	public void setName(String name) {
		this.name = name;
	}


	public List<Metrics> getMetrics() {
		return this.metrics;
	}

	public void setMetrics(List<Metrics> metrics) {
		this.metrics = metrics;
	}


	public Dimension getDimension() {
		return dimension;
	}

	public void setDimension(Dimension dimension) {
		this.dimension = dimension;
	}

	@Override
	public boolean equals(Object object) {

		if (object == this)
			return true;
		Factor factor = (Factor) object;

		return factor.getId() == this.id && factor.getName().equals(this.name);

	}

	/** Busca la metrica del factor identificada con el id
	 * @param idMetrics
	 * @return 
	 */
	public Metrics getMetrics(int idMetrics){
		for(Metrics m : this.metrics){
			if(m.getId() == idMetrics){
				return m;
			}
		}
		return new Metrics();
	}
}
