package com.kiuplus.logic.model;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import org.hibernate.validator.constraints.NotBlank;

import com.fasterxml.jackson.annotation.JsonBackReference;
import com.fasterxml.jackson.annotation.JsonManagedReference;

/**
 * Methods generated by hbm2java
 */
@Entity
@Table(name = "methods")
public class Method implements java.io.Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "ID")
	private int id;

	@Size(max = 45)
	@NotBlank
	private String name;

	@Size(max = 1000)
	@NotBlank
	private String description;
	
	@JsonBackReference
	@ManyToOne(optional = false, fetch = FetchType.EAGER)
	@JoinColumn(name = "idMetrics")
	private Metrics metrics;

	//Evaluate
	@NotNull
	@OneToOne(targetEntity = Operation.class, cascade = CascadeType.ALL, fetch = FetchType.EAGER, orphanRemoval = true)
	@JoinColumn(name = "idOperationEvaluate")
	private Operation operation;

	
	@JsonManagedReference
	@OneToMany(targetEntity = InstancedMetric.class, fetch = FetchType.LAZY)
	@JoinColumn(name = "idMethod", insertable = false, updatable = false)
	private List<InstancedMetric> instancedMetrics;

	
//	@JsonBackReference
//	@OneToOne(targetEntity = Operation.class,  fetch = FetchType.LAZY,  optional = true)
//	@JoinColumn(name = "idOperationCleanWS")
//	private Operation operationCleanWS;
	
	public Method() {
		this.operation = new Operation();
		this.metrics = new Metrics();
		this.instancedMetrics = new ArrayList<>();
	}

//	public Method(int id, String name, Metrics metrics) {
//		this.id = id;
//		this.name = name;
//		this.metrics = metrics;
//		this.operation = new Operation();
//		this.instancedMetrics = new ArrayList<>();
//	}
//
//	public Method(int id, String name, Operation operation) {
//		this.id = id;
//		this.name = name;
//		this.operation = operation;
//		this.instancedMetrics = new ArrayList<>();
//	}
//
//	public Method(int id, String name) {
//		this.id = id;
//		this.name = name;
//		this.instancedMetrics = new ArrayList<>();
//	}
//
	public Method(Metrics metrics) {
		this.name = "";
		this.metrics = metrics;
		this.operation = new Operation();
//		this.operationCleanWS = new Operation();
		this.instancedMetrics = new ArrayList<>();
	}
//
//	public Method(int id, String name, Operation operation, Metrics metrics) {
//		this.id = id;
//		this.name = name;
//		this.operation = operation;
//		this.metrics = metrics;
//		this.instancedMetrics = new ArrayList<>();
//	}

	public int getId() {
		return this.id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getName() {
		return this.name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Metrics getMetrics() {
		return metrics;
	}

	public void setMetrics(Metrics metrics) {
		this.metrics = metrics;
	}

	public Operation getOperation() {
		return operation;
	}

	public void setOperation(Operation operation) {
		this.operation = operation;
	}

	public List<InstancedMetric> getInstancedMetrics() {
		return instancedMetrics;
	}

	public void setInstancedMetrics(List<InstancedMetric> instancedMetrics) {
		this.instancedMetrics = instancedMetrics;
	}
	
//	public Operation getOperationCleanWS() {
//		return operationCleanWS;
//	}
//
//	public void setOperationCleanWS(Operation operationCleanWS) {
//		this.operationCleanWS = operationCleanWS;
//	}

	
	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	@Override
	public boolean equals(Object object) {

		if (object == this)
			return true;
		Method method = (Method) object;

		return method.getId() == this.id && method.getName().equals(this.name);
	}
}
