package com.kiuplus.logic.model;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.PrimaryKeyJoinColumn;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

import org.hibernate.annotations.Cascade;
import org.hibernate.annotations.CascadeType;

import com.fasterxml.jackson.annotation.JsonManagedReference;

@Entity
@Table(name = "parameters_attribute")
@PrimaryKeyJoinColumn(name = "idParameterValue", referencedColumnName = "id")
public class ParameterAttribute extends ParameterValue {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	
	@JsonManagedReference
	@NotNull
	@Cascade({CascadeType.SAVE_UPDATE, CascadeType.REFRESH, CascadeType.DETACH,  CascadeType.MERGE}) // Se declara aca, porque si utilizamos el CascadeType.PERSIST y PERSIST.MERGE de jsp, hibernate no lo toma como SAVE_UPADATE, tendriamos que poner cascadeType.ALL y esto genera una inconsistencia cuando se modifica un MI y se utiliza una de las tablas que tenia asignada antes. 
	@ManyToOne(optional = false, fetch = FetchType.EAGER) 
	@JoinColumn(name = "idAttribute", insertable=true, updatable=true)
	private Attribute attribute;
	

	public ParameterAttribute(){
		super();
		this.attribute = new Attribute();
	}
	
	public ParameterAttribute(int id, Parameter parameter, Attribute attribute){
		super(id, parameter);
		this.attribute = attribute;
	}
	
	public ParameterAttribute(Attribute attribute){
		
		this.attribute = attribute;
	}
	
	public ParameterAttribute(int id,  Attribute attribute){
		super(id);
		this.attribute = attribute;
	}


	public Attribute getAttribute() {
		return attribute;
	}


	public void setAttribute(Attribute attribute) {
		this.attribute = attribute;
	}
	
	
	

	
	

}
