package com.kiuplus.logic.model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import com.fasterxml.jackson.annotation.JsonManagedReference;
import com.kiuplus.logic.model.Parameter.EnumParameterType;


@Entity
@Table(name = "parameters_values")
@Inheritance(strategy = InheritanceType.JOINED)
public class ParameterValue implements Serializable{

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "id")
	private int id;

	@JsonManagedReference
	@ManyToOne(optional = false, fetch = FetchType.EAGER)
	@JoinColumn(name = "idParameter", insertable = true, updatable = true)
	private Parameter parameter;
	
	
	@JsonManagedReference
	@ManyToOne(optional=true, fetch = FetchType.LAZY)
	@JoinColumn(name="idInstancedMetric", insertable=true, updatable=true)
	private InstancedMetric instancedMetric; // Parametro utilizado en el caso de la agregacion para determinar a cual parametro corresponde la metrica instanciada
	
	public ParameterValue() {
		this.parameter = new Parameter();
	}
	
	public ParameterValue(int id) {
		this.id = id;
		this.parameter = new Parameter();
	}
	
	public ParameterValue(int id, Parameter parameter) {
		this.id = id;
		this.parameter = parameter;
	}

	public ParameterValue(EnumParameterType enumParameterType) {
		this.parameter = new Parameter();
		this.parameter.setParameterType(enumParameterType);
	}
	
	public ParameterValue(EnumParameterType enumParameterType, InstancedMetric instancedMetric) {
		this.parameter = new Parameter();
		this.parameter.setParameterType(enumParameterType);
		this.instancedMetric = instancedMetric;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public Parameter getParameter() {
		return parameter;
	}

	public void setParameter(Parameter parameter) {
		this.parameter = parameter;
	}

	public InstancedMetric getInstancedMetric() {
		return instancedMetric;
	}

	public void setInstancedMetric(InstancedMetric instancedMetric) {
		this.instancedMetric = instancedMetric;
	}
	
	
}
