package com.kiuplus.logic.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import org.hibernate.validator.constraints.NotBlank;
import org.hibernate.validator.constraints.NotEmpty;

import com.fasterxml.jackson.annotation.JsonManagedReference;

@Entity
@Table(name = "web_services")
public class WebService implements Serializable {

	/**
		 * 
		 */
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "ID")
	private int id;

	//@Size(max = 2000)
	@NotBlank
	@NotEmpty
	private String url;

	private String targetNamespace;
	
	// Este campo no se serializa para/desde JSON, es para la pantalla Edit
	// method
	// @JsonIgnore
	private List<Operation> operations;

	public WebService() {
		this.operations = new ArrayList<>();
	}

	public WebService(int id, String url, String targetNamespace) {
		this.id = id;
		this.url = url;
		this.targetNamespace = targetNamespace;
		this.operations = new ArrayList<Operation>();
	}

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "ID")
	public int getId() {
		return this.id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getUrl() {
		return this.url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	
	public String getTargetNamespace() {
		return targetNamespace;
	}

	public void setTargetNamespace(String targetNamespace) {
		this.targetNamespace = targetNamespace;
	}

	@OneToMany(mappedBy = "webService", cascade = CascadeType.ALL, orphanRemoval = true, fetch = FetchType.EAGER) 
	@JsonManagedReference
	public List<Operation> getOperations() {
		return operations;
	}

	public void setOperations(List<Operation> operations) {
		this.operations = operations;
	}


}
