package com.kiuplus.configuration.logic.domain;

import java.util.List;

import com.kiuplus.logic.model.Dimension;



/**
 * @author Beatriz
 *
 */

public interface DimensionsDAO {

	
	/**
	 * @return Las dimensiones existentes en la base de datos.
	 */
	public List<Dimension> getAllDimensions();

	
	/** Almacena la dimension en la base de datos.
	 * @param dimension
	 * @return 
	 */
	public void dimensionAdd(Dimension dimension);

	/** Edita la dimension
	 * @param dimension
	 * @return Retorna la dimension editada
	 */
	public void dimensionUpdate(Dimension dimension);
	
	/** 
	 * @param id
	 * @return La dimension identificada con id, sin los factores.
	 */
	public Dimension dimensionFindById(int id);
	
	/** 
	 * @param id
	 * @return La dimension identificada con id, con los factores.
	 */
	public Dimension dimensionFindFullById(int id);
	
	/** 
	 * @param name
	 * @return La dimension con el nombre name.
	 */
	public  List<Dimension> findDimensionByName(String name);


	/** Elimina la dimension de la base de datos
	 * @param dimension
	 */
	public void dimensionDelete(Dimension dimension);
}
