package com.kiuplus.configuration.logic.domain;

import java.util.List;

import org.hibernate.Hibernate;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.query.Query;
import org.springframework.stereotype.Repository;

import com.kiuplus.logic.domain.HibernateUtils;
import com.kiuplus.logic.model.Dimension;

/**
 * @author Beatriz
 *
 */

@Repository
public class DimensionsDAOImpl implements DimensionsDAO {

	private SessionFactory sessionFactory;

	public DimensionsDAOImpl() {
		this.sessionFactory = (SessionFactory) HibernateUtils.getSessionFactory();
	}

	// public DimensionDAOImpl() {
	// this.sessionFactory = HibernateUtils.getSessionFactory();
	// }

	public void dimensionAdd(Dimension dimension) {

		Session session = sessionFactory.openSession();
		try {

			dimension.setId((int) session.save(dimension));

		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} finally {
			session.close();
		}
	}

	@SuppressWarnings("unchecked")
	public List<Dimension> getAllDimensions() {

		Session session = sessionFactory.openSession();
		try {
			Query<Dimension> query = session.createQuery("from " + Dimension.class.getName());

			List<Dimension> dimensions = query.getResultList();
			return dimensions;
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} finally {
			session.close();
		}

	}

	public void dimensionUpdate(Dimension dimension) {

		Session session = sessionFactory.openSession();

		try {
			session.beginTransaction();

			session.update(dimension);

			session.getTransaction().commit();
		} catch (Exception e) {
			e.printStackTrace();
			session.getTransaction().rollback();
			throw e;
		} finally {
			session.close();
		}
	}

	public Dimension dimensionFindById(int id) {

		Session session = sessionFactory.openSession();
		try {
			Dimension dimension = (Dimension) session.get(Dimension.class, id);
			
			return dimension;

		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} finally {
			session.close();
		}
	}

	public Dimension dimensionFindFullById(int id) {

		Session session = sessionFactory.openSession();
		try {
			Dimension dimension = (Dimension) session.get(Dimension.class, id);
			if (dimension != null) {
				Hibernate.initialize(dimension.getFactors());
			}
			return dimension;

		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} finally {
			session.close();
		}
	}

	@SuppressWarnings("unchecked")
	public List<Dimension> findDimensionByName(String name) {

		Session session = sessionFactory.openSession();
		try {
			Query<Dimension> query = session.createQuery("from " + Dimension.class.getName() + " where name= :name ");
			query.setParameter("name", name);
			List<Dimension> dimensions = query.getResultList();
			return dimensions;
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} finally {
			session.close();
		}
	}

	public void dimensionDelete(Dimension dimension) {

		Session session = sessionFactory.openSession();
		try {
			session.beginTransaction();
			session.delete(dimension);
			session.getTransaction().commit();
		} catch (Exception e) {
			e.printStackTrace();
			session.getTransaction().rollback();
			throw e;
		} finally {
			session.close();
		}

	}

}
