package com.kiuplus.configuration.logic.domain;

import java.util.List;

import com.kiuplus.logic.exception.ExceptionKiuPlus;
import com.kiuplus.logic.model.InstancedMetric;
import com.kiuplus.logic.model.Method;

public interface MethodsDAO {

	List<Method> methodsGetAll(int idMetric);

	List<Method> methodsFindByName(String name);

	
	/**
	 * @param id
	 * @return El metodo identificado con el id, sin las operaciones
	 */
	Method methodFindById(int id);

	/**
	 * @param id
	 * @return El metodo identificado con el id, con las operaciones
	 */
	Method methodFindFullById(int id);
	
	void methodAdd(Method method) throws ExceptionKiuPlus;

	void methodUpdate(Method method) throws ExceptionKiuPlus;

	void methodDelete(Method method);
	
	/** Obtiene las metricas instanciadas asociadas al metodo
	 * @param idMethod
	 * @return
	 */
	public List<InstancedMetric> instanedMetricsFind(int idMethod);
	

}
