package com.kiuplus.configuration.logic.domain;

import java.util.List;

import org.hibernate.Hibernate;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.query.Query;
import org.springframework.stereotype.Repository;

import com.kiuplus.logic.domain.HibernateUtils;
import com.kiuplus.logic.model.Metrics;

@Repository
public class MetricsDAOImpl implements MetricsDAO {

	private SessionFactory sessionFactory;

	public MetricsDAOImpl() {
		this.sessionFactory = (SessionFactory) HibernateUtils.getSessionFactory();
	}

	@SuppressWarnings("unchecked")
	public List<Metrics> metricsGetAll(int idFactor) {

		Session session = sessionFactory.openSession();
		try {
			Query<Metrics> query = session
					.createQuery("from " + Metrics.class.getName() + " where idFactor= :idFactor ");
			query.setParameter("idFactor", idFactor);

			List<Metrics> metricss = query.getResultList();

			return metricss;
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} finally {
			session.close();
		}
	}

	@SuppressWarnings("unchecked")
	public List<Metrics> metricsFindByName(String name) {

		Session session = sessionFactory.openSession();
		try {
			Query<Metrics> query = session.createQuery("from " + Metrics.class.getName() + " where name= :name ");
			query.setParameter("name", name);
			List<Metrics> dimensions = query.getResultList();

			return dimensions;
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} finally {
			session.close();
		}
	}

	public Metrics metricsFindById(int id) {

		Session session = sessionFactory.openSession();
		try {
			Metrics metrics = (Metrics) session.get(Metrics.class, id);

			return metrics;
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} finally {
			session.close();
		}
	}

	public Metrics metricsFindFullById(int id) {

		Session session = sessionFactory.openSession();
		try {
			Metrics metrics = (Metrics) session.get(Metrics.class, id);
			if(metrics != null)
				Hibernate.initialize(metrics.getMethods());

			return metrics;
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} finally {
			session.close();
		}
	}

	public void metricsAdd(Metrics metrics) {

		Session session = sessionFactory.openSession();
		try {
			session.beginTransaction();
			metrics.setId((int) session.save(metrics));

			session.getTransaction().commit();
		} catch (Exception e) {
			e.printStackTrace();
			session.getTransaction().rollback();
			throw e;
		} finally {
			session.close();
		}
	}

	public void metricsUpdate(Metrics metrics) {

		Session session = sessionFactory.openSession();
		try {
			session.beginTransaction();

			session.update(metrics);

			session.getTransaction().commit();
		} catch (Exception e) {
			e.printStackTrace();
			session.getTransaction().rollback();
			throw e;
		} finally {
			session.close();
		}
	}

	public void metricsDelete(Metrics metrics) {

		Session session = sessionFactory.openSession();
		try {
			session.beginTransaction();

			session.delete(metrics);

			session.getTransaction().commit();
		} catch (Exception e) {
			e.printStackTrace();
			session.getTransaction().rollback();
			throw e;
		} finally {
			session.close();
		}

	}

}
