package com.kiuplus.configuration.logic.service;



import java.util.List;

import com.kiuplus.logic.exception.ExceptionKiuPlus;
import com.kiuplus.logic.model.Dimension;




/**
 * @author Beatriz
 *
 */
public interface DimensionsService {

	
	/** 
	 * @return La lista de todas las dimensiones del sistema
	 */
	public List<Dimension> dimensionsGetAll();

	/** 
	 * @param idDataModel
	 * @return dimensiones que tienen asociadas metricas instanciadas
	 */
	public List<Dimension> dimensionsDataQualityModelGet(int idDataModel);
	
	/** Almacena la dimension
	 * @param dimension
	 * @throws ExceptionKiuPlus  si existe otra dimension con el mismo nombre
	 */
	public void dimensionCreate(Dimension dimension) throws ExceptionKiuPlus;

	/** Edita la dimension
	 * @param dimension
	 * @return Lanza una excepcion del tipo ExceptionKiuPlus si existe otra dimension con el mismo nombre
	 */
	public void dimensionUpdate(Dimension dimension) throws ExceptionKiuPlus;
	
	/**
	 * @param id
	 * @return La dimension identificada con el id sin los factores
	 */
	public Dimension dimensionGet(int id);

	
	/**
	 * @param id
	 * @return La dimension identificada con el id con los factores
	 */
	public Dimension dimensionFindFullDById(int id);
	
	/** Busca la dimension identificada con el nombre
	 * @return
	 */
	public List<Dimension> dimensionFindByName(String name);
	
	 /** Elimina la dimension de la base de datos
	 * @param id
	 * @throws ExceptionKiuPlus si no existe la dimension
	 */
	public void dimensionDelete(int id) throws ExceptionKiuPlus;

	
		


	
}
