package com.kiuplus.configuration.logic.service;

import java.util.List;

import com.kiuplus.logic.exception.ExceptionKiuPlus;
import com.kiuplus.logic.model.Factor;





public interface FactorsService {
	/** 
	 * @return La lista de todos los factores de la dimension identificado con el id
	 */
	public List<Factor> factorsGetAll(int idDimension);

	/**
	 * @param id
	 * @return El factor identificado con el id, sin las metricas
	 */
	public Factor factorGet(int id);
	
	/**
	 * @param id
	 * @return El factor identificado con el id, con las metricas
	 */
	public Factor factorGetFull(int id);

	/** Guarda el factor
	 * @param factor
	 * @throws ExceptionKiuPlus  si existe otro factor con el mismo nombre
	 */
	public void factorCreate(Factor factor) throws ExceptionKiuPlus;

	/** Edita el factor
	 * @param factor
	 * @return Lanza una excepcion del tipo ExceptionKiuPlus si existe otro factor con el mismo nombre
	 */
	public void factorUpdate(Factor factor) throws ExceptionKiuPlus;

	 /** Elimina el factor de la base de datos
		 * @param id
		 * @throws ExceptionKiuPlus si no existe el factor
		 */
	public Factor factorDelete(int id) throws ExceptionKiuPlus;
}
