package com.kiuplus.configuration.logic.service;

import java.util.List;

import com.kiuplus.logic.exception.ExceptionKiuPlus;
import com.kiuplus.logic.model.Method;




public interface MethodsService {
	/** 
	 * @return La lista de todos los metodos de la metrics identificada con el id
	 */
	public List<Method> methodsGetAll(int idMetrics);

	/**
	 * @param id
	 * @return Los metodos identificados con el id, sin las operaciones
	 */
	public Method methodGet(int id);
	
	/**
	 * @param id
	 * @return Los metodos identificados con el id, con las operaciones
	 */
	public Method methodGetFull(int id);
	
	/** Guarda el metodo
	 * @param method
	 * @throws ExceptionKiuPlus  si existe otro metodo con el mismo nombre
	 */
	public void methodCreate(Method method) throws ExceptionKiuPlus;

	/** Edita el metodo
	 * @param method
	 * @return Lanza una excepcion del tipo ExceptionKiuPlus si existe otra metodo con el mismo nombre
	 */
	public void methodUpdate(Method method) throws ExceptionKiuPlus;

	 /** Elimina el metodo de la base de datos
		 * @param id
		 * @throws ExceptionKiuPlus si no existe el metodo
		 */
	public Method methodDelete(int id) throws ExceptionKiuPlus;

	
}
