package com.kiuplus.configuration.logic.service;

import java.util.List;

import com.kiuplus.logic.exception.ExceptionKiuPlus;
import com.kiuplus.logic.model.Metrics;




public interface MetricsService {
	/** 
	 * @return La lista de todos los metricas del factor identificado con el id
	 */
	public List<Metrics> metricsGetAll(int idFactor);

	/**
	 * @param id
	 * @return Las metricas identificado con el id, sin los metodos
	 */
	public Metrics metricsGet(int id);
	
	/**
	 * @param id
	 * @return Las metrics identificadas con el id, con los metodos
	 */
	public Metrics metricsGetFull(int id);

	/** Guarda la metrica
	 * @param metrics
	 * @pre Existe el factor de la metrica
	 * @throws ExceptionKiuPlus  si existe otro metrica con el mismo nombre
	 */
	public void metricsCreate(Metrics metrics) throws ExceptionKiuPlus;

	/**
	 * Edita la metrica
	 * 
	 * @param metrics
	 * @return Lanza una excepcion del tipo ExceptionKiuPlus si existe otra metrica con el mismo
	 *         nombre
	 */
	public void metricsUpdate(Metrics metrics) throws ExceptionKiuPlus;

	 /** Elimina la metrica de la base de datos
		 * @param id
		 * @throws ExceptionKiuPlus si no existe la metrica
		 */
	public Metrics metricsDelete(int id) throws ExceptionKiuPlus;
}
