package com.kiuplus.webservices.dataquality;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.wsdl.BindingOperation;
import javax.wsdl.extensions.AttributeExtensible;

import org.apache.xmlbeans.XmlException;

import com.eviware.soapui.impl.WsdlInterfaceFactory;
import com.eviware.soapui.impl.wsdl.WsdlInterface;
import com.eviware.soapui.impl.wsdl.WsdlOperation;
import com.eviware.soapui.impl.wsdl.WsdlProject;
import com.eviware.soapui.support.SoapUIException;
import com.kiuplus.logic.model.Operation;
import com.kiuplus.logic.model.Parameter;
import com.predic8.schema.Appinfo;
import com.predic8.schema.Attribute;
import com.predic8.schema.ComplexContent;
import com.predic8.schema.ComplexType;
import com.predic8.schema.Derivation;
import com.predic8.schema.Documentation;
import com.predic8.schema.Import;
import com.predic8.schema.Include;
import com.predic8.schema.ModelGroup;
import com.predic8.schema.Schema;
import com.predic8.schema.SchemaComponent;
import com.predic8.schema.Sequence;
import com.predic8.schema.SimpleType;
import com.predic8.soamodel.XMLElement;
import com.predic8.wsdl.AbstractSOAPBinding;
import com.predic8.wsdl.Binding;
import com.predic8.wsdl.Definitions;
import com.predic8.wsdl.Fault;
import com.predic8.wsdl.Message;
import com.predic8.wsdl.Part;
import com.predic8.wsdl.Port;
import com.predic8.wsdl.PortType;
import com.predic8.wsdl.Service;
import com.predic8.wsdl.WSDLParser;

public class WebServiceDQPruebas {
///Se utiliza predict 8
	
	/**
	 * Obtiene la operacion con los nombres de los parametros Las operaciones ni
	 * los parametros no tienen ids.
	 * 
	 * @param url
	 *            del web service, de la forma
	 *            http://www.webservice.com/nombre.asmx?WSDL
	 * @return
	 * @throws Exception
	 */
	public List<Operation> operationsGet(String url) throws Exception {
		List<Operation> operations = new ArrayList<Operation>();
		try {

			// Obtener el wsdl
			WsdlProject project = new WsdlProject();

			WsdlInterface iface;

			iface = WsdlInterfaceFactory.importWsdl(project, url, false)[0];

			// Obtener las operaciones
			WsdlOperation operacion;

			for (int i = 0; i < iface.getOperationCount(); i++) {
				operacion = (WsdlOperation) iface.getOperationAt(i);

				Operation operation = new Operation();
				if (operacion != null) {
					operation.setName(operacion.getName());
					operation.setParameters(this.parametersGet(operacion));
					operations.add(operation);

				}
			}

		} catch (SoapUIException e) {
			// e.printStackTrace();
			throw new Exception(e.getStackTrace().toString());

		} catch (XmlException e) {
			// e.printStackTrace();
			throw new Exception(e.getStackTrace().toString());
		} catch (IOException e) {
			// e.printStackTrace();
			throw new Exception(e.getStackTrace().toString());
		}
		return operations;
	}

	/**
	 * Obtiene los parametros de la operacion Los parametros no tienen id
	 * 
	 * @param wsdlOperation
	 * @return Parametros de wsdlOperation
	 */
	@SuppressWarnings("unchecked")
	public List<Parameter> parametersGet(WsdlOperation wsdlOperation) {
		List<Parameter> parameters = new ArrayList<Parameter>();
		try {
			BindingOperation request = wsdlOperation.getBindingOperation();

			List<AttributeExtensible> attributes = request.getNativeAttributeNames();
		

			for (int i = 0; i < attributes.size(); i++) {
				parameters.add(new Parameter(0, attributes.get(i).toString(), null, null));
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return parameters;

	}

	// Funciona, es una prueba
	public List<Operation> operationsGetPredic8(String url) {
		List<Operation> operations = new ArrayList<Operation>();

		WSDLParser parser = new WSDLParser();
		
		Definitions defs = parser.parse(url);
		List<Schema> schemas = defs.getSchemas();
		for (Schema schema : schemas) {
			try {
				out("-------------- Schema Information --------------");
				out("  Schema TargetNamespace: " + schema.getTargetNamespace());
				out("  AttributeFormDefault: " + schema.getAttributeFormDefault());
				out("  ElementFormDefault: " + schema.getElementFormDefault());
				out("");

				if (schema.getImports().size() > 0) {
					out(" Schema Imports: ");
					for (Import imp : schema.getImports()) {
						out(" Import Namespace: " + imp.getNamespace());
						out(" Import Location: " + imp.getSchemaLocation());
					}
					out("");
				}

				if (schema.getIncludes().size() > 0) {
					out(" Schema Includes: ");
					for (Include inc : schema.getIncludes()) {
						out(" Include Location: " + inc.getSchemaLocation());
					}
					out("");
				}

				out("  Schema Elements: ");
				for (com.predic8.schema.Element e : schema.getAllElements()) {
					out("    Element Name: " + e.getName());
					ComplexType complexType = (ComplexType) e.getEmbeddedType();
					out("    Embedded type: " + complexType);
					if (complexType != null) {
						Sequence sequence = complexType.getSequence();
						for (com.predic8.schema.Element el : sequence.getElements()) {
							System.out.println("    " + el.getName() + " (" + el.getBuildInTypeName() + ")");
						}
					}
					if (e.getType() != null) {
						/*
						 * schema.getType() delivers a TypeDefinition
						 * (SimpleType orComplexType) object.
						 */
						out("    Element Type Name: " + schema.getType(e.getType()).getName());
						out("    Element minoccurs: " + e.getMinOccurs());
						out("    Element maxoccurs: " + e.getMaxOccurs());
						if (e.getAnnotation() != null)
							annotationOut(e);
					}
				}
				out("");

				out(" Schema ComplexTypes: ");
				for (ComplexType ct : schema.getComplexTypes()) {
					out(" ComplexType Name: " + ct.getName());
					if (ct.getAnnotation() != null)
						annotationOut(ct);
					if (ct.getAttributes().size() > 0) {
						out(" ComplexType Attributes: ");
						/*
						 * If available, attributeGroup could be read as same as
						 * attribute in the following.
						 */
						for (Attribute attr : ct.getAttributes()) {
							out(" Attribute Name: " + attr.getName());
							out(" Attribute Form: " + attr.getForm());
							out(" Attribute ID: " + attr.getId());
							out(" Attribute Use: " + attr.getUse());
							out(" Attribute FixedValue: " + attr.getFixedValue());
							out(" Attribute DefaultValue: " + attr.getDefaultValue());
						}
					}
					/*
					 * ct.getModel() delivers the child element used in
					 * complexType. In case of 'sequence' you can also use the
					 * getSequence() method.
					 */
					out(" ComplexType Model: " + ct.getModel().getClass().getSimpleName());
					if (ct.getModel() instanceof ModelGroup) {
						out(" Model Particles: ");
						for (SchemaComponent sc : ((ModelGroup) ct.getModel()).getParticles()) {
							out(" Particle Kind: " + sc.getClass().getSimpleName());
							out(" Particle Name: " + sc.getName() + "\n");
						}
					}

					if (ct.getModel() instanceof ComplexContent) {
						Derivation der = ((ComplexContent) ct.getModel()).getDerivation();
						out(" ComplexConten Derivation: " + der.getClass().getSimpleName());
						out(" Derivation Base: " + der.getBase());
					}

					if (ct.getAbstractAttr() != null)
						out(" ComplexType AbstractAttribute: " + ct.getAbstractAttr());
					if (ct.getAnyAttribute() != null)
						out(" ComplexType AnyAttribute: " + ct.getAnyAttribute());

					out("");
				}

				if (schema.getSimpleTypes().size() > 0) {
					out(" Schema SimpleTypes: ");
					for (SimpleType st : schema.getSimpleTypes()) {
						out(" SimpleType Name: " + st.getName());
						out(" SimpleType Restriction: " + st.getRestriction());
						out(" SimpleType Union: " + st.getUnion());
						out(" SimpleType List: " + st.getList());
					}
				}
			} catch (Exception e) {
				// TODO: handle exception
			}
		}
		return operations;

	}

	// tiene que ir: private void getElement(Schema schema,
	// com.predic8.schema.Element e){
	private void getElement(com.predic8.schema.Element e) {
		out("    Element Name: " + e.getName());
		ComplexType complexType = (ComplexType) e.getEmbeddedType();
		out("    Embedded type: " + complexType);
		Sequence sequence = complexType.getSequence();
		for (com.predic8.schema.Element el : sequence.getElements()) {
			System.out.println("    " + el.getName() + " (" + el.getBuildInTypeName() + ")");
		}

		if (e.getType() != null) {
			/*
			 * schema.getType() delivers a TypeDefinition (SimpleType
			 * orComplexType) object.
			 */
			// out(" Element Type Name: " +
			// schema.getType(e.getType()).getName());
			out("    Element minoccurs: " + e.getMinOccurs());
			out("    Element maxoccurs: " + e.getMaxOccurs());
			if (e.getAnnotation() != null)
				annotationOut(e);
		}
	}

	private static void annotationOut(SchemaComponent sc) {
		if (sc.getAnnotation().getAppinfos().size() > 0) {
			System.out.print("    Annotation (appinfos) available with the content: ");
			for (Appinfo appinfo : sc.getAnnotation().getAppinfos()) {
				out(appinfo.getContent());
			}
		} else {
			System.out.print("    Annotation (documentation) available with the content: ");
			for (Documentation doc : sc.getAnnotation().getDocumentations()) {
				out(doc.getContent());
			}
		}
	}

	private static void out(String str) {
		System.out.println(str);
	}

	public List<Parameter> parametersGetPredic8(com.predic8.wsdl.Operation operation) {

		XMLElement xml = operation.getParent();
		System.out.println(xml);
		return new ArrayList<Parameter>();
	}

	public List<Operation> operationsGetPredic8V2(String url) {
		List<Operation> operations = new ArrayList<Operation>();
		WSDLParser parser = new WSDLParser();

		// Definitions defs =
		// parser.parse("http://www.thomas-bayer.com/axis2/services/BLZService?wsdl");
		Definitions defs = parser.parse(url);
		// out("-------------- WSDL Details --------------");
		// out("TargenNamespace: \t" + defs.getTargetNamespace());
		// // out("Style: \t\t\t" + defs.getStyle());
		// if (defs.getDocumentation() != null) {
		// out("Documentation: \t\t" + defs.getDocumentation());
		// }
		// out("\n");
		//
		// /*
		// * For detailed schema information see the FullSchemaParser.java
		// sample.
		// */
		// out("Schemas: ");
		// for (Schema schema : defs.getSchemas()) {
		// out(" TargetNamespace: \t" + schema.getTargetNamespace());
		// }
		// out("\n");
		//
		// out("Messages: ");
		// for (Message msg : defs.getMessages()) {
		// out(" Message Name: " + msg.getName());
		// out(" Message Parts: ");
		// for (Part part : msg.getParts()) {
		// out(" Part Name: " + part.getName());
		// out(" Part Element: " + ((part.getElement() != null) ?
		// part.getElement() : "not available!"));
		// out(" Part Type: " + ((part.getType() != null) ? part.getType() :
		// "not available!"));
		// out("");
		// }
		// }
		// out("");

		// out("PortTypes: ");
		// for (PortType pt : defs.getPortTypes()) {
		// if (pt.getName().contains("GlobalWeather")) {
		//
		// out(" PortType Name: " + pt.getName());
		// out(" PortType Operations: ");
		// for (com.predic8.wsdl.Operation op : pt.getOperations()) {
		// if (op.getName().contains("GetWeather")) {
		// out(" Operation Name: " + op.getName());
		// out(" Operation Input Name: "
		// + ((op.getInput().getName() != null) ? op.getInput().getName() : "not
		// available!"));
		// out(" Operation Input Message: " +
		// op.getInput().getMessage().getQname());
		//
		// // ********Mensaje input********//
		// out(" Message Name: " + op.getInput().getMessage().getName());
		// out(" Message Parts: ");
		// for (Part part : op.getInput().getMessage().getParts()) {
		// out(" Part Name: " + part.getName());
		// out(" Part Element: "
		// + ((part.getElement() != null) ? part.getElement() : "not
		// available!"));
		// out(" Part Type: " + ((part.getType() != null) ? part.getType() :
		// "not available!"));
		// out("");
		// }
		//
		// out(" Operation Output Name: "
		// + ((op.getOutput().getName() != null) ? op.getOutput().getName() :
		// "not available!"));
		// out(" Operation Output Message: " +
		// op.getOutput().getMessage().getQname());
		// out(" Operation Faults: ");
		// if (op.getFaults().size() > 0) {
		// for (Fault fault : op.getFaults()) {
		// out(" Fault Name: " + fault.getName());
		// out(" Fault Message: " + fault.getMessage().getQname());
		// }
		// } else
		// out(" There are no faults available!");
		// }
		// }
		// out("");
		// }
		// }
		// out("");

		out("Bindings: ");
		for (Binding bnd : defs.getBindings()) {

			if (bnd.getBinding().getProtocol().equals("SOAP12")) {
				out(" Binding Name: " + bnd.getName());
				out(" Binding Type: " + bnd.getPortType().getName());
				out(" Binding Protocol: " + bnd.getBinding().getProtocol());
				for (PortType pt : defs.getPortTypes()) {
					if (pt.getName().equals(bnd.getPortType().getName())) {
						out("  PortType Name: " + pt.getName());
						out("  PortType Operations: ");
						for (com.predic8.wsdl.Operation op : pt.getOperations()) {
							if (op.getName().contains("GetWeather")) {
								out("    Operation Name: " + op.getName());
								out("    Operation Input Name: " + ((op.getInput().getName() != null)
										? op.getInput().getName() : "not available!"));
								out("    Operation Input Message: " + op.getInput().getMessage().getQname());

								// ********Mensaje input********//
								out("      Message Name: " + op.getInput().getMessage().getName());
								out("      Message Parts: ");
								for (Part part : op.getInput().getMessage().getParts()) {
									out("        Part Name: " + part.getName());
									out("        Part Element: "
											+ ((part.getElement() != null) ? part.getElement() : "not available!"));
									if (part.getElement() != null) {

										this.getElement(part.getElement());
									}
									out("        Part Type: "
											+ ((part.getType() != null) ? part.getType() : "not available!"));
									out("");
								}

								out("    Operation Output Name: " + ((op.getOutput().getName() != null)
										? op.getOutput().getName() : "not available!"));
								out("    Operation Output Message: " + op.getOutput().getMessage().getQname());
								out("    Operation Faults: ");
								if (op.getFaults().size() > 0) {
									for (Fault fault : op.getFaults()) {
										out("      Fault Name: " + fault.getName());
										out("      Fault Message: " + fault.getMessage().getQname());
									}
								} else
									out("      There are no faults available!");
							}
						}
					}
					out("");

				}
				out("");

			}

			// if (bnd.getBinding() instanceof AbstractSOAPBinding)
			// out(" Style: " + (((AbstractSOAPBinding)
			// bnd.getBinding()).getStyle()));
			// out(" Binding Operations: ");
			//

			//// *********Retorna si esta codificado el body************////
			// for (com.predic8.wsdl.BindingOperation bop :
			// bnd.getOperations()) {
			// out(" Operation Name: " + bop.getName());
			// if (bnd.getBinding() instanceof AbstractSOAPBinding) {
			// out(" Operation SoapAction: " +
			// bop.getOperation().getSoapAction());
			// out(" SOAP Body Use: " +
			// bop.getInput().getBindingElements().get(0).getUse());
			// }
			//
			// }

			///////// *********************************************//////
			out("");

		}
		out("");
		//
		// out("Services: ");
		// for (Service service : defs.getServices()) {
		// out(" Service Name: " + service.getName());
		// out(" Service Potrs: ");
		// for (Port port : service.getPorts()) {
		// out(" Port Name: " + port.getName());
		// out(" Port Binding: " + port.getBinding().getName());
		// out(" Port Address Location: " + port.getAddress().getLocation() +
		// "\n");
		// }
		// }

		out("");
		return operations;
	}

	public void original(String url) {
		WSDLParser parser = new WSDLParser();

		Definitions defs = parser.parse(url);

		out("-------------- WSDL Details --------------");
		out("TargenNamespace: \t" + defs.getTargetNamespace());
		// out("Style: \t\t\t" + defs.getStyle());
		if (defs.getDocumentation() != null) {
			out("Documentation: \t\t" + defs.getDocumentation());
		}
		out("\n");

		/*
		 * For detailed schema information see the FullSchemaParser.java sample.
		 */
		out("Schemas: ");
		for (Schema schema : defs.getSchemas()) {
			out("  TargetNamespace: \t" + schema.getTargetNamespace());
		}
		out("\n");

		out("Messages: ");
		for (Message msg : defs.getMessages()) {
			out("  Message Name: " + msg.getName());
			out("  Message Parts: ");
			for (Part part : msg.getParts()) {
				out("    Part Name: " + part.getName());
				out("    Part Element: " + ((part.getElement() != null) ? part.getElement() : "not available!"));
				out("    Part Type: " + ((part.getType() != null) ? part.getType() : "not available!"));
				out("");
			}
		}
		out("");

		out("PortTypes: ");
		for (PortType pt : defs.getPortTypes()) {
			out("  PortType Name: " + pt.getName());
			out("  PortType Operations: ");
			for (com.predic8.wsdl.Operation op : pt.getOperations()) {
				out("    Operation Name: " + op.getName());
				out("    Operation Input Name: "
						+ ((op.getInput().getName() != null) ? op.getInput().getName() : "not available!"));
				out("    Operation Input Message: " + op.getInput().getMessage().getQname());
				out("    Operation Output Name: "
						+ ((op.getOutput().getName() != null) ? op.getOutput().getName() : "not available!"));
				out("    Operation Output Message: " + op.getOutput().getMessage().getQname());
				out("    Operation Faults: ");
				if (op.getFaults().size() > 0) {
					for (Fault fault : op.getFaults()) {
						out("      Fault Name: " + fault.getName());
						out("      Fault Message: " + fault.getMessage().getQname());
					}
				} else
					out("      There are no faults available!");

			}
			out("");
		}
		out("");

		out("Bindings: ");
		for (Binding bnd : defs.getBindings()) {
			out("  Binding Name: " + bnd.getName());
			out("  Binding Type: " + bnd.getPortType().getName());
			out("  Binding Protocol: " + bnd.getBinding().getProtocol());
			if (bnd.getBinding() instanceof AbstractSOAPBinding)
				out("  Style: " + (((AbstractSOAPBinding) bnd.getBinding()).getStyle()));
			out("  Binding Operations: ");
			for (com.predic8.wsdl.BindingOperation bop : bnd.getOperations()) {
				out("    Operation Name: " + bop.getName());
				if (bnd.getBinding() instanceof AbstractSOAPBinding) {
					out("    Operation SoapAction: " + bop.getOperation().getSoapAction());
					out("    SOAP Body Use: " + bop.getInput().getBindingElements().get(0).getUse());
				}
			}
			out("");
		}
		out("");

		out("Services: ");
		for (Service service : defs.getServices()) {
			out("  Service Name: " + service.getName());
			out("  Service Potrs: ");
			for (Port port : service.getPorts()) {
				out("    Port Name: " + port.getName());
				out("    Port Binding: " + port.getBinding().getName());
				out("    Port Address Location: " + port.getAddress().getLocation() + "\n");
			}
		}
		out("");
	}

}