package com.kiuplus.webservices.dataquality;

import java.util.ArrayList;
import java.util.List;

import org.springframework.stereotype.Service;

import com.kiuplus.logic.exception.ExceptionKiuPlus;
import com.kiuplus.logic.model.Operation;
import com.kiuplus.logic.model.Parameter;
import com.kiuplus.logic.model.Parameter.EnumDataType;
import com.kiuplus.logic.model.WebService;
import com.predic8.schema.ComplexType;
import com.predic8.schema.Schema;
import com.predic8.schema.Sequence;
import com.predic8.wsdl.Binding;
import com.predic8.wsdl.Definitions;
import com.predic8.wsdl.Part;
import com.predic8.wsdl.PortType;
import com.predic8.wsdl.WSDLParser;

@Service
public class WebServiceServiceImpl implements WebServiceService {

	// Esto funciona, es el original
	// http://www.membrane-soa.org/soa-model-doc/1.4/java-api/parse-schema-java-api.htm
	// public List<Operation> operationsGetPredic8V2(String url) {
	// List<Operation> operations = new ArrayList<Operation>();
	// WSDLParser parser = new WSDLParser();
	//
	// Definitions defs = parser.parse(url);
	//
	// out("Bindings: ");
	// for (Binding bnd : defs.getBindings()) {
	//
	// if (bnd.getBinding().getProtocol().equals("SOAP12")) {
	// out(" Binding Name: " + bnd.getName());
	// out(" Binding Type: " + bnd.getPortType().getName());
	// out(" Binding Protocol: " + bnd.getBinding().getProtocol());
	// for (PortType pt : defs.getPortTypes()) {
	// if (pt.getName().equals(bnd.getPortType().getName())) {
	// out(" PortType Name: " + pt.getName());
	// out(" PortType Operations: ");
	// for (com.predic8.wsdl.Operation op : pt.getOperations()) {
	//
	// out(" Operation Name: " + op.getName());
	// out(" Operation Input Name: "
	// + ((op.getInput().getName() != null) ? op.getInput().getName() : "not
	// available!"));
	// out(" Operation Input Message: " +
	// op.getInput().getMessage().getQname());
	//
	// // ********Mensaje input********//
	// out(" Message Name: " + op.getInput().getMessage().getName());
	// out(" Message Parts: ");
	// for (Part part : op.getInput().getMessage().getParts()) {
	// out(" Part Name: " + part.getName());
	// out(" Part Element: "
	// + ((part.getElement() != null) ? part.getElement() : "not available!"));
	// if (part.getElement() != null) {
	//
	// this.getElement(part.getElement());
	// }
	// out(" Part Type: "
	// + ((part.getType() != null) ? part.getType() : "not available!"));
	// out("");
	// }
	//
	// out(" Operation Output Name: " + ((op.getOutput().getName() != null)
	// ? op.getOutput().getName() : "not available!"));
	// out(" Operation Output Message: " +
	// op.getOutput().getMessage().getQname());
	// out(" Operation Faults: ");
	// if (op.getFaults().size() > 0) {
	// for (Fault fault : op.getFaults()) {
	// out(" Fault Name: " + fault.getName());
	// out(" Fault Message: " + fault.getMessage().getQname());
	// }
	// } else
	// out(" There are no faults available!");
	//
	// }
	// }
	// out("");
	//
	// }
	// out("");
	//
	// }
	// }
	//
	// return operations;
	// }

	// private void getElement(com.predic8.schema.Element e) {
	// out(" Element Name: " + e.getName());
	// ComplexType complexType = (ComplexType) e.getEmbeddedType();
	// out(" Embedded type: " + complexType);
	// Sequence sequence = complexType.getSequence();
	// for (com.predic8.schema.Element el : sequence.getElements()) {
	// System.out.println(" " + el.getName() + " (" + el.getBuildInTypeName() +
	// ")");
	// }
	//
	// if (e.getType() != null) {
	// out(" Element minoccurs: " + e.getMinOccurs());
	// out(" Element maxoccurs: " + e.getMaxOccurs());
	// if (e.getAnnotation() != null)
	// annotationOut(e);
	// }
	// }

	// private static void annotationOut(SchemaComponent sc) {
	// if (sc.getAnnotation().getAppinfos().size() > 0) {
	// System.out.print(" Annotation (appinfos) available with the content: ");
	// for (Appinfo appinfo : sc.getAnnotation().getAppinfos()) {
	// out(appinfo.getContent());
	// }
	// } else {
	// System.out.print(" Annotation (documentation) available with the content:
	// ");
	// for (Documentation doc : sc.getAnnotation().getDocumentations()) {
	// out(doc.getContent());
	// }
	// }
	// }
	//
	// private static void out(String str) {
	// System.out.println(str);
	// }

	public List<Operation> operationsGet(String url) throws Exception {
		try {
			List<Operation> operations = new ArrayList<Operation>();

			WSDLParser parser = new WSDLParser();
			Definitions defs = parser.parse(url);

			String targetNamespace = defs.getTargetNamespace();
			for (Binding bnd : defs.getBindings()) {

				if (bnd.getBinding().getProtocol().equals("SOAP12")
						|| bnd.getBinding().getProtocol().equals("SOAP11")) {
					for (PortType pt : defs.getPortTypes()) {
						if (pt.getName().equals(bnd.getPortType().getName())) {

							Operation operationDQ;
							for (com.predic8.wsdl.Operation op : pt.getOperations()) {
								operationDQ = new Operation();
								operationDQ.setWebService(new WebService(0, url, targetNamespace));
								operationDQ.setName(op.getName());

								// Parameter input
								if (op.getInput() != null && op.getInput().getMessage() != null) {
									for (Part part : op.getInput().getMessage().getParts()) {
										if (part.getElement() != null) {

											operationDQ.setParameters(this.getParameters(defs, part.getElement()));
										}
									}
								} else {
									throw new ExceptionKiuPlus("Unable to get input parameters");
								}

								if (op.getOutput() != null && op.getOutput().getMessage() != null) {
									// Parameter output
									for (Part part : op.getOutput().getMessage().getParts()) {
										if (part.getElement() != null) {
											List<Parameter> parameters = this.getParameters(defs, part.getElement());
											if (parameters.size() > 0) {
												operationDQ.setDataTypeReturn(parameters.get(0).getDataType());
											}
										}
									}
								} else {
									throw new ExceptionKiuPlus("Unable to get output parameters");
								}

								operations.add(operationDQ);
							}

						}
					}
					break;
				}
			}
			return operations;
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}

	}

	private List<Parameter> getParameters(Definitions defs, com.predic8.schema.Element e) throws ExceptionKiuPlus {
		List<Parameter> parameters = new ArrayList<Parameter>();
		if (e != null) {
			ComplexType complexType = (ComplexType) e.getEmbeddedType();
			if (complexType != null) {
				Sequence sequence = complexType.getSequence();
				if (sequence != null) {
					Parameter parameter;
					for (com.predic8.schema.Element el : sequence.getElements()) {

						parameter = new Parameter();
						parameter.setName(el.getName());
						if (el.getBuildInTypeName() != null) {
							parameter.setDataType(EnumDataType.fromString(el.getBuildInTypeName()));
						} else {
							parameters = this.getComplexTypes(defs, el);
						}
						parameters.add(parameter);
					}
				}
			} else {

				parameters = this.getComplexTypes(defs, e);

			}
		}
		return parameters;
	}

	private List<Parameter> getComplexTypes(Definitions defs, com.predic8.schema.Element element)
			throws ExceptionKiuPlus {

		List<Parameter> parameters = new ArrayList<>();
		List<Schema> schemas = defs.getSchemas();
		for (Schema schema : schemas) {
			try {

				for (ComplexType complexType : schema.getComplexTypes()) {

					if (complexType.getName().equals(element.getType().getLocalPart())) {

						Sequence sequence = complexType.getSequence();
						if (sequence != null) {
							Parameter parameter;
							for (com.predic8.schema.Element el : sequence.getElements()) {

								parameter = new Parameter();
								parameter.setName(el.getName());
								parameter.setDataType(EnumDataType.fromString(el.getBuildInTypeName()));
								
								parameters.add(parameter);
							}
						}

					}
				}

			} catch (Exception e) {
				if (e.getClass().equals(ExceptionKiuPlus.class)) {
					throw (ExceptionKiuPlus) e;
				}
			}

		}

		return parameters;
	}

}
