package KiuPlusLogicExecution.KiuPlusLogicExecution;

import java.net.MalformedURLException;
import java.net.*;
import java.util.ArrayList;
import java.util.Dictionary;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.xml.rpc.ServiceException;
import javax.xml.namespace.QName;
import javax.xml.soap.*;//TO DO: revisar si para invocar soap12 que cambio hay que hacer

import com.kiuplus.logic.model.*;
import com.kiuplus.logic.model.Attribute.EnumAttributeType;
import com.kiuplus.logic.model.AttributeDatabase.EnumDatabaseSystem;
import com.kiuplus.logic.model.Metrics.EnumGranularity;
import com.kiuplus.logic.model.Parameter.EnumParameterType;
import com.kiuplus.logic.objects.*;


/**
 * Hello world!
 *
 */

public class App 
{
    public static void main( String[] args )
    {
        System.out.println( "Hello World!" );
    }
    
    public static void Execute (DataModel dm, List<InstancedMetric> imList){
    	try
    	{
	    	String schemaName = "world";
	    	//TO DO: Chequear si hay resultados para las metricas a ejecutar --> en caso de que haya hay que resumir
	    	//TO DO: Copiar lo datos a ser evaluados
	    	Schema schemaToCopy = getSchemaToCopy(imList);
	    	AttributeDatabase adb = dm.getDatabaseSource();
			DataAccessBORRAR _dataAccess;
			//Inicio el DataAcces que voy a utilizar para obtener los datos a evaluar
			switch (adb.getSystem()){
			case MySQL:
				_dataAccess = new MySQLDataAccessBORRAR(adb.getUrl(), adb.getUser(), adb.getPassword());
				break;
			case PostgreSQL:
				_dataAccess = new DataAccessBORRAR(adb.getUrl(), adb.getUser(), adb.getPassword());
				break;
			default:
				_dataAccess = new DataAccessBORRAR(adb.getUrl(), adb.getUser(), adb.getPassword());
				break;
			}
			
			//Me conecto a la base de datos que voy a consultar los datos
			_dataAccess.connect();
			List<GenericObject> attributesList = _dataAccess.getPKandAttributsList(schemaName, schemaToCopy);
			
			//Me conecto a la base de datos donde voy a guardar los resultados
			String resultDB = "jdbc:mysql://localhost:3306/world";
  			String resultDBUser = "root";
  			String resultDBPassword = "Sertec01";
  			String resultSchemaName = "MetaDataDataBase_" + dm.getId();
			DataAccessBORRAR dataAccesslMetadata = new MySQLDataAccessBORRAR(resultDB, resultDBUser, resultDBPassword);
  			dataAccesslMetadata.connect();
			
			//Obtengo los valores a copiar
			schemaToCopy.getTableNames().forEach((tableName) -> {
				List<String> attributesStringList = _dataAccess.getAttributeStringList(tableName, attributesList);
				dataAccesslMetadata.createDataTable(tableName, attributesList);
				List<GenericObject> toCopy = _dataAccess.getValues(tableName, attributesStringList);
				toCopy.forEach(valueToCopy -> {
					dataAccesslMetadata.save(attributesStringList, valueToCopy, tableName);
				});
			});
  			
  			//Me desconecto de la BD a evaluar
  			_dataAccess.disconnect();
  			
	    	//TO DO: Ejecutar cada una de las metricas
  			imList.forEach(im -> {
  				String tableName = "";
  				List<String> attributeStringList =  new ArrayList<String>();
  				Map<String, String> attributeParameters = new HashMap<String, String>();
  				//Creo la tabla donde se van a guardar los resultados de la im
  				dataAccesslMetadata.createResultTable(im.getId(), im.getMethod().getOperation().getDataTypeReturn().getText());
  				
  				//Obtengo los parametros que son referenciales
  				List<Reference> referencedParameterList = (List<Reference>) im.getParameterValues().stream().filter(p -> p.getClass().equals(Reference.class));
  				List<GenericObject> referencedParameters = new ArrayList<GenericObject> ();
  				for (Reference r : referencedParameterList){
  					attributeParameters.put(r.getParameter().getName(), r.getParameter().getName());
  					GenericObject go = new GenericObject();
  					go.setProperty(r.getParameter().getName(), r.getReferenceValue());
  					referencedParameters.add(go);  					
  				}
  				
  				//Obtengo los parametros que son de Base de datos
  				List<ParameterAttribute> parameterAttributes = (List<ParameterAttribute>) im.getParameterValues().stream().filter(p -> p.getClass().equals(ParameterAttribute.class));
  				
  				//Depende de la granularidad de la metrica
  				switch (im.getMethod().getMetrics().getGranularity()){
  				case Cell:
  				case CellSet:
  				case Tuple:
  					for(ParameterAttribute p : parameterAttributes) {
						//Nombre de la tabla
  		    			if(p.getAttribute().getTypeAttribute().equals(EnumAttributeType.COLUMNS)) {
  		    				AttributeColumn ac = (AttributeColumn) p.getAttribute();
  		    				tableName = ac.getAttributeTable().getName();
  		    				attributeStringList.add(p.getAttribute().getName());
  		    				attributeParameters.put(p.getParameter().getName(), p.getAttribute().getName());
  		    			}	
  		    		}
  					attributeStringList.add("Id_" + tableName);
  					final String innerTableName = tableName;
  					List<GenericObject> toEvalute = dataAccesslMetadata.getValues(tableName, attributeStringList);
  					toEvalute.forEach(valueToEvalute -> {
  						//Agrego los parametros por referencia
  						valueToEvalute.AddProperties(referencedParameters);
  						//Llamo al WS
  						Object result = InvokeWesService(im.getMethod().getOperation(), valueToEvalute, attributeParameters);
  						//Guardo el resultado en la BD
  						dataAccesslMetadata.saveResult(im.getId(), Integer.parseInt(valueToEvalute.getProperty("Id_" + innerTableName)), result);
  						
  					});
  					break;
  				case Column:
  				case ColumnSet:
  				case Table:
  					break;
  				default:
  					break;
  	    			
  	    		}
  				//Actualizar la instancia im con la fecha de ejecución y la referencia al resultado
  				im.setMetadataTableResult("");
  			});
  			
	    	//TO DO: Ejecutar las agregaciones
  			
  			//Cierro la conexión con la base de metadatos
  			dataAccesslMetadata.disconnect();
    	}
    	catch(Exception ex)
    	{}
    }
    
    public static Schema getSchemaToCopy(List<InstancedMetric> imList){
    	Schema result = new Schema();
    	for(InstancedMetric im : imList){
    		List<ParameterAttribute> parameterAttributes = (List<ParameterAttribute>) im.getParameterValues().stream().filter(p -> p.getClass().equals(ParameterAttribute.class));
    		switch (im.getMethod().getMetrics().getGranularity()){
			case Cell:
			case CellSet:
			case Tuple:
				for(ParameterAttribute p : parameterAttributes) {
	    			//Nombre de la tabla
	    			if(p.getAttribute().getTypeAttribute().equals(EnumAttributeType.COLUMNS)) {
	    				AttributeColumn ac = (AttributeColumn)p.getAttribute();
	    				result.add(ac.getAttributeTable().getName(), p.getAttribute().getName());
	    			}
	    		}
				
				break;
			case Column:
			case ColumnSet:
	    		for(ParameterAttribute p : parameterAttributes) {
    				if(p.getParameter().getParameterType().equals(EnumParameterType.COLUMN_NAME)) {
    					// Nombre de la columna
    					p.getAttribute().getName();
    					
    				
    					AttributeColumn ac = (AttributeColumn)p.getAttribute();
    					// nombre de la tabla 
    					ac.getAttributeTable().getName();
    				}
	    		}
	    		//TO DO: como se hace en este caso?
				break;
			case Table:
	    		for(ParameterAttribute p : parameterAttributes) {
    				if(p.getParameter().getParameterType().equals(EnumParameterType.TABLE_NAME)) {
    					// Nombre de la tabla
    					p.getAttribute().getName();
    				}
	    		}
	    		//TO DO: como se hace en este caso?
				break;
			default:
				break;
    			
    		}
    	}
		return result;
    }
    
    public static Schema getSchema(InstancedMetric im){
    	Schema result = new Schema();
		List<ParameterAttribute> parameterAttributes = (List<ParameterAttribute>) im.getParameterValues().stream().filter(p -> p.getClass().equals(ParameterAttribute.class));
		switch (im.getMethod().getMetrics().getGranularity()){
		case Cell:
		case CellSet:
		case Tuple:
			for(ParameterAttribute p : parameterAttributes) {
    			//Nombre de la tabla
    			if(p.getAttribute().getTypeAttribute().equals(EnumAttributeType.COLUMNS)) {
    				AttributeColumn ac = (AttributeColumn)p.getAttribute();
    				result.add(ac.getAttributeTable().getName(), p.getAttribute().getName());
    			}
    		}
			
			break;
		case Column:
		case ColumnSet:
    		for(ParameterAttribute p : parameterAttributes) {
				if(p.getParameter().getParameterType().equals(EnumParameterType.COLUMN_NAME)) {
					// Nombre de la columna
					p.getAttribute().getName();
					
				
					AttributeColumn ac = (AttributeColumn)p.getAttribute();
					// nombre de la tabla 
					ac.getAttributeTable().getName();
				}
    		}
    		//TO DO: como se hace en este caso?
			break;
		case Table:
    		for(ParameterAttribute p : parameterAttributes) {
				if(p.getParameter().getParameterType().equals(EnumParameterType.TABLE_NAME)) {
					// Nombre de la tabla
					p.getAttribute().getName();
				}
    		}
    		//TO DO: como se hace en este caso?
			break;
		default:
			break;
			
		}
		return result;
    }
    
    //CASO 1-B -- Granularidad celda 
  	public static void ExecuteMetric (InstancedMetric im){
  		try{
  			/*
  			//Los tengo que sacar de alguna configuración local
  			String resultDB = "jdbc:mysql://localhost:3306/world";
  			String resultDBUser = "root";
  			String resultDBPassword = "Sertec01";
  			String resultTableName = "";
  			String resultColumnName = "";
  			
  			String schemaName = "world";
  			String tableName = "city";
  			
  			
  			
  			//Antes de hacer la consulta tengo que verificar que el nombre de la tabla y 
  			//de la columna sean válidos
  			//TODO: Hacer consulta que verifica que los datos de la base sean validos 
  			//(exista el esquema, la tabla y los atributos)
  			
  			//Obtengo la lista de atributos (pk + columnas a evaluar) y la definición de cada uno
  			List<InstancedMetricAttribute> imaList = im.getInstancedMetricAttributes();
  			List<GenericObject> attributesList = _dataAccess.getPKandAttributsList(schemaName, tableName, imaList);
  			
  			//Obtengo los valores a evaluar
  			List<String> attributesStringList = _dataAccess.getAttributeStringList(attributesList);
  			List<GenericObject> toEvaluate = _dataAccess.getValues(tableName, attributesStringList);
  			
  			//Me desconecto de la BD a evaluar
  			_dataAccess.disconnect();
  			
  			//Primero me tengo que conectar a las base de resultados
  			DataAccess dataAccesslMetadata = new MySQLDataAccess(resultDB, resultDBUser, resultDBPassword);
  			dataAccesslMetadata.connect();
  			
  			//Crear la tabla donde vamos a guardar los datos analizados y los resultados
  			//Esta tabla tiene que tener los atributos pk + el/los atributos a evaluar + 
  			//el resultado
  			//TODO:
  			//	- Fijarnos como poner el IdResult para evitar que una columna (pk o a evaluar) 
  			//	  sea igual a esa
  			//	- ¿Que hacemos si la tabla de resultados existe --> Se borran los resultados
  			
  			dataAccesslMetadata.createOrUpdateMetaDataTable(im, attributesList);
  			
  			//Para cada uno de los valores invocar el WS y guardar el resultado
  			for (GenericObject tuple : toEvaluate){
  				//Invoco al WS
  				Object wsResult = InvokeWesService(im.getMethod().getOperation().getWebService().getUrl(), 
  													im.getMethod().getOperation().getName(), 
  													tuple, 
  													imaList);
  				//Guardo el resultado en la base de metadatos
  				dataAccesslMetadata.saveResult(attributesStringList, tuple, wsResult, resultTableName, resultColumnName);
  				//TODO: Chequear si pudo guardar o no el resultado y ver que se hace si no
  			}
  			//Me desconecto de la BD de metadatos
  			dataAccesslMetadata.disconnect();
  			*/
  		}
  		catch (Exception exp){
  			System.out.println(exp.getMessage());
  		}
  		
  	}
  	
  	@SuppressWarnings("finally")
  	public static Object InvokeWesService(Operation operation, GenericObject valueToEvalute, Map<String, String> attributeParameters){//(String url, String operation, GenericObject toEvaluate, List<InstancedMetricAttribute> imaList){
  		try{
  			//TODO: definir que protocolo de WS vamos a usar
  			//Parametros que necesito tener para crear e invocar el WS
  			String prefix = "web";
  			
  			// Creo la conexión SOAP
  	        SOAPConnectionFactory soapConnectionFactory = SOAPConnectionFactory.newInstance();
  	        SOAPConnection soapConnection = soapConnectionFactory.createConnection();
  	        
  	        //Armamos el xml para invocar el WS
  	        MessageFactory messageFactory = MessageFactory.newInstance();
  	        SOAPMessage soapMessage = messageFactory.createMessage();
  	        SOAPPart soapPart = soapMessage.getSOAPPart();
  	        
  	        MimeHeaders headers = soapMessage.getMimeHeaders();
  	        URL tempURL = new URL(operation.getWebService().getUrl());
  	        headers.addHeader("SOAPAction", tempURL.getProtocol() + "://" + tempURL.getAuthority() + "/" + operation);
  	        
  	        // SOAP Envelope
  	        SOAPEnvelope envelope = (SOAPEnvelope) soapPart.getEnvelope();
  	        envelope.addNamespaceDeclaration(prefix, tempURL.getProtocol() + "://" + tempURL.getAuthority());

  	        SOAPBody body = soapMessage.getSOAPBody();
  	        QName bodyName = new QName(null, operation.getName(), prefix);
  	        SOAPBodyElement bodyElement = body.addBodyElement(bodyName);
  	        
  	        //Agrego los parametros
  	        operation.getParameters().forEach((parameter)->{
  	        	SOAPElement symbol;
  				try {
  					symbol = bodyElement.addChildElement(parameter.getName(), prefix); //Nombre del parametro
  					symbol.addTextNode(valueToEvalute.getProperty(attributeParameters.get(parameter.getName()))); //Valor a evaluar
  				} catch (SOAPException e) {
  					// TODO Auto-generated catch block
  					e.printStackTrace();
  				}
  		        
  	        });
  	        
  	        soapMessage.saveChanges();
  	        
  	        //Realizo la llamada al WS con el xml armado
  	        SOAPMessage soapResponse = soapConnection.call(soapMessage, tempURL);
  	        

  	        // print SOAP Response -- PRUEBAS
  	        soapResponse.writeTo(System.out);

  	        soapConnection.close();
  	        //TODO: Castear el resultado para devolver
  	        return soapResponse.getProperty("result");
  	        
  		}
  		catch (Exception exp){
  			System.out.println(exp.getMessage());
  		}
  		finally
  		{
  			return new Object();
  		}
  	}

}
