package KiuPlusLogicExecution.KiuPlusLogicExecution;

import java.util.*;
import java.util.stream.Collectors;
import com.kiuplus.logic.objects.*;
import com.kiuplus.logic.extractors.*;

public class MySQLDataAccessBORRAR extends DataAccessBORRAR{

	public MySQLDataAccessBORRAR(String server, String user, String password) {
		super(server, user, password);
		// TODO Auto-generated constructor stub
		super.setDataBase(new MySQL(server, user, password));
	}
	/*
	@Override
	public List<GenericObject> getPKandAttributsList(String schemaName, String tableName, List<InstancedMetricAttribute> attributeList){	
		String query = "";
		Map<Integer, String> parameters = new HashMap<Integer, String>();
		parameters.put(1, schemaName);
		parameters.put(2, tableName);
		
		int key = 3;
		for (InstancedMetricAttribute attribute : attributeList){
			query = "OR COLUMN_NAME = ? ";
			parameters.put(key, attribute.getAttribute().getName());
			key++;
		}
		
		query = "SELECT * "
				+"FROM INFORMATION_SCHEMA.COLUMNS "
				+"WHERE TABLE_SCHEMA = ? "
					+"AND TABLE_NAME = ? AND "
					+"(COLUMN_KEY IN('PRI', 'UNI') "
					+ query;
		List<GenericObject> result = super.getDataBase().ExecuteQuery(query, parameters);
		return result;
	}
	*/
	public List<String> getttributeStringList (List<GenericObject> attributeList){
		List<String> result = new ArrayList<String>();
		attributeList.forEach((temp) -> {
			result.add(temp.getProperty("COLUMN_NAME"));
		});
		return result;
	}
	
	@Override
	public List<GenericObject> getValues(String tableName, List<String> attributeStringList){
				
		//Obtener valores a evaluar y pk
		List<GenericObject> result = super.getDataBase().ExecuteQuery(String.format("SELECT %s FROM %s", String.join(", ", String.join(", ", attributeStringList)), tableName));
		return result;
	}

	@Override
	public void createDataTable(String tableName, List<GenericObject> attributeList){
		List<String> attributeTypeStringList = new ArrayList<String>();
		attributeList.stream().filter(a -> a.getProperty("TABLE_NAME") == tableName).collect(Collectors.toList()).forEach((temp) -> {
			attributeTypeStringList.add(temp.getProperty("COLUMN_NAME") + " " + temp.getProperty("COLUMN_TYPE"));
		});
		
		super.getDataBase().ExecuteUpdate(	"DROP TABLE IF EXISTS " + tableName + "; " +
											"CREATE TABLE " + tableName + " " +
											"( " +
											    "Id_" + tableName + " INT NOT NULL AUTO_INCREMENT, PRIMARY KEY(Id_" + tableName +"), " +
											    String.join(", ", attributeTypeStringList) +
											") ");
	}
	
	@Override
	public void createResultTable(int imId, String resultType){
		String tableName = "metadata_im_" + imId;
		super.getDataBase().ExecuteUpdate(	"DROP TABLE IF EXISTS " + tableName + "; " +
											"CREATE TABLE " + tableName + " " +
											"( " +
											    "value int(11) NOT NULL, " +
											    "result " + resultType + " DEFAULT NULL" +
											") ");
	}

	@Override
	public void saveResult(int imId, int resultId, Object result){
		String tableName = "metadata_im_" + imId;
		Map<Integer, String> parameters = new HashMap<Integer, String>();
		parameters.put(1, Integer.toString(resultId));
		parameters.put(2, result.toString());
		String query = "INSERT INTO " + tableName + " (value, result) VALUES(?, ?)";
		super.getDataBase().ExecuteUpdate(query, parameters);
	}
	
	public void saveResult2(List<String> attributeStringList, GenericObject tuple, Object result, String resultTableName, String resultColumnName){
		int key = 1;
		String query = "";
		String values = "";
		Map<Integer, String> parameters = new HashMap<Integer, String>();
		for (String columnName : attributeStringList){
				query += columnName + ", ";
				values += "?, "; 
				parameters.put(key, tuple.getProperty(columnName));
				key++;
		}
		query = "INSERT INTO " + resultTableName + " (" + query + resultColumnName + ") VALUES(" + values + "?)";
		parameters.put(key, result.toString());
		super.getDataBase().ExecuteUpdate(query, parameters);
	}
	
	public void save(List<String> attributeStringList, GenericObject tuple, String tableName){
		int key = 1;
		String query = "";
		String values = "";
		Map<Integer, String> parameters = new HashMap<Integer, String>();
		for (String columnName : attributeStringList){
				query += columnName + ", ";
				values += "?, "; 
				parameters.put(key, tuple.getProperty(columnName));
				key++;
		}
		query = query.substring(0,query.length());
		values = values.substring(0,values.length());
		query = "INSERT INTO " + tableName + " (" + query + ") VALUES(" + values + ")";
		super.getDataBase().ExecuteUpdate(query, parameters);
	}
	
	public String dataBaseType(String enumDataType){
		switch (enumDataType) {
        	case "int": return "INT";
        	case "double": return "DOUBLE";
        	case "bool": return "BIT";
        	case "nvarchar": return "TEXT";
        	case "datetime": return "DATETIME(3)";
        	default: return "TEXT";
		}
	}
	
	public List<GenericObject> getPKandAttributsList(String schemaName, Map<String,GenericObject> schemaToCopy){	
		String query = "";
		Map<Integer, String> parameters = new HashMap<Integer, String>();
		parameters.put(1, schemaName);
		int key = 2;
		for (String tableName : schemaToCopy.keySet()){
			parameters.put(key, tableName);
			key++;
			query += "AND (TABLE_NAME = ? AND "
					+"(COLUMN_KEY IN('PRI', 'UNI') ";
			for (String columnName : schemaToCopy.get(tableName).getProperties().keySet()){
				parameters.put(key, columnName);
				key++;
				query += "OR COLUMN_NAME = ? ";
			}
			query += "))";
		}
		
		query = "SELECT * "
				+"FROM INFORMATION_SCHEMA.COLUMNS "
				+"WHERE TABLE_SCHEMA = ? "
					+ query;
		List<GenericObject> result = super.getDataBase().ExecuteQuery(query, parameters);
		return result;
	}
}
