package com.kiuplus.qualityModel.logic.connecttoDB;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import com.kiuplus.logic.objects.*;

public class MySQLBORRAR implements ExtractoresBORRAR {
    private String  user;
    private String  password;
    private String  server;
    private static Connection connection  = null;
    
    public MySQLBORRAR(String server, String user, String password){
    	this.server = server;
    	this.user = user;
    	this.password = password;
    }
    
    public void Connect() throws Exception{
        try{
        	//Registrar el driver
            Class.forName("com.mysql.jdbc.Driver");
            
            //Establecer la conexion con el servidor
            connection = DriverManager.getConnection(this.server, this.user, this.password);
            
        }catch (Exception ex){
            System.err.println("ERROR");
            System.err.println(ex);
            throw ex;
        }
    }

    public List<GenericObject> ExecuteSentence(String query){
    	PreparedStatement pstmt = null;
    	ResultSet rs = null;
    	List<GenericObject> result = new ArrayList<GenericObject>();
    	try {
    	    pstmt = connection.prepareStatement(query);
    	    rs = pstmt.executeQuery();
    	    int columnCount = rs.getMetaData().getColumnCount();
    	    while ( rs.next() ) {
    	    	GenericObject row = new GenericObject();
	    	    for (int i = 1; i <= columnCount; ++i) {
	    	        row.setProperty(rs.getMetaData().getColumnName(i), rs.getString(i)); 
	    	    }
	    	    result.add(row);
    	    }
    	}
    	catch (Exception ex){
    		System.err.println("ERROR");
            System.err.println(ex);
    	}
    	finally {
    	    if (rs != null) {
    	        try {
    	            rs.close();
    	        } catch (SQLException sqlEx) { } // ignore

    	        rs = null;
    	    }

    	    if (pstmt != null) {
    	        try {
    	            pstmt.close();
    	        } catch (SQLException sqlEx) { } // ignore
    	        pstmt = null;
    	    }
    	}
		return result;
    }
    
    
    public List<GenericObject> ExecuteSentence(String query, Map<Integer, String> parameters){
    	PreparedStatement pstmt = null;
    	ResultSet rs = null;
    	List<GenericObject> result = new ArrayList<GenericObject>();
    	try {
    	    pstmt = connection.prepareStatement(query);
    	    if(parameters != null){
                for(Integer key : parameters.keySet()){
                    pstmt.setObject(key, parameters.get(key));
                }
            }    
    	    rs = pstmt.executeQuery();
    	    int columnCount = rs.getMetaData().getColumnCount();
    	    while ( rs.next() ) {
    	    	GenericObject row = new GenericObject();
	    	    for (int i = 1; i <= columnCount; ++i) {
	    	        row.setProperty(rs.getMetaData().getColumnName(i), rs.getString(i)); 
	    	    }
	    	    result.add(row);
    	    }
    	}
    	catch (Exception ex){
    		System.err.println("ERROR");
            System.err.println(ex);
    	}
    	finally {
    	    if (rs != null) {
    	        try {
    	            rs.close();
    	        } catch (SQLException sqlEx) { } // ignore

    	        rs = null;
    	    }

    	    if (pstmt != null) {
    	        try {
    	            pstmt.close();
    	        } catch (SQLException sqlEx) { } // ignore
    	        pstmt = null;
    	    }
    	}
		return result;
    }

    public void Disconnect() throws Exception{
    	try {
			connection.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			throw e;
		}
    }

    public List<GenericObject> ExecuteQuery(String query){
    	PreparedStatement pstmt = null;
    	ResultSet rs = null;
    	List<GenericObject> result = new ArrayList<GenericObject>();
    	try {
    	    pstmt = connection.prepareStatement(query);
    	    rs = pstmt.executeQuery();
    	    int columnCount = rs.getMetaData().getColumnCount();
    	    while ( rs.next() ) {
    	    	GenericObject row = new GenericObject();
	    	    for (int i = 1; i <= columnCount; ++i) {
	    	        row.setProperty(rs.getMetaData().getColumnName(i), rs.getString(i)); 
	    	    }
	    	    result.add(row);
    	    }
    	}
    	catch (Exception ex){
    		System.err.println("ERROR");
            System.err.println(ex);
    	}
    	finally {
    	    if (rs != null) {
    	        try {
    	            rs.close();
    	        } catch (SQLException sqlEx) { } // ignore

    	        rs = null;
    	    }

    	    if (pstmt != null) {
    	        try {
    	            pstmt.close();
    	        } catch (SQLException sqlEx) { } // ignore
    	        pstmt = null;
    	    }
    	}
		return result;
    }
    
    public List<GenericObject> ExecuteQuery(String query, Map<Integer, String> parameters){
    	PreparedStatement pstmt = null;
    	ResultSet rs = null;
    	List<GenericObject> result = new ArrayList<GenericObject>();
    	try {
    	    pstmt = connection.prepareStatement(query);
    	    if(parameters != null){
                for(Integer key : parameters.keySet()){
                    pstmt.setObject(key, parameters.get(key));
                }
            }    
    	    rs = pstmt.executeQuery();
    	    int columnCount = rs.getMetaData().getColumnCount();
    	    while ( rs.next() ) {
    	    	GenericObject row = new GenericObject();
	    	    for (int i = 1; i <= columnCount; ++i) {
	    	        row.setProperty(rs.getMetaData().getColumnName(i), rs.getString(i)); 
	    	    }
	    	    result.add(row);
    	    }
    	}
    	catch (Exception ex){
    		System.err.println("ERROR");
            System.err.println(ex);
    	}
    	finally {
    	    if (rs != null) {
    	        try {
    	            rs.close();
    	        } catch (SQLException sqlEx) { } // ignore

    	        rs = null;
    	    }

    	    if (pstmt != null) {
    	        try {
    	            pstmt.close();
    	        } catch (SQLException sqlEx) { } // ignore
    	        pstmt = null;
    	    }
    	}
		return result;
    }
    
    public int ExecuteUpdate(String query){
    	PreparedStatement pstmt = null;
    	int result = 0;
    	try {
    	    pstmt = connection.prepareStatement(query);
    	    result = pstmt.executeUpdate();
    	}
    	catch (Exception ex){
    		System.err.println("ERROR");
            System.err.println(ex);
    	}
    	finally {

    	    if (pstmt != null) {
    	        try {
    	            pstmt.close();
    	        } catch (SQLException sqlEx) { } // ignore
    	        pstmt = null;
    	    }
    	}
		return result;
    }
    
    public int ExecuteUpdate(String query, Map<Integer, String> parameters){
    	PreparedStatement pstmt = null;
    	int result = 0;
    	try {
    	    pstmt = connection.prepareStatement(query);
    	    if(parameters != null){
                for(Integer key : parameters.keySet()){
                    pstmt.setObject(key, parameters.get(key));
                }
            }    
    	    result = pstmt.executeUpdate();
    	    
    	}
    	catch (Exception ex){
    		System.err.println("ERROR");
            System.err.println(ex);
    	}
    	finally {
    	    if (pstmt != null) {
    	        try {
    	            pstmt.close();
    	        } catch (SQLException sqlEx) { } // ignore
    	        pstmt = null;
    	    }
    	}
		return result;
    }
    
}