package com.kiuplus.qualityModel.logic.domain;

import java.util.List;

import com.kiuplus.logic.model.AttributeColumn;
import com.kiuplus.logic.model.AttributeTable;
import com.kiuplus.logic.model.DataModel;

/**
 * @author Beatriz
 *
 */

public interface DataModelDAO {


	/**
	 * 
	 * @return Modelos de datos almacenados en la base de datos
	 */
	public List<DataModel> dataModelsGet();
	
	
	/** Obtiene el modelo de datos con las agregaciones
	 * @param id
	 * @return
	 */
	public DataModel dataModelGetFull(int id);
	
	/**
	 * @param id
	 * @return DataModel identificado con el id
	 */
	public DataModel dataModelGet(int id);
	
	/** 
	 * @param name
	 * @return dataModel por nombre
	 */
	public List<DataModel> dataModelFind(String name);
	
	/** Crea el modelo de datos
	 * @param dataModel
	 */
	public void dataModelAdd(DataModel dataModel);

	/** Edita el modelo de datos
	 * @param dataModel
	 */
	public void dataModelUpdate(DataModel dataModel);

	/** Elimina el data model
	 * @param dataModel
	 */
	public void dataModelDelete(DataModel dataModel);

	/** Consulta las tablas identificadas con el nombre
	 * @param name
	 * @return
	 */
	public List<AttributeTable> tablesAttributeFind(String name);

	/** Consulta las columnas identificadas con el nombre
	 * @param name
	 * @return
	 */
	public List<AttributeColumn> columnsAttributeFind(String name); 









}
