package com.kiuplus.qualityModel.logic.domain;

import java.util.List;

import com.kiuplus.logic.model.InstancedMetric;
import com.kiuplus.logic.model.ParameterAttribute;

/**
 * @author Beatriz
 *
 */

public interface InstancedMetricDAO {

	/**
	 * 
	 * @return Metricas instanciadas almacenadss en la base de datos
	 */
	public List<InstancedMetric> instancedMetricsGet();

	/** Obtiene las MI del modelo de datos
	 * @param idDataModel
	 * @return
	 */
	public List<InstancedMetric> instancedMetricsGet(Integer idDataModel);
	
	/**
	 * @param id
	 * @return Metrica instanciada identificado con el id
	 */
	public InstancedMetric instancedMetricGet(Integer id);


	/**
	 * @param ids
	 * @return Lista de metricas instanciadas identificadas con los ids
	 */
	public List<InstancedMetric> instancedMetricsGet(List<Integer> ids);
	
	/**
	 * @param name
	 * @return Metricas instanciadas identificas con el nombre
	 */
	
	public List<InstancedMetric> instancedMetricFind(String name);

	/**
	 * Crea la Metrica instanciada
	 * 
	 * @param instancedMetric
	 */
	public void instancedMetricAdd(InstancedMetric instancedMetric);

	/**
	 * Edita la Metrica instanciada
	 * 
	 * @param instancedMetric
	 */
	public void instancedMetricUpdate(InstancedMetric instancedMetric);

	/**
	 * Elimina la Metrica instanciada
	 * 
	 * @param instancedMetric
	 */
	public void instancedMetricDelete(InstancedMetric instancedMetric);

	// ****************************************************//
	// ParameterAttribute
	// ****************************************************//

	/**
	 * Retorna el parameterAttribute identificado con el id
	 * 
	 * @param id
	 * @return
	 */
	public ParameterAttribute parameterAttributeGet(Integer id);





	// ****************************************************//
	// DataBase
	// ****************************************************//

}
