package com.kiuplus.qualityModel.logic.domain;

import java.util.List;

import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.query.Query;
import org.springframework.stereotype.Repository;

import com.kiuplus.logic.domain.HibernateUtils;
import com.kiuplus.logic.model.InstancedMetric;
import com.kiuplus.logic.model.ParameterAttribute;

/**
 * @author Beatriz
 *
 */

@Repository
public class InstancedMetricDAOImpl implements InstancedMetricDAO {

	private SessionFactory sessionFactory;

	public InstancedMetricDAOImpl() {
		this.sessionFactory = (SessionFactory) HibernateUtils.getSessionFactory();
	}

	@Override
	public List<InstancedMetric> instancedMetricsGet(Integer idDataModel) {
		Session session = sessionFactory.openSession();
		try {
			Query<InstancedMetric> query = session
					.createQuery("from " + InstancedMetric.class.getSimpleName() + " where idDataModel= :idDataModel ");
			query.setParameter("idDataModel", idDataModel);
			List<InstancedMetric> instancedMetrics = query.getResultList();

			return instancedMetrics;
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} finally {
			session.close();
		}
	}

	public List<InstancedMetric> instancedMetricsGet() {
		Session session = sessionFactory.openSession();
		try {

			Query<InstancedMetric> query = session.createQuery("from " + InstancedMetric.class.getName());
			List<InstancedMetric> instancedMetrics = query.getResultList();

			return instancedMetrics;
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} finally {
			session.close();
		}
	}

	public InstancedMetric instancedMetricGet(Integer id) {
		Session session = sessionFactory.openSession();
		try {
			InstancedMetric instancedMetric = (InstancedMetric) session.get(InstancedMetric.class, id);

			return instancedMetric;
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} finally {
			session.close();
		}
	}

	public List<InstancedMetric> instancedMetricsGet(List<Integer> ids) {
		Session session = sessionFactory.openSession();
		try {
			Query<InstancedMetric> query = session
					.createQuery("from " + InstancedMetric.class.getName() + " WHERE id IN :idsList");
			query.setParameter("idsList", ids);
			List<InstancedMetric> instancedMetrics = query.getResultList();

			return instancedMetrics;
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} finally {
			session.close();
		}
	}

	public List<InstancedMetric> instancedMetricFind(String name) {
		Session session = sessionFactory.openSession();
		try {
			Query<InstancedMetric> query = session
					.createQuery("from " + InstancedMetric.class.getSimpleName() + " where name= :name ");
			query.setParameter("name", name);
			List<InstancedMetric> instancedMetrics = query.getResultList();

			return instancedMetrics;
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} finally {
			session.close();
		}
	}

	public void instancedMetricAdd(InstancedMetric instancedMetric) {
		Session session = sessionFactory.openSession();
		try {

			session.beginTransaction();

			instancedMetric.setId((Integer) session.save(instancedMetric));
			session.getTransaction().commit();
		} catch (Exception e) {
			e.printStackTrace();
			session.getTransaction().rollback();
			throw e;
		} finally {
			session.close();
		}
	}

	public void instancedMetricUpdate(InstancedMetric instancedMetric) {
		Session session = sessionFactory.openSession();

		try {
			session.beginTransaction();
			instancedMetric = (InstancedMetric)session.merge(instancedMetric);
			session.update(instancedMetric);

			session.getTransaction().commit();
		} catch (Exception e) {
			e.printStackTrace();
			session.getTransaction().rollback();
			throw e;
		} finally {
			session.close();
		}
	}

	public void instancedMetricDelete(InstancedMetric instancedMetric) {

		Session session = sessionFactory.openSession();
		try {
			session.beginTransaction();

			session.delete(instancedMetric);

			session.getTransaction().commit();
		} catch (Exception e) {
			e.printStackTrace();
			session.getTransaction().rollback();
			throw e;
		} finally {
			session.close();
		}

	}

	// ****************************************************//
	// ParameterAttribute
	// ****************************************************//

	public ParameterAttribute parameterAttributeGet(Integer id) {
		Session session = sessionFactory.openSession();
		try {
			ParameterAttribute parameterAttribute = (ParameterAttribute) session.get(ParameterAttribute.class, id);

			return parameterAttribute;
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} finally {
			session.close();
		}
	}

}
