package com.kiuplus.qualityModel.logic.domain;

import java.util.List;

import com.kiuplus.logic.model.ResultGroup;
import com.kiuplus.logic.model.ParameterValue;

public interface ResultGroupsDAO {

	/** Obtiene los grupos de resultados identificados con el id
	 * @param id
	 * @return
	 */
	ResultGroup resultGroupGet(int id);
	

	/** Obtien los grupos de resultados identificados con los ids
	 * @param resultGroupsIds
	 * @return
	 */
	List<ResultGroup> resultGroupsGet(List<Integer> resultGroupsIds);
	
	/** Obtiene los grupos de resultados con el nombre
	 * @param name
	 * @return
	 */
	List<ResultGroup> resultGroupsFind(String name);

	/** Crea el grupo de resultado
	 * @param resultGroupGranularity
	 */
	void resultGroupCreate(ResultGroup resultGroup);

	/** Actualiza el grupo de resultado
	 * @param resultGroup
	 */
	void resultGroupEdit(ResultGroup resultGroup);
	
	/** Elimina el grupo de resultado
	 * @param resultGroup
	 */
	void resultGroupDelete(ResultGroup resultGroup);

	
	/** Obtien los param values que tienen asociadas la metrica instanciada y pertenecen a un grupo de resultado
	 * @param idInstancedMetric identificador de la metrica instanciada
	 * @p
	 * @return
	 */
	List<ParameterValue> parameterValueInstancedMetricFind(int idInstancedMetric);

}
