package com.kiuplus.qualityModel.logic.service;

import java.util.List;

import com.kiuplus.logic.exception.ExceptionKiuPlus;
import com.kiuplus.logic.model.Attribute;
import com.kiuplus.logic.model.InstancedMetric;
import com.kiuplus.logic.model.ParameterAttribute;


/**
 * @author Beatriz
 *
 */
public interface InstancedMetricsService {

	
	/** Retorna las MI del modelo de datos
	 * @param idDataModel
	 * @return
	 */
	public List<InstancedMetric> instancedMetricsGet(int idDataModel);
	
	/**
	 * @param ids
	 * @return Lista de metricas instanciadas identificadas con los ids
	 */
	public List<InstancedMetric> instancedMetricsGet(List<Integer> ids);
	
	/** Obtiene la metrica instanciada identificada con el nombre en el modelo de datos
	 * @param name
	 * @return
	 */
	public InstancedMetric instancedMetricFind(String name);
	
	/** Crea la metrica instancidad
	 * @param instancedMetric
	 * @throws ExceptionKiuPlus
	 */ 
	public void instancedMetricCreate(InstancedMetric instancedMetric)  throws ExceptionKiuPlus;

	/** Edita la metrica instanciada
	 * @param instancedMetric
	 * @throws ExceptionKiuPlus
	 */
	public void instancedMetricEdit(InstancedMetric instancedMetric) throws ExceptionKiuPlus;
	
	/** Elimina la metrica instanciada
	 * @param id
	 * @exception ExceptionKiuPlus 
	 * 				No existe la metrica instanciada
	 * 				Tiene resultado de grupos asociados
	 */
	public void instancedMetricDelete(int id) throws ExceptionKiuPlus;

	/** Obtiene la metrica identificada con el id
	 * @param id
	 * @return
	 */
	public InstancedMetric instancedMetricGet(int id);



	//****************************************************//
	//ParameterAttribute
	//****************************************************//
	
	/** Retorna el parametro atributo identificado con el id
	 * @param id
	 * @return
	 */
	public ParameterAttribute parameterAttributeGet(int id);

	
	

	

	
}
