<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>

<%@ page language="java" contentType="text/html; charset=ISO-8859-1"
	pageEncoding="ISO-8859-1"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">

<html>
<title>Spring MVC Example with AJAX call</title>
<head>

<script src="resources/js/jquery-3.1.1.min.js" type="text/javascript"></script>
<link rel="stylesheet" href="resources/css/bootstrap.min.css">
<link rel="stylesheet" href="resources/css/bootstrap-theme.min.css">
<script src="resources/js/bootstrap.min.js"></script>

<script src="resources/GraphicHandler.js" /></script>
<script src="resources/UsersRequestsHandler.js"></script>
<script src="resources/ComunicationHandler.js" type="text/javascript"></script>
<script src="resources/Main.js" type="text/javascript"></script>


</head>


<body>
	<script src="${GraphicHandlerJS}"></script>
	<script src="${ComunicationHandlerJS}"></script>
	<script src="${UsersRequestsHandlerJS}"></script>
	<script src="${MainJS}"></script>


	<div class="container-fluid">
		<div class="row-fluid">
			<div class="span12">
				<fieldset>
					<form:form class="form-horizontal" method="POST"
						commandName='method' action="/KiuPlusWebApp/addMethod.html">
						<div class="form-group">
							<label class="control-label col-sm-2">Name* </label>
							<div class="controls col-sm-4">
								<form:input path="name" type="text" class="form-control" />
							</div>
							<form:errors path="name" cssClass="alert alert-danger col-sm-5"
								element="div" />
						</div>
						<div class="form-group">
							<label class="control-label col-sm-2">Dimension*</label>
							<div class="controls col-sm-4">
								<form:select path="dimension" onchange="UsersRequestsHandler.getFactors(this)" class="form-control">
									<form:option value="-1" label="...." />
									<form:options items="${dimensionsList}" />

								</form:select>
							</div>
							<form:errors path="dimension" cssClass="alert alert-danger col-sm-5"
								element="div" />
						</div>

						<div class="form-group">
							<label class="control-label col-sm-2">Factor*</label>
							<div class="controls col-sm-4">
								<form:select path="factor" onchange="UsersRequestsHandler.getMetrics(this)"	id="factors" class="form-control">
									<form:option value="-1" label="...." />
									<form:options items="${factorsList}" />

								</form:select>
							</div>
								<form:errors path="factor" cssClass="alert alert-danger col-sm-5"
								element="div" />
						</div>

						<div class="form-group">
							<label class="control-label col-sm-2">Metrics*</label>
							<div class="controls col-sm-4">
								<form:select path="metrics" id="metrics" class="form-control">
									<form:option value="-1" label="...." />
									<form:options items="${metricsList}" />

								</form:select>
							</div>
								<form:errors path="metrics" cssClass="alert alert-danger col-sm-5"
								element="div" />
						</div>


						<div class="form-group">
							<label class="control-label col-sm-2">URL* </label>
							<div class="controls col-sm-4">
								<form:input path="url" type="text" class="form-control" id="txtUrl"/>
								
							</div >
							<div class="controls col-sm-1">
								<button type="button" class="btn btn-primary" onclick="UsersRequestsHandler.validateURL()">Validate</button>
							</div>
							<form:errors path="url" cssClass="alert alert-danger col-sm-4"
								element="div" />


						</div>

						<div class="form-group">
							<label class="control-label col-sm-2">WS Operation*</label>
							<div class="controls col-sm-4">
								<form:select path="wsOperations"  id="cboWsOperations" class="form-control">
									<form:option value="" label="...." />
									<form:options items="${wsOperationsList}" />

								</form:select>
							</div>
								<form:errors path="wsOperations" cssClass="alert alert-danger col-sm-5"
								element="div" />
						</div>

						<div class="form-group">
							<label class="control-label col-sm-2">Connect to DataBase</label>
							<div class="controls col-sm-4">
								<form:checkbox path="connectToDataBase" />

							</div>
						</div>
						
						<div class="form-actions" align="center">
							<button type="submit" class="btn btn-success">Save</button>
						</div>
					</form:form>
				</fieldset>
			</div>
		</div>
	</div>
</body>
</html>