package com.kiupluswebapp.model;

import javax.validation.constraints.Min;
import javax.validation.constraints.Size;

import org.hibernate.validator.constraints.NotBlank;
import org.hibernate.validator.constraints.NotEmpty;

public class Method {

	// Parameter configuration:
	// Data: Datos de la base de datos
	// Referencial: Valores que necesita el metodo para realizar calculos
	// Conectionstring: Parametro en el cual se envia el string de conexion en
	// caso que
	// el web service se conecte directamente para obtener los datos
	// public enum EnumParameterType {
	// Data,
	// Referencial,
	// DBConectionString
	// }

	// region Attribute
	private Integer id;


	@NotBlank(message = "validator_invalid_state_name")
	@Size(min = 2, max = 50)
	private String name;

	private Operation operation;

	@Min(value = 0, message = "Select a dimension.")
	private Integer dimension;

	@Min(value = 0, message = "Select a factor.")
	private Integer factor;

	@Min(value = 0, message = "Select a metrics.")
	private Integer metrics;

	@NotEmpty(message="URL should not be blank.")
	private String url;
	
	@Min(value = 0, message = "Select a operation.")
	private String wsOperations;

	private boolean connectToDataBase;
	
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Operation getOperation() {
		return operation;
	}

	public void setOperation(Operation operation) {
		this.operation = operation;
	}



	public Integer getDimension() {
		return dimension;
	}

	public void setDimension(Integer dimension) {
		this.dimension = dimension;
	}

	public Integer getFactor() {
		return factor;
	}

	public void setFactor(Integer factor) {
		this.factor = factor;
	}

	public Integer getMetrics() {
		return metrics;
	}

	public void setMetrics(Integer metrics) {
		this.metrics = metrics;
	}

	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	
	public String getWsOperations() {
		return wsOperations;
	}

	public void setWsOperations(String wsOperations) {
		this.wsOperations = wsOperations;
	}

	
	
	public boolean isConnectToDataBase() {
		return connectToDataBase;
	}

	public void setConnectToDataBase(boolean connectToDataBase) {
		this.connectToDataBase = connectToDataBase;
	}

	public Method() {

	}

	public Method(String name) {
		this.name = name;
	}

	// endregion

	// region Parameters

	// endregion

}
