package com.project.kiuplus.controller.qualityModel;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.json.simple.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.kiuplus.logic.model.InstancedMetric;
import com.kiuplus.logic.model.ParameterValue;
import com.kiuplus.logic.model.ResultGroup;
import com.kiuplus.logic.model.Parameter.EnumParameterType;
import com.kiuplus.qualityModel.logic.service.InstancedMetricsService;
import com.project.kiuplus.exceptions.ExceptionMethod;

@Controller
public class QualityModelResultGroupController {
	
	@Autowired
	private InstancedMetricsService instancedMetricsService;
	
	// **************************//
	// llamados ajax
	// **************************//

	/**
	 * Obtiene las metricas instanciadas del modelo de datos
	 * 
	 * @param idDataModel
	 * @param index
	 *            indice del parameter value de la agregacion
	 * @param model
	 * @return Metricas instanciadas
	 * @throws Exception
	 */
	@SuppressWarnings("unchecked")
	@RequestMapping(value = "/instancedMetricsFind", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
	public @ResponseBody JSONObject instancedMetricsFind(
			@RequestParam(value = "idDataModel", required = true) int idDataModel,
			@RequestParam(value = "index", required = true) int index,
			@RequestParam(value = "type", required = true) String type, HttpServletRequest request) throws Exception {

		try {
			JSONObject json = new JSONObject();
			ResultGroup aggregation = (ResultGroup) request.getSession().getAttribute("aggregation");

			List<InstancedMetric> instancedMetrics = this.instancedMetricsService.instancedMetricsGet(idDataModel);

			json.put("instancedMetrics", instancedMetrics);

			// Establezco el tipo del parametro
			if (type.equals("TABLE_NAME")) {
				aggregation.getParameterValues().set(index, new ParameterValue(EnumParameterType.TABLE_NAME));
			} else {
				aggregation.getParameterValues().set(index, new ParameterValue(EnumParameterType.COLUMN_NAME));
			}
			request.getSession().setAttribute("aggregation", aggregation);

			return json;

		} catch (Exception e) {
			e.printStackTrace();
			throw new ExceptionMethod("It is not possible to obtain the instanced metrics.");
		}
	}
}
