<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>

<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<!DOCTYPE html>

<html lang="en">

<title>Dimension Detail</title>
<head>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>


<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<link rel="stylesheet" type="text/css" href="resources/css/kiuPlusCss.css">

<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>

<link rel="stylesheet" href="resources/css/dataTables.bootstrap.min.css">
<script src="resources/js/jquery.dataTables.min.js"></script>
<script src="resources/js/dataTables.bootstrap.min.js"></script>


<script src="resources/GraphicHandler.js" /></script>
<script src="resources/UsersRequestsHandler.js"></script>
<script src="resources/ComunicationHandler.js" type="text/javascript"></script>
<script src="resources/Main.js" type="text/javascript"></script>



<script>
	$(document).ready(function() {
		formatTable('dtFactors');
		// 		$('#dtFactors').DataTable({
		// 			// 			"jQueryUI" : true,
		// 			//"pagingType" : "full_numbers",//pone previus y next
		// 			"pagingType" : "simple_numbers",
		// 			"lengthMenu" : [ [ 5, 10, 50, -1 ], [ 5, 10, 50, "All" ] ]
		// 		/* few more options are available to use */
		// 		});
		menuSideReLoadConfiguration("dimension", ${dimension.id});

	});
</script>

</head>


<body class="bodyCss">

	<div>
		<c:if test="${message != null }">
			<div class="alert alert-success">${message}</div>
		</c:if>
		<c:if test="${error != null }">
			<div class="alert alert-danger">${error}</div>
		</c:if>
		<div class="col-md-6">
			<h3>Dimension: ${dimension.name}</h3>
		</div>
		<div class="col-md-6" align="right" style="margin-top: 10px">
			<a class="btn btn-primary btn-md" href="configurationEditDimensionPage?id=${dimension.id}">
				<span class="glyphicon glyphicon-pencil"></span>
				Edit
			</a>

			<a class="btn btn-danger  btn-md" data-toggle="modal" data-target="#confirmationModal"
				onclick="setUrlOkModal('${pageContext.request.contextPath}/configurationDeleteDimension?id=${dimension.id}', 'Dimension', '${dimension.name}'); return false;">
				<span class="glyphicon glyphicon-trash"></span>
				Delete
			</a>
		</div>
		<div class="col-md-12">
			<hr>
		</div>
		<!-- 		<div class="col-md-12" style="text-align: center;"> -->
		<!-- 			<hr> -->
		<%-- 			<span class="cssSpanTitle">${dimension.name}</span> --%>
		<!-- 		</div> -->


		<div class="col-md-8 col-md-offset-2">

			<div class="form-group row">
				<h4 class="col-md-3 col-form-label">Factors</h4>
				<div class="col-md-9" align="right">
					<a class="btn btn-success" href="configurationFactorCreatePage?idDimension=${dimension.id}">
						<span class="glyphicon glyphicon-plus"> </span>
						Factor
					</a>
				</div>
			</div>

			<c:choose>
				<c:when test="${empty dimension.factors}">
					<div>There are no factors in the dimension</div>
				</c:when>
				<c:otherwise>
					<div class=" panel panel-default center-block ">

						<table id="dtFactors" class="table table-striped ">
							<thead>
								<tr>
									<th class="text-center">Name</th>
									<th class="text-center"></th>
								</tr>
							</thead>
							<tbody>

								<c:forEach var="factor" items="${dimension.factors}" varStatus="status">
									<tr>
										<td>${factor.name}</td>
										<td align="center">
											<a class="btn btn-info  btn-sm" href="configurationFactorShowPage?id=${factor.id}">
												<span class="glyphicon glyphicon-eye-open"> </span>
												View
											</a>
<%-- 											<a class="btn btn-primary  btn-sm" href="configurationFactorEditPage?id=${factor.id}"> --%>
<!-- 												<span class="glyphicon glyphicon-pencil"></span> -->
<!-- 												Edit -->
<!-- 											</a> -->
<!-- 											<a class="btn btn-danger  btn-sm" data-toggle="modal" data-target="#confirmationModal" -->
<%-- 												onclick="setUrlOkModal('${pageContext.request.contextPath}/configurationFactorDelete?id=${factor.id}'); return false;"> --%>
<!-- 												<span class="glyphicon glyphicon-trash"></span> -->
<!-- 												Delete -->
<!-- 											</a> -->
										</td>
									</tr>
								</c:forEach>
							</tbody>
						</table>
					</div>
				</c:otherwise>
			</c:choose>

		</div>
	</div>
	<!-- 				Modal -->
	<div id="popUpYesNo">
		<jsp:include page="../common/popUpDeleteYesNo.jsp" />
	</div>
</body>
</html>