<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<!DOCTYPE html>
<html lang="en">
<head>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<link rel="stylesheet" type="text/css" href="resources/css/kiuPlusCss.css">
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
<link rel="stylesheet" href="resources/css/dataTables.bootstrap.min.css">
<script src="resources/js/jquery.dataTables.min.js"></script>
<script src="resources/js/dataTables.bootstrap.min.js"></script>

<script src="resources/GraphicHandler.js" /></script>
<script src="resources/UsersRequestsHandler.js"></script>
<script src="resources/ComunicationHandler.js" type="text/javascript"></script>
<script src="resources/Main.js" type="text/javascript"></script>

<title>Insert title here</title>

<!-- Initialization code of data table at the time of page load. -->
<script>
	$(document).ready(function() {
		menuSideReLoadConfiguration("", -1);
		$('#dtDimensions').DataTable({
			// 			"jQueryUI" : true,
			//"pagingType" : "full_numbers",//pone previus y next
			"pagingType" : "simple_numbers",
			"lengthMenu" : [ [ 5, 10, 50, -1 ], [ 5, 10, 50, "All" ] ]
		/* few more options are available to use */
		});
	});
</script>

</head>
<body class="bodyCss">

	<div>

		<c:if test="${message != null }">
			<div class="alert alert-success">${message}</div>
		</c:if>
		<c:if test="${error != null }">
			<div class="alert alert-danger">${error}</div>
		</c:if>
		<div class="col-md-6">
			<h3>Dimensions</h3>
		</div>
		<div class="col-md-12">
			<hr>
		</div>
		<div class="row">

			<div class="col-sm-8 col-md-offset-2">
				<div align="right">
					<a class="btn btn-success" href="configurationDimensionCreatePage.html">
						<span class="glyphicon glyphicon-plus"> </span>
						Dimension
					</a>
				</div>
				<br>
				<div>
					<c:choose>
						<c:when test="${empty listDimensions}">
							There are no dimensions in the catalog
						</c:when>
						<c:otherwise>
							<div class=" panel panel-default center-block">
								<!-- 							<div class="panel-heading">Dimensions</div> -->
								<table id="dtDimensions" class="table table-striped ">
									<thead>
										<tr>
											<th class="text-center">Name</th>
											<th class="text-center"></th>
										</tr>
									</thead>
									<tbody>



										<c:if test="${empty listDimensions}"></c:if>

										<c:forEach var="dimension" items="${listDimensions}" varStatus="status">
											<tr>
												<td>${dimension.name}</td>

												<td align="center">
													<a class="btn btn-info btn-sm" href="configurationDimensionShowPage?id=${dimension.id}">
														<span class="glyphicon glyphicon-eye-open"> </span>
														View
													</a>

													<!-- 												<a class="btn btn-primary btn-sm" -->
													<%-- 													href="configurationEditDimensionPage?id=${dimension.id}"><span class="glyphicon glyphicon-pencil"></span> Edit</a> --%>

													<!-- 												<a class="btn btn-danger  btn-sm" data-toggle="modal" data-target="#confirmationModal" -->
													<%-- 													onclick="setUrlOkModal('${pageContext.request.contextPath}/configurationDeleteDimension?id=${dimension.id}'); return false;"><span class="glyphicon glyphicon-trash"></span> Delete</a> --%>
											</tr>
										</c:forEach>
									</tbody>
								</table>
							</div>
						</c:otherwise>
					</c:choose>

				</div>
			</div>
		</div>
		<!-- 		<div id="popUpYesNo"> -->
		<%-- 			<jsp:include page="../common/popUpYesNo.jsp" /> --%>
		<!-- 		</div> -->
	</div>

</body>
</html>