<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<!DOCTYPE>
<html lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">

<script type="text/javascript">

$(document).ready(function() {
	$('a').click(function(e) {
		redirectHref($(this).attr('href'));
	
	});
		
});
</script>

<style type="text/css">
span {
	color: #848383;
}

#divMenu ul {
	padding: 0px;
	margin: 0px;
	list-style: none;
	min-width: 100%;
}

#divMenu a {
	color: #cecece;
}

.a_text {
	padding-left: 5px;
	margin-left: 10px;
}

/* .a_span { */
/* 	padding-top: 5px; */
/* 	float: none; */
/* } */
.li_ppal {
	border-bottom: 1px solid #171616;
	border-radius: 0px;
	padding-left: 0px;
	margin: 0px;
	background-color: #383838;
	min-width: 100%;
}

.li_sub_menu {
	background-color: #222;
	padding: 0px;
	margin: 0px;
	padding-left: 10px;
	padding-top: 5px;
	border: none;
	border-radius: 0px;
}

#divMenu a:hover, span:hover, a:focus, span:focus {
	color: #fffcfc;
	background-color: transparent;
}

#divMenu {
	color: #d3d1d1;
	background-color: transparent;
}
</style>

</head>
<body>
	<div id="divMenu"
		style="width: 300px; float: left; max-height: 95vh; overflow-y: auto; height: -webkit-fill-available; background-color: #383838;">
		<div class="nav-side-menu">
			<div class="navbar-header" style="padding-left: 0px; background-color: #2e2d2d; min-width: 100%">
				<a href="#mnuconfigurationCatalog" class="navbar-brand" style="padding: 15px; margin: 0px">Catalog</a>
				<div id="accordion" style="display: inline; position: relative;">
					<a class="dropdown-toggle" data-toggle="dropdown" href="#" data-target="#ulDimensionsEdit"
						style="float: right;">
						<span class="glyphicon glyphicon-pencil" style="padding-right: 10px; padding-top: 15px">
						</span>
					</a>

					<ul class="dropdown-menu nav navbar-nav">
						<!-- 											Dimension crear y listar -->

						<li>
							<a href="#mnuconfigurationDimensionCreatePage">
								<span class="glyphicon glyphicon-plus"> </span>
								Create dimension
							</a>
						<li class="divider"></li>

						<li>
							<a class="danger" href="#mnuconfigurationDimensionsListPage">
								<span class=" glyphicon glyphicon-th-list"> </span>
								List dimensions
							</a>
						</li>

					</ul>
				</div>
			</div>
			<div id="menu" class="collapse navbar-collapse"
				style="margin: 0px; padding: 0px; min-width: 100%">

				<ul class="nav navbar-nav" id="ulDimensions">
					<c:forEach var="dimension" items="${dimensions}">
						<li class="panel li_ppal">
							<div style="color: #9d9d9d; margin-top: 10px; margin-bottom: 10px;">
								<a data-toggle="collapse" class="collapse-toggle a_text" href="#"
									data-parent="#ulDimensions" data-target="#ulFactors${dimension.id}"
									id="dimension${dimension.id}">
									${fn:substring(dimension.name, 0, 23)}

									<c:if test="${not empty dimension.factors}">
										<span class="glyphicon glyphicon-chevron-down" style="padding-top: 5px; float: none;">
										</span>
									</c:if>
								</a>
								<a href="#mnuconfigurationDimensionShowPage?id=${dimension.id}">
									<span class="glyphicon glyphicon-eye-open" style="padding-right: 10px; padding-top: 5px">
									</span>
								</a>
							</div>
							<!-- 													Factores -->
							<ul class="collapse" id="ulFactors${dimension.id}">
								<c:forEach var="factor" items="${dimension.factors}">
									<li class="panel li_sub_menu">

										<a data-toggle="collapse" class="collapse-toggle a_text" href="#"
											data-parent="#ulFactors${dimension.id}" data-target="#ulMetrics${factor.id}"
											id="factor${factor.id}" style="width: 200px">
											${fn:substring(factor.name, 0, 22)}
											
											<c:if test="${not empty factor.metrics}">
												<span class="glyphicon glyphicon-chevron-down" style="padding-top: 5px; float: none;">
												</span>
											</c:if>
										</a>
										<a href="#mnuconfigurationFactorShowPage?id=${factor.id}">
											<span class="glyphicon glyphicon-eye-open" style="padding-top: 5px; padding-right: 10px">
											</span>
										</a>
										<!-- 																Metricas -->
										<ul class="collapse" id="ulMetrics${factor.id}">
											<c:forEach var="metrics" items="${factor.metrics}">
												<li class="panel li_sub_menu">

													<a data-toggle="collapse" class="collapse-toggle a_text" href="#"
														data-parent="#ulMetrics${factor.id}" data-target="#ulMethod${metrics.id}"
														id="metrics${metrics.id}">
														${fn:substring(metrics.name, 0, 21)}
														
														<c:if test="${not empty metrics.methods}">
															<span class="glyphicon glyphicon-chevron-down" style="padding-top: 5px; float: none;">
															</span>
														</c:if>
													</a>
													<a href="#mnuconfigurationMetricsShowPage?id=${metrics.id}">
														<span class="glyphicon glyphicon-eye-open"
															style="padding-top: 5px; padding-right: 10px"> </span>
													</a>
													<!-- 																			Metodos -->
													<ul class="collapse" id="ulMethod${metrics.id}">
														<c:forEach var="method" items="${metrics.methods}">
															<li class="panel li_sub_menu">

																<a id="method${method.id}" href="#mnuconfigurationMethodShowPage?id=${method.id}"
																	class="a_text">
																	${fn:substring(method.name, 0, 22)}
																	
																	<span class="glyphicon glyphicon-eye-open"
																		style="padding-top: 5px; padding-right: 10px"> </span>
																</a>
															</li>
														</c:forEach>
													</ul>
												</li>
											</c:forEach>
										</ul>
									</li>
								</c:forEach>
							</ul>
						</li>
					</c:forEach>
				</ul>
			</div>
		</div>
	</div>
	<script type="text/javascript">
	  		menuSideConfigurationOpen(${dimensionId}, ${factorId}, ${metricsId}, ${methodId}, '${type}'); 
	 		</script>


</body>
</html>