<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1"
	pageEncoding="ISO-8859-1" session="true"%>

<!DOCTYPE html>

<html lang="en">

<title>Method</title>

<head>

<script
	src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>


<link rel="stylesheet"
	href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<link rel="stylesheet" type="text/css"
	href="resources/css/kiuPlusCss.css">

<script
	src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>

<link rel="stylesheet" href="resources/css/dataTables.bootstrap.min.css">
<script src="resources/js/jquery.dataTables.min.js"></script>
<script src="resources/js/dataTables.bootstrap.min.js"></script>


<script src="resources/GraphicHandler.js" /></script>
<script src="resources/UsersRequestsHandler.js"></script>
<script src="resources/ComunicationHandler.js" type="text/javascript"></script>
<script src="resources/Main.js" type="text/javascript"></script>

<script type="text/javascript">
	$(function() {
		$('[data-toggle="tooltip"]').tooltip();
	});


	$(window).on('load', function(){ $(".loader").fadeOut("slow")});
	
	
	$(window).ready(function(){
		
			//Deshabilita los campos cuando el metodo tiene metricas instanciadas asociadas		
			if($('#lblHasMI').text() == 'true'){
				$('#txtWebServiceUrl').prop('disabled', true);
				$('#btnValidate').prop('disabled', true);
				$('#cbOperations').prop('disabled', true);
				$("input:radio").prop('disabled', true);
				<!-- 				$("#divOperationCleanWS").prop('disabled', true); -->
				<!--  				$("#chkOperationCleanWS").prop('disabled', true); -->
			}
			
			<%--  			$('#divOperationCleanWS').prop('hidden', ${method.operationCleanWS == null} ||  ${method.operationCleanWS.id ==0}); --%>
			<%--  			$("#chkOperationCleanWS").prop('checked', ${method.operationCleanWS != null}  && ${method.operationCleanWS.id !=0}); --%>
	});
	
	
	$(document).ready(function() {
		if(${method.id != 0}){
			menuSideReLoadConfiguration("method", ${method.id});
		}
	});
	
	function showDivOperationCleanWS(){
		$('#divOperationCleanWS').prop('hidden', !$('#divOperationCleanWS').prop('hidden'));
		$('#cbOperationsCleanWS').val("");
		<%-- ${method.operationCleanWS.id} = -1; --%>
	}
	
</script>

</head>

<body class="bodyCss">
	<div id="loader" class="loader"></div>
	<div>
		<c:if test="${error != null }">
			<div class="alert alert-danger">${error}</div>
		</c:if>
		<form:form method="POST" commandName='method'
			action="${pageContext.request.contextPath}/configurationMethodCreateOrEdit.html">

			<label id="lblHasMI" style="display: none">${hasMI}</label>
			<div class="col-md-6">
				<c:choose>
					<c:when test="${method.id == 0}">
						<h3>Create method</h3>
					</c:when>
					<c:when test="${method.id != 0}">
						<h3>Edit method</h3>
					</c:when>
				</c:choose>
			</div>
			<div class="col-md-12">
				<hr>
			</div>
			<div class="col-md-10 col-md-offset-1">
				<div class="form-group row">
					<label class="col-md-2 col-form-label">Dimension </label>
					<div class="col-md-5" style="text-align: left">${method.metrics.factor.dimension.name}</div>
				</div>
				<div class="form-group row">
					<label class="col-md-2 col-form-label">Factor </label>
					<div class="col-md-5" style="text-align: left">${method.metrics.factor.name}</div>
				</div>
				<div class="form-group row">
					<label class="col-md-2 col-form-label">Metrics </label>
					<div class="col-md-5" style="text-align: left">${method.metrics.name}</div>
				</div>

				<div class="form-group row">
					<label class="col-md-2 col-form-label">Granularity </label>
					<div class="col-md-5" style="text-align: left">${method.metrics.granularity}</div>
				</div>
				<div class="form-group row">
					<hr>
				</div>
				<div class="form-group row">
					<label class="col-md-2 col-form-label">Name* </label>
					<div class="col-md-5">
						<form:input path="name" type="text" class="form-control"
							maxlength="45" />
					</div>
					<form:errors path="name"
						cssClass="alert alertValidation alert-danger col-md-5"
						element="div" style="margin-bottom:0px" />
				</div>
				<div class="form-group row">
					<label class="col-md-2 col-form-label">Description* </label>
					<div class="col-md-5">
						<form:textarea path="description" class="form-control"
							maxlength="1000" />
					</div>
					<form:errors path="description"
						cssClass="alert alertValidation alert-danger col-md-5"
						element="div" style="margin-bottom:0px" />
				</div>
				<div class="row">
					<hr>
				</div>
				<div class="form-group row">
					<h4 class="col-md-3 col-form-label">Web Service</h4>
				</div>
				<div class="form-group row" id="divUrl">
					<label class="col-md-2 col-form-label">URL* </label>
					<div class="col-md-5">
						<form:input id="txtWebServiceUrl" path="operation.webService.url"
							type="url" class="form-control" maxlength="2000" />
					</div>
					<div class="col-md-2">
						<span class="glyphicon glyphicon-question-sign"
							data-toggle="tooltip" data-placement="right"
							title="Url of the wsdl. e.g.: http://DataQualityModel/DataQualityImpCatalogo?wsdl"
							style="color: #6E6E6E"></span>
						<button id="btnValidate" type="button" class="btn btn-primary"
							onclick="UsersRequestsHandler.methodUrlWebServiceValidate('${method.metrics.connectToDB}', '${method.metrics.granularity}')">Validate</button>
					</div>
					<div class="col-md-5 col-md-offset-2">
						<form:errors path="operation.webService.url"
							cssClass="alert alertValidation alert-danger" element="div"
							id="errorUrl" />
						<div id="divUrlError" class="alert alertValidation alert-danger"
							style="display: none;"></div>
					</div>
				</div>
				<div class="form-group row">
					<label class="col-md-2 col-form-label">Operation* </label>
					<div class="col-md-5">
						<form:select path="operation.name" id="cbOperations"
							class="form-control"
							onchange="UsersRequestsHandler.methodParametersGet('${method.metrics.connectToDB}', '${method.metrics.granularity}');">
							<form:options items="${method.operation.webService.operations}"
								itemLabel="name" itemValue="name" />
						</form:select>
					</div>
					<form:errors path="operation.name"
						cssClass="alert alertValidation alert-danger col-md-5"
						element="div" id="errorOperation" />
				</div>
				<div class="form-group row">
					<label class="col-md-2 col-form-label">Parameters </label>
					<form:errors id="errorOperationParameters"
						path="operation.parameters"
						cssClass="alert alertValidation alert-danger col-md-9"
						element="div" style="margin-bottom: 0px" />
				</div>

				<div id="divParameterEmpty" style="display: none">The
					operation has no parameters</div>
				<div class=" panel panel-default center-block"
					id="divParameterNotEmpty"
					onload="visbilityTable(${method.operation.parameters})">
					<table id="tableParameters" class="table table-striped">
						<thead>
							<tr id="trParametersHead">
								<th class="text-center col-md-3">Name</th>
								<th class="text-center">Type</th>
								<th class="text-center">Referential</th>
								<c:if
									test="${method.metrics.granularity == 'Cell' || method.metrics.granularity == 'CellSet' || method.metrics.granularity == 'Tuple'}">
									<th class="text-center">Attribute</th>
								</c:if>
								<c:if
									test="${method.metrics.granularity == 'Column' || method.metrics.granularity == 'ColumnSet'  || method.metrics.granularity == 'Table'}">
									<th class="text-center">Table name</th>
								</c:if>
								<c:if
									test="${method.metrics.granularity == 'Column' || method.metrics.granularity == 'ColumnSet'}">
									<th class="text-center">Column name</th>
								</c:if>
								<c:if test="${method.metrics.connectToDB}">
									<th id="thConnecttionParameter" class="text-center">Connection
										parameter</th>
								</c:if>
							</tr>
						</thead>
						<tbody id="tableParametersBody">
							<c:forEach var="parameter" items="${method.operation.parameters}"
								varStatus="loop">
								<tr>
									<td style="text-align: center">
										<form:label path="operation.parameters[${loop.index}].name">${parameter.name}</form:label>
									</td>
									<td style="text-align: center">${parameter.dataType.text}</td>
									<%-- 											<c:forEach var="enumP" items="${enumParameterTypeList}"> --%>
									<td style="text-align: center">
										<form:radiobutton
											path="operation.parameters[${loop.index}].parameterType"
											value="REFERENCE" />
									</td>
									<c:if
										test="${method.metrics.granularity == 'Cell' || method.metrics.granularity == 'CellSet' || method.metrics.granularity == 'Tuple'}">
										<td style="text-align: center">
											<form:radiobutton
												path="operation.parameters[${loop.index}].parameterType"
												value="ATTRIBUTE" />
										</td>
									</c:if>

									<c:if
										test="${method.metrics.granularity == 'Column' || method.metrics.granularity == 'ColumnSet'  || method.metrics.granularity == 'Table'}">
										<td style="text-align: center">
											<form:radiobutton
												path="operation.parameters[${loop.index}].parameterType"
												value="TABLE_NAME" />
										</td>
									</c:if>

									<c:if
										test="${method.metrics.granularity == 'Column' || method.metrics.granularity == 'ColumnSet'}">
										<td style="text-align: center">
											<form:radiobutton
												path="operation.parameters[${loop.index}].parameterType"
												value="COLUMN_NAME" />
										</td>
									</c:if>

									<td style="text-align: center">
										<c:if test="${method.metrics.connectToDB}">
											<form:radiobutton
												path="operation.parameters[${loop.index}].parameterType"
												value="CONNECT_TO_DB" />
										</c:if>
									</td>
									<%-- 											</c:forEach> --%>
								</tr>
							</c:forEach>
						</tbody>
					</table>
				</div>
				<div class="form-group row">
					<hr>
				</div>
				<div class="row form-actions col-md-12" align="center">
					<button type="submit" class="btn btn-success">
						<span class="glyphicon glyphicon-ok"></span>
						Save
					</button>
				</div>
			</div>

		</form:form>

	</div>
</body>
</html>