<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<!DOCTYPE html>

<html lang="en">

<title>Method detail</title>

<head>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>


<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<link rel="stylesheet" type="text/css" href="resources/css/kiuPlusCss.css">

<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>

<link rel="stylesheet" href="resources/css/dataTables.bootstrap.min.css">
<script src="resources/js/jquery.dataTables.min.js"></script>
<script src="resources/js/dataTables.bootstrap.min.js"></script>


<script src="resources/GraphicHandler.js" /></script>
<script src="resources/UsersRequestsHandler.js"></script>
<script src="resources/ComunicationHandler.js" type="text/javascript"></script>
<script src="resources/Main.js" type="text/javascript"></script>
<script type="text/javascript">
	$(function() {
		$('[data-toggle="tooltip"]').tooltip()
	})

	$(document).ready(function() {
		menuSideReLoadConfiguration("method", ${method.id});
		<%-- 	$('#divOperationCleanWS').prop('hidden', ${method.operationCleanWS == null} ||  ${method.operationCleanWS.id ==0}); --%>
		<%-- 		$("#chkOperationCleanWS").prop('checked', ${method.operationCleanWS != null}  && ${method.operationCleanWS.id !=0}); --%>
	});
	
</script>

</head>

<body class="bodyCss">

	<div>
		<c:if test="${message != null }">
			<div class="alert alert-success">${message}</div>
		</c:if>
		<c:if test="${error != null }">
			<div class="alert alert-danger">${error}</div>
		</c:if>
		<div class="col-md-6">
			<h3>Method: ${method.name}</h3>
		</div>
		<div class="col-md-6" align="right" style="margin-top: 10px">
			<a class="btn btn-primary btn-md" href="configurationMethodEditPage?id=${method.id}">
				<span class="glyphicon glyphicon-pencil"></span>
				Edit
			</a>
			<a class="btn btn-danger  btn-md" data-toggle="modal" data-target="#confirmationModal"
				onclick="setUrlOkModal('${pageContext.request.contextPath}/configurationMethodDelete?id=${method.id}', 'Method', '${method.name}'); return false;">
				<span class="glyphicon glyphicon-trash"></span>
				Delete
			</a>
		</div>
		<div class="col-md-12">
			<hr>
		</div>

		<!-- 		<div class="col-md-12" style="text-align: center;"> -->
		<!-- 			<hr> -->
		<%-- 			<span class="cssSpanTitle">${method.name}</span> --%>
		<!-- 		</div> -->

		<div class="col-md-10 col-md-offset-1">
			<div class="form-group row">
				<label class="col-md-2 col-form-label">Dimension </label>
				<div class="col-md-5" style="text-align: left">${method.metrics.factor.dimension.name}</div>
			</div>
			<div class="form-group row">
				<label class="col-md-2 col-form-label">Factor </label>
				<div class="col-md-5" style="text-align: left">${method.metrics.factor.name}</div>
			</div>
			<div class="form-group row">
				<label class="col-md-2 col-form-label">Metrics </label>
				<div class="col-md-5" style="text-align: left">${method.metrics.name}</div>
			</div>
			<div class="form-group row">
				<label class="col-md-2 col-form-label">Granularity </label>
				<div class="col-md-5" style="text-align: left">${method.metrics.granularity}</div>
			</div>
			<div class="row">
				<hr>
			</div>
				<div class="form-group row">
				<label class="col-md-2 col-form-label">Description </label>
				<div class="col-md-10" style="text-align: left">${method.description}</div>
			</div>
			<div class="row">
				<hr>
			</div>
			
			<div class="form-group row">
				<h4 class="col-md-2 col-form-label">Web Service</h4>
			</div>
			<div class="form-group row">
				<label class="col-md-2 col-form-label">Url </label>
				<div class="col-md-10" style="text-align: left">${method.operation.webService.url}</div>
			</div>
			<div class="form-group row">
				<label class="col-md-2 col-form-label">Operation </label>
				<div class="col-md-2" style="text-align: left">${method.operation.name}</div>
			</div>

			<div class="form-group row">
				<label class="col-md-2 col-form-label">Parameters </label>
			</div>
			<c:choose>
				<c:when test="${empty method.operation.parameters}">
					<div id="divParameterEmpty">The method has no parameters</div>
				</c:when>
				<c:otherwise>
					<div class=" panel panel-default center-block" id="divParameterNotEmpty">

						<table id="tableParameters" class="table table-striped ">
							<thead>
								<tr>
									<th class="text-center col-md-3">Name</th>
									<th class="text-center">Type</th>
									<th class="text-center">Referential</th>
									<c:if
										test="${method.metrics.granularity == 'Cell' || method.metrics.granularity == 'CellSet' || method.metrics.granularity == 'Tuple'}">
										<th class="text-center">Attribute</th>
									</c:if>
									<c:if
										test="${method.metrics.granularity == 'Column' || method.metrics.granularity == 'ColumnSet'  || method.metrics.granularity == 'Table'}">
										<th class="text-center">Table name</th>
									</c:if>
									<c:if
										test="${method.metrics.granularity == 'Column' || method.metrics.granularity == 'ColumnSet'}">
										<th class="text-center">Column name</th>
									</c:if>
									<c:if test="${method.metrics.connectToDB}">
										<th id="thConnecttionParameter" class="text-center">Connection parameter</th>
									</c:if>
								</tr>
							</thead>
							<tbody id="tableParametersBody">
								<c:forEach var="parameter" items="${method.operation.parameters}" varStatus="loop">
									<tr>
										<td style="text-align: center">
											<label>${parameter.name}</label>
										</td>
										<td style="text-align: center">${parameter.dataType.text}</td>

										<td style="text-align: center">
											<form:radiobutton path="method.operation.parameters[${loop.index}].parameterType"
												value="REFERENCE" disabled="true" />
										</td>

										<c:if
											test="${method.metrics.granularity == 'Cell' || method.metrics.granularity == 'CellSet' || method.metrics.granularity == 'Tuple'}">
											<td style="text-align: center">
												<form:radiobutton path="method.operation.parameters[${loop.index}].parameterType"
													value="ATTRIBUTE" disabled="true" />
											</td>
										</c:if>

										<c:if
											test="${method.metrics.granularity == 'Column' || method.metrics.granularity == 'ColumnSet'  || method.metrics.granularity == 'Table'}">
											<td style="text-align: center">
												<form:radiobutton path="method.operation.parameters[${loop.index}].parameterType"
													value="TABLE_NAME" disabled="true" />
											</td>
										</c:if>

										<c:if
											test="${method.metrics.granularity == 'Column' || method.metrics.granularity == 'ColumnSet'}">
											<td style="text-align: center">
												<form:radiobutton path="method.operation.parameters[${loop.index}].parameterType"
													value="COLUMN_NAME" disabled="true" />
											</td>
										</c:if>
										<td style="text-align: center">
											<c:if test="${method.metrics.connectToDB}">
												<form:radiobutton path="method.operation.parameters[${loop.index}].parameterType"
													value="CONNECT_TO_DB" disabled="true" />
											</c:if>
										</td>

									</tr>
								</c:forEach>
							</tbody>
						</table>
					</div>
				</c:otherwise>
			</c:choose>
			<hr>
<!-- 			<div class="form-group row"> -->
<!-- 				<input type="checkbox" id="chkOperationCleanWS" disabled="disabled"> Clean data of web service after execute instanced metrics -->
<!-- 			</div> -->
<!-- 			<div id="divOperationCleanWS" class="form-group row"> -->
<!-- 				<label class="col-md-4 col-form-label">Operation Clean Web Service </label> -->
<%-- 				<div class="col-md-6" style="text-align: left">${method.operationCleanWS.name}</div> --%>
<!-- 			</div> -->
			

		</div>
	</div>
	<div id="popUpYesNo">
		<jsp:include page="../common/popUpDeleteYesNo.jsp" />
	</div>

	
	
</body>
</html>