<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>

<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<!DOCTYPE html>

<html lang="en">

<title>Metrics</title>
<head>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>


<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<link rel="stylesheet" type="text/css" href="resources/css/kiuPlusCss.css">

<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>

<link rel="stylesheet" href="resources/css/dataTables.bootstrap.min.css">
<script src="resources/js/jquery.dataTables.min.js"></script>
<script src="resources/js/dataTables.bootstrap.min.js"></script>


<script src="resources/GraphicHandler.js" /></script>
<script src="resources/UsersRequestsHandler.js"></script>
<script src="resources/ComunicationHandler.js" type="text/javascript"></script>
<script src="resources/Main.js" type="text/javascript"></script>

<script type="text/javascript">
	$(window).ready(function() {

		//Deshabilita los campos cuando un metodo de la metrica tiene metricas instanciadas asociadas		
		if (${hasMethods} == true) {
			$('#cmbGranularity').prop('disabled', true);
		}
	});
	
	$(document).ready(function() {
		menuSideReLoadConfiguration("metrics", ${metrics.id});
	});
</script>

</head>

<body class="bodyCss">
	<div>
		<c:if test="${error != null }">
			<div class="alert alert-danger">${error}</div>
		</c:if>
		<form:form method="POST" commandName='metrics'
			action="${pageContext.request.contextPath}/configurationMetricsCreateOrEdit.html">

			<c:choose>
				<c:when test="${metrics.id == 0}">
					<h3>Create metrics</h3>
				</c:when>
				<c:when test="${metrics.id != 0}">
					<h3>Edit metrics</h3>
				</c:when>
			</c:choose>
			<div class="col-md-12">
				<hr>
			</div>
			<div class="col-md-10 col-md-offset-1">


				<div class="form-group row">
					<label class="col-md-2">Dimension </label>
					<div class="col-md-5" style="text-align: left">${metrics.factor.dimension.name}</div>
				</div>
				<div class="form-group row">
					<label class="col-md-2">Factor </label>
					<div class="col-md-5" style="text-align: left">${metrics.factor.name}</div>
				</div>
				<div class="form-group row">
					<hr>
				</div>
				<div class="form-group row">
					<label class="col-md-2 col-form-label">Name* </label>
					<div class="col-md-5">
						<form:input path="name" type="text" class="form-control" maxlength="45" />
					</div>
					<form:errors path="name" cssClass="alert alertValidation alert-danger col-md-4" element="div" />

				</div>
				<div class="form-group row">
					<label class="col-md-2 col-form-label">Description* </label>
					<div class="col-md-5">
						<form:textarea path="description" class="form-control" maxlength="1000" />
					</div>
					<form:errors path="description" cssClass="alert alertValidation alert-danger col-md-5"
						element="div" style="margin-bottom:0px" />
				</div>
				<div class="form-group row">
					<label class="col-md-2 col-form-label">Granularity* </label>
					<div class="col-md-5">
						<form:select path="granularity" id="cmbGranularity" class="form-control">
							<form:options items="${granularityList}" itemLabel="text" />
						</form:select>
					</div>
					<form:errors path="granularity" cssClass="alert alertValidation alert-danger col-md-4"
						element="div" />
				</div>
				<br>
				<div class="row form-actions col-md-12" align="center">
					<button type="submit" class="btn btn-success">
						<span class="glyphicon glyphicon-ok"></span>
						Save
					</button>
				</div>
			</div>
		</form:form>
	</div>
</body>
</html>