<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<!DOCTYPE html>

<html lang="en">
<head>

<script type="text/javascript">


$(document).ready(function() {
	<c:if test="${not empty resultAggExecute}">
		<c:forEach items="${resultAggExecute}" var="result">
			<c:if test="${result.key != null}">
				formatTable('dataTable_' + ${result.key.id});
			</c:if>
		</c:forEach>
	</c:if>
	GraphicHandler.hideLoader();
});

function printPDFResultExecute(){	    
  var pdfFrame = window.frames["iframePrint"];
  pdfFrame.focus();
  pdfFrame.print();
}

	
</script>
<title>Result of Execute Aggregations</title>
</head>
<body class="bodyCss">
	<div>

		<c:if test="${error != null }">
			<div class="alert alert-danger alert-dismissible">
				<!-- <button type="button" class="close" data-dismiss="alert" aria-label="Close">
					<span aria-hidden="true">&times;</span>
				</button> -->
				${error}
			</div>
		</c:if>
		<c:if test="${not empty errorAggList}">
			<div class="alert alert-danger alert-dismissible">
				<button type="button" class="close" data-dismiss="alert" aria-label="Close">
					<span aria-hidden="true">&times;</span>
				</button>
				<ul class="list-unstyled">
					<c:forEach items="${errorAggList}" var="errorList">
						<li>${errorList}</li>
					</c:forEach>
				</ul>
			</div>
		</c:if>
		<c:choose>
			<c:when test="${error == null }">
				<div class="col-md-12">
					<div class="col-md-6">
						<h3>Result of Execute Aggregations</h3>
					</div>
					<div class="col-md-6" align="right" style="margin-top: 10px">
						<a href="qualityModelDataModelResultExportPDF?id=${dataModel.id}&download=true"
							style="margin-right: 10px;">
							<img alt="" src="resources/images/icon_pdf.png" width="40px">
						</a>
						<a onclick="printPDFResultExecute()">
							<img alt="" src="resources/images/icon_print.png" width="40px">
						</a>
					</div>
					<div class="col-md-12">
						<hr>
					</div>
				</div>
				<div class="col-md-10 col-md-offset-1">

			<div class="form-group row">
				<label class="col-md-2 col-form-label">Data Quality Model</label>
				<div class="col-md-5" style="text-align: left">${dataModel.name}</div>
			</div>
			<div class="col-md-12">
				<hr>
			</div>
			<div style="text-align: left;">
				<c:if test="${not empty resultAggExecute}">
					<!-- Agregaciones -->
					<div class="form-group row">
						<label class="col-md-12 col-form-label">Aggregations</label>
						<br>
						<div class="col-md-10 col-md-offset-1">
							<c:forEach items="${resultAggExecute}" var="result">
								<c:if test="${not empty result.value}">
									<div>
										<div>
											<h4>${result.key.name}</h4>
										</div>
										<div class="form-group row">
											<label class="col-md-3 col-form-label">End granularity</label>
											<div class="col-md-9" style="text-align: left">${result.key.granularity}</div>
										</div>
										<div class="form-group row">
											<label class="col-md-3 col-form-label">Instanced metrics</label>

											<div class="col-md-9" style="text-align: left">
												<c:forEach var="parameterValue" items="${result.key.parameterValues}" varStatus="status">
													<c:if test="${parameterValue.parameter.parameterType == 'TABLE_NAME'}">
															${parameterValue.instancedMetric.name}
															<br>
													</c:if>
												</c:forEach>
											</div>
										</div>
										<div class="panel panel-default center-block" id="divParameterNotEmpty"
											onload="visbilityTable(${result.value})">
											<table id="dataTable_${result.key.id}" class="table table-striped">
												<thead>
													<tr>
														<c:forEach items="${result.value[0].properties}" var="propertie">
															<th class="text-center">${propertie.key}</th>
														</c:forEach>
													</tr>
												</thead>
												<tbody>
													<c:forEach items="${result.value}" var="genericObject">
														<tr>
															<c:forEach items="${genericObject.properties}" var="mapElement">
																<c:forEach items="${mapElement.value}" var="listElement">
																	<td class="text-center">${listElement}</td>
																</c:forEach>
															</c:forEach>
														</tr>

													</c:forEach>

												</tbody>
											</table>
										</div>
										<hr>
									</div>
								</c:if>
							</c:forEach>
						</div>
					</div>
				</c:if>

			</div>
		</div>
			</c:when>
			<c:otherwise>
				<div class="col-md-12">
					<div class="col-md-6">
						<h3>Result of Execute Aggregations</h3>
					</div>
					<div class="col-md-12">
						<hr>
					</div>
				</div>
			</c:otherwise>
		</c:choose>
	</div>
	<div id="divPrint">
		<iframe id="iframePrint" name="iframePrint"
			src="qualityModelDataModelResultExportPDF?id=${dataModel.id}&download=false"
			style="display: none"></iframe>
	</div>
</body>
</html>