<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>

<!DOCTYPE html>

<html lang="en">

<title>Execute</title>

<head>
<link rel="shortcut icon" href="resources/images/favicon.png" type="image/png">
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
<!-- <link rel="stylesheet" type="text/css" href="resources/css/kiuPlusCss.css"> -->
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
<link rel="stylesheet" href="resources/css/dataTables.bootstrap.min.css">
<script src="resources/js/jquery.dataTables.min.js"></script>
<script src="resources/js/dataTables.bootstrap.min.js"></script>

<script src="resources/GraphicHandler.js" /></script>
<script src="resources/UsersRequestsHandler.js"></script>
<script src="resources/ComunicationHandler.js"></script>
<script src="resources/Main.js"></script>

<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">

<script type="text/javascript">
	$(window).on('load', function() {
		$(".loader").fadeOut("slow");

	});

	function autoResize(obj) {

		var height = obj.contentDocument.body.scrollHeight;
		obj.style.height = height + 'px';
	}
</script>
</head>

<body class="bodyCss">
	<header>
		<jsp:include page="../menuBar.jsp" />
	</header>
	<div id="loader" class="loader"></div>

	<div>

		<c:if test="${error != null }">
			<div class="alert alert-danger">${error}</div>
		</c:if>


		<div class="col-md-6">
			<h3>Execute</h3>
		</div>
		<div class="col-md-12">
			<hr>
		</div>
		<div class="col-md-10 col-md-offset-1">

			<div class="form-group row">
				<label class="col-md-2 col-form-label">Data Quality Model * </label>
				<div class="col-md-5">
					<select id="cbDataQualityModel" class="form-control"
						onchange="UsersRequestsHandler.dataQualityModelExecutePage()">
						<option value="0" label="..." />
						<c:forEach var="qualityModel" items="${dataQualityModels}" varStatus="loop">
							<option value="${qualityModel.id}" label="${qualityModel.name}" />
						</c:forEach>
					</select>
				</div>
			</div>

			<div class="form-group row">
				<label class="col-md-2 col-form-label">Type * </label>
				<div class="col-md-5">
					<select id="cbType" class="form-control"
						onchange="UsersRequestsHandler.dataQualityModelExecutePage()">
						<option value="" label="..." />
						<option value="IMPartialAgreg" label="Instanced metrics and partial aggregations" />
						<option value="Agregregations" label="Aggregations" />
					</select>
				</div>
				<form:errors path="type" cssClass="alert alert-danger alertValidation col-md-4" element="div" />
			</div>


			<div id="divSelectIMAgg"></div>
			<div id="divResult" class="form-group row">
			</div>
		</div>

	</div>
</body>
</html>