<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1"
	pageEncoding="ISO-8859-1"%>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<!DOCTYPE html>

<html lang="en">
<head>

<script type="text/javascript">


$(document).ready(function() {
	<c:if test="${not empty resultIMExecute}">
		<c:forEach items="${resultIMExecute}" var="result">
			<c:if test="${result.key != null}">
				formatTable('dataIM_' + ${result.key.id});
			</c:if>
		</c:forEach>
	</c:if>

	<c:if test="${not empty resultAggExecute}">
		<c:forEach items="${resultAggExecute}" var="result">
			<c:if test="${result.key != null}">
				formatTable('dataAggTable_' + ${result.key.id});
			</c:if>
		</c:forEach>
	</c:if>
	
	<c:if test="${not empty resultComposedIMExecute}">
		<c:forEach items="${resultComposedIMExecute}" var="result">
			<c:if test="${result.key != null}">
				formatTable('dataComposedIMTable_' + ${result.key.id});
			</c:if>
		</c:forEach>
	</c:if>
	
	
	
	formatTable('dataAggregationTable');
	menuSideReLoadQualityModel(${dataModel.id}, "", -1);
});

function printPDFResultExecute(){	    
  var pdfFrame = window.frames["iframePrint"];
  pdfFrame.focus();
  pdfFrame.print();
}

	
</script>
<title>Result of Execute ${dataModel.name}</title>
</head>
<body class="bodyCss">
	<!-- 	<div id="loader" class="loader"></div> -->
	<div>

		<c:if test="${error != null }">
			<div class="alert alert-danger">${error}</div>
		</c:if>

		<!-- 			Descargar PDF y imprimir -->
		<div class="col-md-12" align="right" style="margin-top: 10px">
			<a
				href="qualityModelDataModelResultExportPDF?id=${dataModel.id}&download=true"
				style="margin-right: 10px;">
				<img alt="" src="resources/images/icon_pdf.png" width="40px">
			</a>
			<a onclick="printPDFResultExecute()">
				<img alt="" src="resources/images/icon_print.png" width="40px">
			</a>
		</div>
		<div class="col-md-12">
			<hr>
		</div>
		<div class="col-md-10 col-md-offset-1">
			<c:if
				test="${empty resultIMExecute and empty resultAggExecute and empty resultIMComposedExecute}">
				<label class="col-md-12">No execution results for the
					selected data model</label>
			</c:if>
		</div>
		<div style="text-align: left;">
			<c:if test="${not empty resultIMExecute}">
				<!-- Metricas instanciadas -->
				<label class="col-md-12 col-form-label">Instanced Metrics</label>
				<br>

				<div class="col-md-10 col-md-offset-1">
					<c:forEach items="${resultIMExecute}" var="result">

						<span class="cssSpanSubtitle">${result.key.name} </span>
						<br>

						<c:if test="${empty result.value}">
							<div>
								Has not results <br> <br>
							</div>
						</c:if>
						<c:if test="${not empty result.value}">
							<div>

								<div class="row">
									<label class="col-md-4">Date of execution</label>

									<div class="col-md-8" style="text-align: left">
										<fmt:formatDate pattern="dd/MM/yyyy HH:mm:ss"
											value="${result.key.dateTimeResult}" />
									</div>
								</div>
								<div class=" panel panel-default center-block"
									id="divParameterNotEmpty"
									onload="visbilityTable(${result.value})">
									<table id="dataIM_${result.key.id}"
										class="table table-striped ">
										<thead>
											<tr>

												<c:forEach items="${result.value[0].properties}"
													var="propertie">
													<th class="text-center">${propertie.key}</th>
												</c:forEach>
											</tr>
										</thead>
										<tbody>
											<c:forEach items="${result.value}" var="genericObject">
												<tr>
													<c:forEach items="${genericObject.properties}"
														var="mapElement">
														<td class="text-center">
															<c:choose>
																<c:when test="${mapElement.value == null}">
																	<label
																		style="color: gray; font-weight: normal; font-style: italic;">null</label>
																</c:when>
																<c:otherwise>
																      		${mapElement.value}
																</c:otherwise>
															</c:choose>
														</td>
													</c:forEach>
												</tr>

											</c:forEach>

										</tbody>
									</table>
								</div>
							</div>
						</c:if>
						<hr>
					</c:forEach>
				</div>
			</c:if>
			<!-- Aggregaciones -->
			<c:if test="${not empty resultAggExecute}">
				<div class="form-group row">
					<br>
					<label class="col-md-12 col-form-label">Aggregations</label>
					<br>
					<div class="col-md-10 col-md-offset-1">
						<c:forEach items="${resultAggExecute}" var="result">
							<div>
								<div>
									<span class="cssSpanSubtitle">${result.key.name}</span>
									<br>
								</div>
								<div class="form-group row">
									<label class="col-md-3 col-form-label">End granularity</label>
									<div class="col-md-9" style="text-align: left">${result.key.granularity}</div>
								</div>
								<div class="form-group row">
									<label class="col-md-3 col-form-label">Instanced
										metrics</label>

									<div class="col-md-9" style="text-align: left">
										<c:forEach var="parameterValue"
											items="${result.key.parameterValues}" varStatus="status">
											<c:if
												test="${parameterValue.parameter.parameterType == 'TABLE_NAME'}">
												${parameterValue.instancedMetric.name}
												<br>
											</c:if>
										</c:forEach>
									</div>
								</div>
								<div class="row">
									<c:choose>
										<c:when test="${empty result.value}">
											<div>
												Has not results <br> <br>
											</div>
										</c:when>
										<c:otherwise>
											<div class=" panel panel-default center-block"
												id="divParameterNotEmpty"
												onload="visbilityTable(${result.value})">
												<table id="dataAggTable_${result.key.id}"
													class="table table-striped ">
													<thead>
														<tr>
															<c:forEach items="${result.value[0].properties}"
																var="propertie">
																<th class="text-center">${propertie.key}</th>
															</c:forEach>
														</tr>
													</thead>
													<tbody>
														<c:forEach items="${result.value}" var="genericObject">
															<tr>
																<c:forEach items="${genericObject.properties}"
																	var="mapElement">
																	<c:forEach items="${mapElement.value}"
																		var="listElement">
																		<td class="text-center">${listElement}</td>
																	</c:forEach>
																</c:forEach>
															</tr>
														</c:forEach>
													</tbody>
												</table>
											</div>
										</c:otherwise>
									</c:choose>
								</div>
							</div>
							<hr>
						</c:forEach>
					</div>
				</div>
			</c:if>

			<!-- Composed IM -->
			<c:if test="${not empty resultComposedIMExecute}">
				<div class="form-group row">
					<br>
					<label class="col-md-12 col-form-label">Composed Instanced
						Metrics</label>
					<br>
					<div class="col-md-10 col-md-offset-1">
						<c:forEach items="${resultComposedIMExecute}" var="result">
							<div>
								<div>
									<span class="cssSpanSubtitle">${result.key.name}</span>
									<br>
								</div>
								<div class="form-group row">
									<label class="col-md-3 col-form-label">End granularity</label>
									<div class="col-md-9" style="text-align: left">${result.key.granularity}</div>
								</div>
								<div class="form-group row">
									<label class="col-md-3 col-form-label">Instanced
										Metrics</label>

									<div class="col-md-9" style="text-align: left">
										<c:forEach var="parameterValue"
											items="${result.key.parameterValues}" varStatus="status">
											<c:if
												test="${parameterValue.parameter.parameterType == 'TABLE_NAME'}">
												${parameterValue.instancedMetric.name}
												<br>
											</c:if>
										</c:forEach>
									</div>
								</div>
								<div class="row">
									<c:choose>
										<c:when test="${empty result.value}">
											<div>
												Has not results <br> <br>
											</div>
										</c:when>
										<c:otherwise>
											<div class=" panel panel-default center-block"
												id="divParameterNotEmpty"
												onload="visbilityTable(${result.value})">
												<table id="dataComposedIMTable_${result.key.id}"
													class="table table-striped ">
													<thead>
														<tr>
															<c:forEach items="${result.value[0].properties}"
																var="propertie">
																<th class="text-center">${propertie.key}</th>
															</c:forEach>
														</tr>
													</thead>
													<tbody>
														<c:forEach items="${result.value}" var="genericObject">
															<tr>
																<c:forEach items="${genericObject.properties}"
																	var="mapElement">
																	<c:forEach items="${mapElement.value}"
																		var="listElement">
																		<td class="text-center">${listElement}</td>
																	</c:forEach>
																</c:forEach>
															</tr>
														</c:forEach>
													</tbody>
												</table>
											</div>
										</c:otherwise>
									</c:choose>
								</div>
							</div>
							<hr>
						</c:forEach>
					</div>
				</div>
			</c:if>
		</div>

	</div>
	<div id="divPrint">
		<iframe id="iframePrint" name="iframePrint"
			src="qualityModelDataModelResultExportPDF?id=${dataModel.id}&download=false"
			style="display: none"></iframe>
	</div>
</body>
</html>