<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<!DOCTYPE html>

<html lang="en">
<head>

<script type="text/javascript">


$(document).ready(function() {
	<c:if test="${not empty resultIMExecute}">
		<c:forEach items="${resultIMExecute}" var="result">
			<c:if test="${result.key != null}">
				formatTable('dataTable_' + ${result.key.id});
			</c:if>
		</c:forEach>
	</c:if>
	GraphicHandler.hideLoader();
});

function printPDFResultExecute(){	    
  var pdfFrame = window.frames["iframePrint"];
  pdfFrame.focus();
  pdfFrame.print();
}

	
</script>
<title>Result of Execute Instanced Metrics</title>
</head>
<body class="bodyCss">
	<div>

		<c:if test="${error != null }">
			<div class="alert alert-danger">${error}</div>
		</c:if>
		<div class="col-md-12">
			<div class="col-md-6">
				<h3>Result of Execute Instanced Metrics</h3>
			</div>
			<div class="col-md-6" align="right" style="margin-top: 10px">
				<a href="qualityModelDataModelResultExportPDF?id=${dataModel.id}&download=true"
					style="margin-right: 10px;">
					<img alt="" src="resources/images/icon_pdf.png" width="40px">
				</a>
				<a onclick="printPDFResultExecute()">
					<img alt="" src="resources/images/icon_print.png" width="40px">
				</a>
			</div>
			<div class="col-md-12">
				<hr>
			</div>
		</div>
		<div class="col-md-10 col-md-offset-1">			

			<div class="form-group row">
				<label class="col-md-2 col-form-label">Data Quality Model</label>
				<div class="col-md-5" style="text-align: left">${dataModel.name}</div>
			</div>

			<!-- 			Descargar PDF y imprimir -->

			<div class="col-md-12">
				<hr>
			</div>
			<div class="col-md-10 col-md-offset-1">
				<c:if test="${empty resultIMExecute}">
					<label class="col-md-12">No execution results for the selected data model</label>
				</c:if>
			</div>
			<div style="text-align: left;">
				<c:if test="${not empty resultIMExecute}">
					<!-- Metricas instanciadas -->
					<div class="form-group row">
						<label class="col-md-12 col-form-label">Instanced Metrics</label>
						<br>

						<div class="col-md-10 col-md-offset-1">
							<c:forEach items="${resultIMExecute}" var="result">
								<c:if test="${not empty result.value}">
									<div>
										<div>
											<h4>${result.key.name} </h4>
										</div>
										<div class="row">
											<label class="col-md-3">Date of execution</label>

											<div class="col-md-9" style="text-align: left">
												<fmt:formatDate pattern="dd/MM/yyyy HH:mm:ss" value="${result.key.dateTimeResult}" />
											</div>
										</div>
										
										<div class=" panel panel-default center-block" id="divParameterNotEmpty"
											onload="visbilityTable(${result.value})">
											<table id="dataTable_${result.key.id}" class="table table-striped ">
												<thead>
													<tr>

														<c:forEach items="${result.value[0].properties}" var="propertie">
															<th class="text-center">${propertie.key}</th>
														</c:forEach>
													</tr>
												</thead>
												<tbody>
													<c:forEach items="${result.value}" var="genericObject">
														<tr>
															<c:forEach items="${genericObject.properties}" var="mapElement">
																<td class="text-center">
															<c:choose>
																<c:when test="${mapElement.value == null}">
																       <label style="color: gray;font-weight: normal;font-style: italic;">null</label> 
																</c:when>
																<c:otherwise>
																      	${mapElement.value}
																 </c:otherwise>
															</c:choose>
														</td>
															</c:forEach>
														</tr>

													</c:forEach>

												</tbody>
											</table>
										</div>
										<hr>
									</div>
								</c:if>
							</c:forEach>
						</div>
					</div>
				</c:if>

			</div>
		</div>
	</div>
	<div id="divPrint">
		<iframe id="iframePrint" name="iframePrint"
			src="qualityModelDataModelResultExportPDF?id=${dataModel.id}&download=false"
			style="display: none"></iframe>
	</div>
</body>
</html>