<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1"
	pageEncoding="ISO-8859-1"%>

<!DOCTYPE html>

<html lang="en">

<title>Composed Intanced Metric</title>

<head>

<script
	src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>


<link rel="stylesheet"
	href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<link rel="stylesheet" type="text/css"
	href="resources/css/kiuPlusCss.css">

<script
	src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>

<link rel="stylesheet" href="resources/css/dataTables.bootstrap.min.css">
<script src="resources/js/jquery.dataTables.min.js"></script>
<script src="resources/js/dataTables.bootstrap.min.js"></script>


<script src="resources/GraphicHandler.js" /></script>
<script src="resources/UsersRequestsHandler.js"></script>
<script src="resources/ComunicationHandler.js" type="text/javascript"></script>
<script src="resources/Main.js" type="text/javascript"></script>

<script type="text/javascript">
	$(window).on('load', function() {
		$(".loader").fadeOut("slow");
	});
	
	$(document).ready(function() {
		menuSideReLoadQualityModel(${composedIM.dataModel.id}, "Aggregation", ${composedIM.id});
		$('#divInstancedMetric2').prop("hidden", ${instancedMetric2 == null});
	});
	
// 	function qualityModelAggregationAddIM(){
// 		$('#divInstancedMetric2').prop("hidden", false);
// 		$('#btnAddIM').prop("hidden", true);
// 	}
	
	function composedIMRemoveIM(index){
		$('[id*=errorInstancedMetricSelect]').css('display', 'none');
		if($('[id*=divInstancedMetricSelect]').length > 2){
			$('#divInstancedMetricSelect' + index).remove();
			var val = $('#cbInstancedMetric' + index).val();
			if(val != -1){
				UsersRequestsHandler.composedIMLoadParameterIM();
			}
		}else{
			GraphicHandler.messageError("It cant be deleted, are necessary at least two instanced metrics.", "#errorInstancedMetricSelect" + index);
		}
	}
	

//		
//		$('#cbInstancedMetric2').val(-1);
//		$('#btnAddIM').prop("hidden", false);
</script>
</head>
<body class="bodyCss">
	<div id="loader" class="loader"></div>

	<div>

		<c:if test="${error != null }">
			<div class="alert alert-danger">${error}</div>
		</c:if>

		<form:form id="form" method="POST" modelAttribute="composedIM"
			action="${pageContext.request.contextPath}/qualityModelComposedIMCreateEdit.html">
			<div class="col-md-6">
				<c:choose>
					<c:when test="${composedIM.id == 0}">
						<h3>Create Composed Intanced Metric</h3>
					</c:when>
					<c:when test="${composedIM.id != 0}">
						<h3>Edit Composed Intanced Metric</h3>
					</c:when>
				</c:choose>
			</div>
			<div class="col-md-12">
				<hr>
			</div>
			<div class="col-md-10 col-md-offset-1">
				<div class="form-group row">
					<label class="col-md-3">Data Model</label>
					<div class="col-md-5" style="text-align: left">${composedIM.dataModel.name}</div>
				</div>
				<div class="form-group row">
					<hr>
				</div>
				<div class="form-group row">
					<label class="col-md-3 col-form-label">Name* </label>
					<div class="controls col-md-5">
						<form:input path="name" type="text" class="form-control"
							maxlength="45" />
					</div>
					<form:errors path="name"
						cssClass="alert alert-danger alertValidation col-md-4"
						element="div" />
				</div>


				<div id="divInstancedMetrics" class="form-group row">
					<div class="form-group row">
						<label class="col-md-3 col-form-label">Instanced Metrics*
						</label>
						<c:if test="${instancedMetricError != null }">
							<div class="alert alertValidation alert-danger col-md-9">${instancedMetricError}</div>
						</c:if>
					</div>

					<c:forEach items="${instancedMetricsSelected}" var="imSelected"
						varStatus="loop">
						<div id="divInstancedMetricSelect${loop.index}"
							class="form-group row">

							<div class="col-md-5 col-md-offset-3">
								<select id="cbInstancedMetric${loop.index}" class="form-control"
									onchange="UsersRequestsHandler.composedIMLoadParameterIM()"
									name="nameInstancedMetrics[]">
									<option value="" label="..." />
									<c:forEach items="${instancedMetrics}" var="im">
										<option value="${im.name}"
											<c:if test="${im.name == imSelected.name}"> selected </c:if>
											label="${im.fullName}" />
									</c:forEach>
								</select>
							</div>
							<div style="text-align: left;" class="col-md-1">
								<a type="button" class="btn btn-danger btn-sm"
									onclick="composedIMRemoveIM(${loop.index})">
									<span class="glyphicon glyphicon-minus"> </span>
								</a>
							</div>
						</div>
					</c:forEach>
				</div>

				<div style="text-align: left;" id="btnAddIM"
					class="col-md-9 col-md-offset-3 form-group">
					<a type="button" class="btn btn-success btn-sm"
						onclick="UsersRequestsHandler.composedIMAddIM(${composedIM.dataModel.id})">
						<span class="glyphicon glyphicon-plus"> </span>
					</a>
				</div>

				<div class="form-group row">
					<label class="col-md-3 col-form-label">End Granularity * </label>
					<div class="col-md-5">
						<form:select path="granularity" id="cmbGranularity"
							class="form-control">
							<form:option value="">...</form:option>
							<form:options items="${granularityList}" itemLabel="text" />
						</form:select>
					</div>
					<form:errors path="granularity"
						cssClass="alert alertValidation alert-danger col-md-4"
						element="div" />
				</div>
				<div class="form-group row" id="divUrl">
					<label class="col-md-3 col-form-label">URL* </label>
					<div class="col-md-7">
						<form:input id="txtWebServiceUrl" path="operation.webService.url"
							type="url" class="form-control" maxlength="2000" />
					</div>
					<div style="text-align: left;">
						<button id="btnValidate" type="button" class="btn btn-primary"
							onclick="UsersRequestsHandler.composedIMUrlWebServiceValidate(${dataModel.id})">Validate</button>
					</div>
					<div class="col-md-10" style="float: right;">
						<form:errors path="operation.webService.url"
							cssClass="alert alertValidation alert-danger" element="div"
							id="errorUrl" />
						<div id="divUrlError" class="alert alertValidation alert-danger"
							style="display: none;"></div>
					</div>
				</div>
				<div class="form-group row">
					<label class="col-md-3 col-form-label">Operation* </label>
					<div class="col-md-5">
						<form:select path="operation.name" id="cbOperations"
							class="form-control"
							onchange="UsersRequestsHandler.composedIMParametersLoad(this.value, ${dataModel.id})">
							<form:options
								items="${composedIM.operation.webService.operations}"
								itemLabel="name" itemValue="name" />
						</form:select>
					</div>
					<form:errors path="operation.name"
						cssClass="alert alertValidation alert-danger col-md-4"
						element="div" />

				</div>
				<div class="form-group row">
					<hr>
				</div>
				<div class="form-group row">
					<label class="col-md-3 col-form-label">Operation parameters</label>
					<br> Select the data for execute the Composed Intanced Metric
				</div>

				<!-- 				<div class="form-group row"> -->
				<%-- 					<form:errors path="operation.parameters" cssClass="alert alertValidation alert-danger col-md-9" --%>
				<%-- 						element="div" style="margin-bottom: 0px" /> --%>
				<!-- 				</div> -->
				<div class="form-group row">
					<form:errors path="parameterValues"
						cssClass="alert alertValidation alert-danger col-md-12"
						element="div" />
					<div id="divParameterEmpty" style="display: none;">The
						operation has no parameters</div>
					<div id="MIError" class="alert alertValidation alert-danger"
						style="display: none;"></div>
				</div>
				<div class=" panel panel-default center-block"
					id="divParameterNotEmpty"
					onload="visbilityTable(${composedIM.parameterValues})">
					<table id="tableParameters" class="table table-striped">
						<thead>
							<tr>
								<th class="text-center col-md-2">Name</th>
								<th class="text-center col-md-1">Data type</th>
								<th class="text-center col-md-3">Type</th>
								<th class="text-center col-md-4">Value</th>
							</tr>
						</thead>
						<tbody id="tableParametersBody">
							<c:forEach var="parameterValue"
								items="${composedIM.parameterValues}" varStatus="loop">
								<tr>
									<!-- 										Nombre -->
									<td style="text-align: center">
										<input type="hidden" value="${parameterValue.parameter.name}"
											name="parameterValues[${loop.index}].parameter.name">
										<form:label
											path="parameterValues[${loop.index}].parameter.name">${parameterValue.parameter.name}</form:label>
									</td>
									<!-- 											Tipo -->
									<td style="text-align: center">
										<input type="hidden"
											value="${parameterValue.parameter.dataType}"
											name="parameterValues[${loop.index}].parameter.dataType">
										${parameterValue.parameter.dataType.text}
									</td>

									<td style="text-align: center">
										<form:select
											path="parameterValues[${loop.index}].parameter.parameterType"
											class="form-control"
											onchange="UsersRequestsHandler.composedIMTypeParameterChange(${dataModel.id}, this.value,'${parameterValue.parameter.name}', ${loop.index})">
											<form:option value="" label="..." />
											<form:option value="ATTRIBUTE"
												label="Result of" />
											<form:option value="REFERENCE" label="Reference" />
										</form:select>
									</td>
									<td style="text-align: center"
										id="td${parameterValue.parameter.name}Value">

										<c:if
											test="${parameterValue.parameter.parameterType == 'ATTRIBUTE'}">

											<form:select
												path="parameterValues[${loop.index}].instancedMetric.name"
												id="cbParameterInstancedMetrics" class="form-control">
												<form:option value="" label="..." />
												<%-- 												<form:option value="${instancedMetric1.name}" label="${instancedMetric1.name}" /> --%>
												<%-- 												<c:if test="${instancedMetric1 != null}"> --%>
												<%-- 													<form:option value="${instancedMetric2.name}" label="${instancedMetric2.name}" /> --%>
												<%-- 												</c:if> --%>
												<c:forEach items="${instancedMetricsSelected}" var="im">
													<option value="${im.name}"
														<c:if test="${im.name == parameterValue.instancedMetric.name}"> selected </c:if>
														label="${im.fullName}" />
												</c:forEach>
											</form:select>

										</c:if>

										<c:if
											test="${parameterValue.parameter.parameterType == 'REFERENCE'}">
											<form:input
												path="parameterValues[${loop.index}].referenceValue"
												type="text" class="form-control" maxlength="45" />
										</c:if>

									</td>
								</tr>
							</c:forEach>
						</tbody>
					</table>
				</div>
			</div>
			<div class="row form-actions col-md-12" align="center">
				<button type="submit" class="btn btn-success">
					<span class="glyphicon glyphicon-ok"></span>
					Save
				</button>
			</div>

		</form:form>
	</div>

</body>
</html>