<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>

<!DOCTYPE html>

<html lang="en">

<title>Composed Intanced Metric</title>

<head>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>


<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<link rel="stylesheet" type="text/css" href="resources/css/kiuPlusCss.css">

<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>

<link rel="stylesheet" href="resources/css/dataTables.bootstrap.min.css">
<script src="resources/js/jquery.dataTables.min.js"></script>
<script src="resources/js/dataTables.bootstrap.min.js"></script>


<script src="resources/GraphicHandler.js" /></script>
<script src="resources/UsersRequestsHandler.js"></script>
<script src="resources/ComunicationHandler.js" type="text/javascript"></script>
<script src="resources/Main.js" type="text/javascript"></script>

<script type="text/javascript">
	$(window).on('load', function() {
		$(".loader").fadeOut("slow");
		
	});
	
	$(document).ready(function() {
		menuSideReLoadQualityModel(${composedIM.dataModel.id} , "ComposedIM", ${composedIM.id});
		
	});
	
</script>
</head>
<body class="bodyCss">
	<div id="loader" class="loader"></div>

	<div>
		<fieldset>
			<c:if test="${error != null }">
				<div class="alert alert-danger">${error}</div>
			</c:if>

			<div class="col-md-6">
				<h3>Composed Instanced Metric: ${composedIM.name}</h3>
			</div>

			<div class="col-md-5" align="right" style="margin-top: 10px">
				<a class="btn btn-primary  btn-md"
					href="qualityModelComposedIMEditPage?idComposedIM=${composedIM.id}">
					<span class="glyphicon glyphicon-pencil"></span>
					Edit
				</a>
				<!-- 				<a class="btn btn-success btn-md" -->
				<%-- 					href="qualityModelDataModelExecuteComposedIM?id=${composedIM.id}">Execute</a> --%>
				<!-- 				<a class="btn btn-default btn-md" -->
				<%-- 					href="qualityModelDataModelExecuteComposedIMResultPage?id=${composedIM.id}">Result of the --%>
				<!-- 					execution</a> -->
				<a class="btn btn-danger  btn-md" data-toggle="modal" data-target="#confirmationModal"
					onclick="setUrlOkModal('${pageContext.request.contextPath}/qualityModelComposedIMDeletePage?id=${composedIM.id}&idDataModel=${composedIM.dataModel.id}', 'ComposedIM', '${composedIM.name}'); return false;">
					<span class="glyphicon glyphicon-trash"></span>
					Delete
				</a>
			</div>
			<div class="col-md-12">
				<hr>
			</div>

			<!-- 			<div class="col-md-12" style="text-align: center;"> -->
			<!-- 				<hr> -->
			<%-- 				<span class="cssSpanTitle">${composedIM.name}</span> --%>

			<!-- 			</div> -->

			<div class="col-md-10 col-md-offset-1">
				<div class="form-group row">
					<label class="col-md-2 col-form-label">Data Model</label>
					<div class="col-md-5" style="text-align: left">${composedIM.dataModel.name}</div>
				</div>
				<div class="form-group row" id="divUrl">
					<label class=" col-md-2">End Granularity </label>
					<div class="col-md-10" style="text-align: left">${composedIM.granularity}</div>
				</div>
				<div class="form-group row" id="divUrl">
					<label class=" col-md-2">URL </label>
					<div class="col-md-10" style="text-align: left">${composedIM.operation.webService.url}</div>
				</div>
				<div class="form-group row">
					<label class="col-md-2">Operation </label>
					<div class="col-md-5" style="text-align: left">${composedIM.operation.name}</div>
				</div>

				<div class="form-group row">
					<hr>
				</div>
				<div class="form-group row">
					<label class="col-md-3">Operation parameters</label>
					<br> Data for execute the Composed Intanced Metric
				</div>

				<div class="form-group row">
					<c:choose>
						<c:when test="${empty composedIM.parameterValues}">
							<div>The operation has no parameters</div>
						</c:when>
						<c:otherwise>

							<div class=" panel panel-default center-block" id="divParameterNotEmpty"
								onload="visbilityTable(${composedIM.parameterValues})">
								<table id="tableParameters" class="table table-striped">
									<thead>
										<tr>
											<th class="text-center col-md-2">Name</th>
											<th class="text-center col-md-2">Data type</th>
											<th class="text-center col-md-2">Type</th>
											<th class="text-center col-md-2">Value</th>
										</tr>
									</thead>
									<tbody id="tableParametersBody">
										<c:forEach var="parameterValue" items="${composedIM.parameterValues}" varStatus="loop">
											<tr>
												<!-- 											Name -->
												<td style="text-align: center">
													<label>${parameterValue.parameter.name}</label>
												</td>
												<!-- 												Data type -->
												<td style="text-align: center">${parameterValue.parameter.dataType.text}</td>
												<!-- 												Type -->
												
												<td style="text-align: center">
													<c:if test="${parameterValue.parameter.parameterType == 'ATTRIBUTE'}">
														Result of													
													</c:if>
													<c:if test="${parameterValue.parameter.parameterType == 'REFERENCE'}">
														Reference
													
													</c:if>
												</td>
												
												<!-- 												Value -->
												<td style="text-align: center">
													<c:if test="${parameterValue.parameter.parameterType == 'ATTRIBUTE'}">
														${parameterValue.instancedMetric.fullName}														
													</c:if>
													<c:if test="${parameterValue.parameter.parameterType == 'REFERENCE'}">
														${parameterValue.referenceValue}
													
													</c:if>
												</td>
										</c:forEach>
									</tbody>
								</table>
							</div>

						</c:otherwise>
					</c:choose>
				</div>
			</div>

		</fieldset>
		<!-- 				Modal -->
		<div id="popUpYesNo">
			<jsp:include page="../common/popUpDeleteYesNo.jsp" />
		</div>
	</div>

</body>
</html>