<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>

<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<!DOCTYPE html>

<html lang="en">

<title>Data Quality Model</title>

<head>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>


<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<link rel="stylesheet" type="text/css" href="resources/css/kiuPlusCss.css">

<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>

<link rel="stylesheet" href="resources/css/dataTables.bootstrap.min.css">
<script src="resources/js/jquery.dataTables.min.js"></script>
<script src="resources/js/dataTables.bootstrap.min.js"></script>


<script src="resources/GraphicHandler.js" /></script>
<script src="resources/UsersRequestsHandler.js"></script>
<script src="resources/ComunicationHandler.js" type="text/javascript"></script>
<script src="resources/Main.js" type="text/javascript"></script>

<script type="text/javascript">
	$(window).on('load', function() {
		$(".loader").fadeOut("slow")
	});

	$(function() {
		$('[data-toggle="tooltip"]').tooltip()
	})
</script>
</head>

<body class="bodyCss">
	<div id="loader" class="loader"></div>
	<div>

		<fieldset>
			<c:if test="${error != null }">
				<div class="alert alert-danger">${error}</div>
			</c:if>

			<c:if test="${message != null }">
				<div class="alert alert-success">${message}</div>
			</c:if>

			<form:form method="POST" commandName='dataModel'
				action="${pageContext.request.contextPath}/qualityModelDataModelCreateEdit.html">

				<c:choose>
					<c:when test="${dataModel.id == 0}">
						<h3>Add Data Quality Model</h3>
					</c:when>
					<c:when test="${dataModel.id != 0}">
						<h3>Edit Data Quality Model</h3>
					</c:when>
				</c:choose>


				<hr>
				<div class="control-label col-md-8 col-md-offset-2">
				<div class="control-label col-md-12">
					<div class="form-group">
						<div class="row">
							<label class="control-label col-md-3">Name * </label>
							<div class="controls col-md-5">
								<form:input path="name" type="text" class="form-control" maxlength="45" />
							</div>
							<form:errors path="name" cssClass="alert alert-danger alertValidation col-md-4" element="div" />
						</div>

						<br>
						<hr>
						<h4 align="left">Database</h4>

						<div class="row">
							<div class="col-md-12 cssDescription" style="text-align: left;">Setting up the connection to the database that have the data to evaluate.</div>
							<br>
							<br>
							<label class="control-label col-md-3">Name * </label>
							<div class="controls col-md-5">
								<form:input id="nameDatabase" path="databaseSource.name" type="text" class="form-control"
									maxlength="45" />
							</div>
							<form:errors path="databaseSource.name"
								cssClass="alert alert-danger alertValidation col-md-4" element="div" />
						</div>
						<div class="row">
							<label class="control-label col-md-3">Schema *</label>
							<div class="controls col-md-5">
								<form:input id="schema" path="databaseSource.schema" type="text" class="form-control"
									maxlength="200" />
							</div>
							<form:errors path="databaseSource.schema"
								cssClass="alert alert-danger alertValidation col-md-4" element="div" />
						</div>
						
						<div class="row">
							<label class="control-label col-md-3">Url * </label>
							<div class="controls col-md-5">
								<form:input id="url" path="databaseSource.url" type="text" class="form-control"
									maxlength="2000" />
							</div>
							<div class="col-md-1" style="text-align: left;">
								<span class="glyphicon glyphicon-question-sign" data-toggle="tooltip" data-placement="right"
									title="Url to connect to the database. e.g. jdbc:mysql://localhost:3306" style="color: #6E6E6E"></span>
							</div>
							<form:errors path="databaseSource.url" cssClass="alert alert-danger alertValidation col-md-4"
								element="div" />
						</div>

						<div class="row">
							<label class="control-label col-md-3">User *</label>
							<div class="controls col-md-5">
								<form:input id="user" path="databaseSource.user" type="text" class="form-control"
									maxlength="45" />
							</div>
							<form:errors path="databaseSource.user"
								cssClass="alert alert-danger alertValidation col-md-4" element="div" />
						</div>

						<div class="row">
							<label class="control-label col-md-3">Password * </label>
							<div class="controls col-md-5">
								<form:input id="password" path="databaseSource.password" type="password"
									class="form-control" maxlength="45" />
							</div>
							<form:errors path="databaseSource.password"
								cssClass="alert alert-danger alertValidation col-md-4" element="div" />
						</div>

						<div class="row">
							<label class="control-label col-md-3">System * </label>
							<div class="controls col-md-5">
								<form:select id="system" path="databaseSource.system" class="form-control">
									<form:option value="" label="..." />
									<form:options items="${enumDatabaseSystem}" />
								</form:select>
							</div>
							<form:errors path="databaseSource.system"
								cssClass="alert alert-danger alertValidation col-md-4" element="div" />
						</div>
						<div id="divResponse" class="row">
							<c:if test="${errorValidation != null}">
								<div class="alert alert-danger alertValidation col-md-8">${errorValidation}</div>
							</c:if>
						</div>
					</div>
					</div>
					<div class="form-group" align="center">

						<button type="button" class="btn btn-primary"
							onclick="UsersRequestsHandler.qualityModelConnectDatabaseTestConnection()">Test
							Connection</button>
						<button type="submit" class="btn btn-success">Save</button>

					</div>
				</div>

			</form:form>
		</fieldset>
	</div>

</body>
</html>