<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>

<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<!DOCTYPE html>

<html lang="en">

<title>Data Model Detail</title>
<head>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>


<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<link rel="stylesheet" type="text/css" href="resources/css/kiuPlusCss.css">

<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>

<link rel="stylesheet" href="resources/css/dataTables.bootstrap.min.css">
<script src="resources/js/jquery.dataTables.min.js"></script>
<script src="resources/js/dataTables.bootstrap.min.js"></script>


<script src="resources/GraphicHandler.js" /></script>
<script src="resources/UsersRequestsHandler.js"></script>
<script src="resources/ComunicationHandler.js" type="text/javascript"></script>
<script src="resources/Main.js" type="text/javascript"></script>

<script>
	$(document).ready(function() {
		formatTable('dtFactors');
		window.parent.$('#divMenuSide').css('visibility', 'hidden');
	});
</script>

</head>


<body class="bodyCss">

	<div>
		<c:if test="${message != null }">
			<div class="alert alert-success">${message}</div>
		</c:if>
		<c:if test="${error != null }">
			<div class="alert alert-danger">${error}</div>
		</c:if>
		<div class="row-fluid">
			<div class="span12"></div>
			<h3>Data Quality Models</h3>
			<hr>
		</div>

		<div class="row">
			<div class="col-sm-8 col-md-offset-2">

				<div>
					<fieldset>
						<div class="row">
							<div class="col-md-12" align="right">
								<a class="btn btn-success" href="qualityModelDataModelCreatePage"><span class="glyphicon glyphicon-plus"> </span> Data Quality Model</a>
							</div>

						</div>
						<br>

						<c:choose>
							<c:when test="${empty dataModels}">
								<div>There are no data quality models</div>
							</c:when>
							<c:otherwise>
								<div class=" panel panel-default center-block ">

									<table id="dtFactors" class="table table-striped ">
										<thead>
											<tr>
												<th class="text-center">Name</th>
												<th class="text-center"></th>
											</tr>
										</thead>
										<tbody>

											<c:forEach var="dataModel" items="${dataModels}" varStatus="status">
												<tr>
													<td>${dataModel.name}</td>

													<td align="center">
														<a class="btn btn-info  btn-sm"
															href="qualityModelDataModelShowPage?id=${dataModel.id}"><span class="glyphicon glyphicon-eye-open"></span> View</a>
<!-- 														<a class="btn btn-primary  btn-sm" -->
<%-- 															href="qualityModelDataModelEditPage?id=${dataModel.id}">Update</a> --%>
<!-- 														<a class="btn btn-danger  btn-sm" data-toggle="modal" data-target="#confirmationModal" -->
<%-- 															onclick="setUrlOkModal('${pageContext.request.contextPath}/qualityModelDataModelDeletePage?id=${dataModel.id}'); return false;"><span class="glyphicon glyphicon-trash"></span> Delete</a> --%>
													</td>

												</tr>
											</c:forEach>
										</tbody>
									</table>
								</div>
							</c:otherwise>
						</c:choose>

					</fieldset>
				</div>

			</div>
		</div>
<!-- 		<div id="popUpYesNo"> -->
<%-- 			<jsp:include page="../common/popUpYesNo.jsp" /> --%>
<!-- 		</div> -->
	</div>
</body>
</html>