<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>

<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<!DOCTYPE html>

<html lang="en">

<title>Data Quality Model</title>
<head>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>


<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">


<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>

<link rel="stylesheet" href="resources/css/dataTables.bootstrap.min.css">
<script src="resources/js/jquery.dataTables.min.js"></script>
<script src="resources/js/dataTables.bootstrap.min.js"></script>


<script src="resources/GraphicHandler.js" /></script>
<script src="resources/UsersRequestsHandler.js"></script>
<script src="resources/ComunicationHandler.js" type="text/javascript"></script>
<script src="resources/Main.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="resources/css/kiuPlusCss.css">

<script>
	window.addEventListener('load', function() {
		UsersRequestsHandler.instanceMetricsLoadTable(${dimensions}, "${pageContext.request.contextPath}");
	});
		
	$(document).ready(function() {
		menuSideReLoadQualityModel(${dataModel.id}, "", -1);
		$(".loader").fadeOut("slow");
	});
	
	$(function () {
		  $('[data-toggle="tooltip"]').tooltip()
	});
		
	function printPDFDataModel(){	    
	  var pdfFrame = window.frames["iframePrint"];
	  pdfFrame.focus();
	  pdfFrame.print();
	}
	
</script>

</head>


<body class="bodyCss">
	<div id="loader" class="loader" style="display: inline;"></div>
	<div>
		<c:if test="${message != null }">
			<div class="alert alert-success">${message}</div>
		</c:if>
		<c:if test="${error != null }">
			<div class="alert alert-danger">${error}</div>
		</c:if>


		<div class="col-md-8">
			<h3>Data Quality Model: ${dataModel.name}</h3>
		</div>
		<div class="col-md-4" align="right" style="margin-top: 10px">
			<a class="btn btn-primary  btn-md" href="qualityModelDataModelEditPage?id=${dataModel.id}"
				style="margin-right: 10px">
				<span class="glyphicon glyphicon-pencil"></span>
				Edit
			</a>
			<a class="btn btn-danger btn-md" data-toggle="modal" data-target="#confirmationModal"
				onclick="setUrlOkModal('${pageContext.request.contextPath}/qualityModelDataModelDeletePage?id=${dataModel.id}', 'Data Quality Model', '${dataModel.name}'); return false;"
				style="margin-right: 10px">
				<span class="glyphicon glyphicon-trash"></span>
				Delete
			</a>

			<a href="qualityModelDataModelExportPDF?idDataModel=${dataModel.id}&download=true"
				style="margin-right: 10px;">
				<img alt="" src="resources/images/icon_pdf.png" width="40px" data-toggle="tooltip"
					data-placement="auto" title="Export the data quality model to PDF document."
					class="red-tooltip">
			</a>
			<a onclick="printPDFDataModel()">
				<img alt="" src="resources/images/icon_print.png" width="40px" data-toggle="tooltip"
					data-placement="auto" title="Print the data quality model.">
			</a>

		</div>
		<div class="col-md-12">
			<hr>
		</div>
		<div class="form-group row">
			<h4 class="form-group row">Database</h4>
			<div class="form-group row col-md-11 col-md-offset-1 cssDescription">
				Configuration of the connection to the database to obtain the data that will be evaluated.<br>
			</div>
			<div class="form-group row">
				<label class="col-md-2 col-form-label">Name</label>
				<div class="col-md-5" style="text-align: left">${dataModel.databaseSource.name}</div>
			</div>
			<div class="form-group row">
				<label class="col-md-2 col-form-label">Schema</label>
				<div class="col-md-5" style="text-align: left">${dataModel.databaseSource.schema}</div>
			</div>
			<div class="form-group row">
				<label class="col-md-2 col-form-label">Url</label>
				<div class="col-md-5" style="text-align: left">${dataModel.databaseSource.url}</div>
			</div>

			<div class="form-group row">
				<label class="col-md-2 col-form-label">User</label>
				<div class="col-md-5" style="text-align: left">${dataModel.databaseSource.user}</div>
			</div>
			<div class="form-group row">
				<label class="col-md-2 col-form-label">System</label>
				<div class="col-md-4" style="text-align: left">${dataModel.databaseSource.system}</div>
			</div>
		</div>
		<div class="row">
			<hr>
		</div>
		<!-- 						Metricas isntanciadas -->
		<h4 class="col-md-6">Instanced Metrics</h4>
		<div class="col-md-6" align="right">
			<a class="btn btn-success"
				href="qualityModelInstancedMetricCreatePage?idDataModel=${dataModel.id}">
				<span class="glyphicon glyphicon-plus"> </span>
			</a>
		</div>
		<div class="col-md-12">
			<div class="panel panel-default center-block ">
				<table id="dtIM" class="table table-striped ">
					<thead>
						<tr>
							<th class="col-md-2">Dimension</th>
							<th class="col-md-2">Factor</th>
							<th class="col-md-2">Metric</th>
							<th class="col-md-2">Method</th>
							<th class="col-md-2">Instance Metrics</th>
							<th class="text-center"></th>

						</tr>
					</thead>
					<tbody id="tableIMBody">

					</tbody>
				</table>
			</div>
			<hr>
		</div>
		<h4 class="col-md-6">Aggregations</h4>
		<div class="col-md-6" align="right">
			<a type="button" class="btn btn-success"
				href="qualityModelAggregationCreatePage?idDataModel=${dataModel.id}">
				<span class="glyphicon glyphicon-plus"> </span>
			</a>
		</div>

		<div class="col-md-12" align="right">
			<c:choose>
				<c:when test="${empty dataModel.resultGroups}">
					<div style="text-align: left">There are no aggregations in the data model</div>
				</c:when>
				<c:otherwise>
					<div class=" panel panel-default center-block ">

						<table id="dtAggregation" class="table table-striped ">
							<thead>
								<tr>
									<th class="col-md-4">Name</th>
									<th class="text-center"></th>
								</tr>
							</thead>
							<tbody>

								<c:forEach var="aggregation" items="${dataModel.resultGroups}" varStatus="status">
									<c:if test="${aggregation.type == 'Aggregation'}">
										<tr>
											<td>${aggregation.name}</td>
										

											<td align="center">
												<a class="btn btn-info  btn-sm"
													href="qualityModelAggregationShowPage?id=${aggregation.id}">
													<span class="glyphicon glyphicon-eye-open"> </span>
													View
												</a>
											</td>

										</tr>
									</c:if>
								</c:forEach>
							</tbody>
						</table>
					</div>
				</c:otherwise>
			</c:choose>
				<hr>
		</div>
		<h4 class="col-md-6">Composed Instanced Metrics</h4>
		<div class="col-md-6" align="right">
			<a type="button" class="btn btn-success"
				href="qualityModelComposedIMCreatePage?idDataModel=${dataModel.id}">
				<span class="glyphicon glyphicon-plus"> </span>
			</a>
		</div>
		<div class="col-md-12" align="right">
			<c:choose>
				<c:when test="${empty dataModel.resultGroups}">
					<div style="text-align: left">There are no Composed Instanced Metric in the data model</div>
				</c:when>
				<c:otherwise>
					<div class=" panel panel-default center-block ">

						<table id="dtComposedInstancedMetric" class="table table-striped ">
							<thead>
								<tr>
									<th class="col-md-4">Name</th>
									<th class="text-center"></th>
								</tr>
							</thead>
							<tbody>

								<c:forEach var="composedIM" items="${dataModel.resultGroups}" varStatus="status">
									<c:if test="${composedIM.type == 'ComposedInstancedMetric'}">
										<tr>
											<td>${composedIM.name}</td>
										

											<td align="center">
												<a class="btn btn-info  btn-sm"
													href="qualityModelComposedIMShowPage?id=${composedIM.id}">
													<span class="glyphicon glyphicon-eye-open"> </span>
													View
												</a>
											</td>

										</tr>
									</c:if>
								</c:forEach>
							</tbody>
						</table>
					</div>
				</c:otherwise>
			</c:choose>
		</div>
		
	</div>
	<!-- 				Modal -->
	<div id="popUpYesNo">
		<jsp:include page="../common/popUpDeleteYesNo.jsp" />
	</div>

	<div id="divPrint">
		<iframe id="iframePrint" name="iframePrint"
			src="qualityModelDataModelExportPDF?idDataModel=${dataModel.id}&download=false"
			style="display: none"></iframe>
	</div>
</body>
</html>