<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>

<!DOCTYPE html>

<html lang="en">

<title>Instanced Metric</title>

<head>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>


<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<link rel="stylesheet" type="text/css" href="resources/css/kiuPlusCss.css">

<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>

<link rel="stylesheet" href="resources/css/dataTables.bootstrap.min.css">
<script src="resources/js/jquery.dataTables.min.js"></script>
<script src="resources/js/dataTables.bootstrap.min.js"></script>


<script src="resources/GraphicHandler.js" /></script>
<script src="resources/UsersRequestsHandler.js"></script>
<script src="resources/ComunicationHandler.js" type="text/javascript"></script>
<script src="resources/Main.js" type="text/javascript"></script>

<script type="text/javascript">
	$(window).on('load', function() {
		$(".loader").fadeOut("slow");
		
	});
	
	$(document).ready(function() {
		menuSideReLoadQualityModel(${instancedMetric.dataModel.id}, "InstancedMetric", ${instancedMetric.id});
		
		//Deshabilita los campos cuando la mi tiene agregaciones asociadas	
		if(${hasAggregations} == true){
			$('#cbDimensions').prop('disabled', true);
			$('#cbFactors').prop('disabled', true);
			$('#cbMetrics').prop('disabled', true);
			$('#cbMethods').prop('disabled', true);
			$('#tableParametersBody').find('select').prop('disabled', true);
			$('#tableParametersBody').find('input').prop('disabled', true);
			
		}
	});
	

</script>
</head>

<body class="bodyCss">
	<div id="loader" class="loader"></div>

	<div>

		<c:if test="${error != null }">
			<div class="alert alert-danger">${error}</div>
		</c:if>

		<form:form id="form" method="POST" modelAttribute="instancedMetric"
			action="${pageContext.request.contextPath}/qualityModelInstancedMetricCreateEdit.html">
			<div class="col-md-6">
				<c:choose>
					<c:when test="${instancedMetric.id == 0}">
						<h3>Create instanced metric</h3>
					</c:when>
					<c:when test="${instancedMetric.id != 0}">
						<h3>Edit Instanced Metric</h3>
					</c:when>
				</c:choose>
			</div>
			<div class="col-md-12">
				<hr>
			</div>
			<div class="col-md-12 col-md-offset-0">
				<div class="form-group row">
					<label class="col-md-2">Data Model</label>
					<div class="col-md-5" style="text-align: left">${instancedMetric.dataModel.name}</div>
				</div>
				<div class="form-group row">
					<hr>
				</div>
				<div class="form-group row">
					<label class="col-md-2 col-form-label">Name* </label>
					<div class="col-md-5">
						<form:input path="name" type="text" class="form-control" maxlength="45" />
					</div>
					<form:errors path="name" cssClass="alert alert-danger alertValidation col-md-5" element="div" />
				</div>
				<div class="form-group row">
					<label class="col-md-2 col-form-label">Dimension* </label>
					<div class="col-md-5">
						<form:select path="method.metrics.factor.dimension.id" id="cbDimensions" class="form-control"
							onchange="UsersRequestsHandler.factorsGet(this.value)">
							<form:option value="0" label="..." />
							<form:options items="${dimensions}" itemLabel="name" itemValue="id" />
						</form:select>
					</div>
					<form:errors path="method.metrics.factor.dimension"
						cssClass="alert alert-danger alertValidation col-md-4" element="div" />

				</div>

				<div class="form-group row">
					<label class="col-md-2 col-form-label">Factor* </label>
					<div class="col-md-5">
						<form:select path="method.metrics.factor.id" id="cbFactors" class="form-control"
							onchange="UsersRequestsHandler.metricsGet(this.value)"> --%>
 									<form:option value="0" label="..." />
							<form:options items="${factors}" itemLabel="name" itemValue="id" />
						</form:select>
					</div>
					<form:errors path="method.metrics.factor"
						cssClass="alert alert-danger alertValidation col-md-5" element="div" />
				</div>

				<div class="form-group row">
					<label class="col-md-2 col-form-label">Metrics* </label>
					<div class="col-md-5">
						<form:select path="method.metrics.id" id="cbMetrics" class="form-control"
							onchange="UsersRequestsHandler.instancedMetricsMethodsGet(this.value)">
							<form:option value="0" label="..." />
							<form:options items="${metrics}" itemLabel="name" itemValue="id" />
						</form:select>
					</div>
					<form:errors path="method.metrics" cssClass="alert alert-danger alertValidation col-md-5"
						element="div" />

				</div>
				<div class="form-group row">
					<label class="col-md-2 col-form-label">Granularity </label>
					<div class="col-md-5" style="text-align: left" id="lblGranularity">${instancedMetric.method.metrics.granularity}</div>
					<form:input id="inputGranularity" path="method.metrics.granularity" type="hidden" />
				</div>
				<div class="form-group row">
					<label class="col-md-2 col-form-label">Method* </label>
					<div class="col-md-5">
						<form:select path="method.id" id="cbMethods" class="form-control"
							onchange="UsersRequestsHandler.instancedMetricsParametersSet(${instancedMetric.dataModel.id},this.value)">
							<form:option value="0" label="..." />
							<form:options items="${methods}" itemLabel="name" itemValue="id" />
						</form:select>
					</div>
					<form:errors path="method" cssClass="alert alert-danger alertValidation col-md-4" element="div" />
				</div>
				<div class="form-group row">
					<hr>
				</div>
				
				<div class="form-group row">
					<label class="col-md-2 col-form-label">Web Service Url </label>
					<div id="divUrl" class="col-md-5" style="text-align: left">${instancedMetric.method.operation.webService.url}</div>
				</div>
				<div class="form-group row">
					<label class="col-md-2 col-form-label">Operation </label>
					<div id="divOperation" class="col-md-5" style="text-align: left">${instancedMetric.method.operation.name}</div>
				</div>
				<div class="form-group row">
					<label class="col-md-3 col-form-label">Operation parameters</label>
					<br>
					<div class="cssDescription">Select the data for execute the instance metric</div>
				</div>
				<label id="lblErrorParameter" class="alert alert-danger alertValidation" style="display: none;">
				</label>
				<form:errors id="parameterValuesError" path="parameterValues"
					cssClass="alert alert-danger alertValidation col-md-12 " element="div" style="text-align: left" />
				<div id="divParameterEmpty" style="display: none; text-align: left">The method has no
					parameters</div>

				<div class=" panel panel-default center-block" id="divParameterNotEmpty">
					<table id="tableParameters" class="table table-striped">
						<thead>
							<tr id="tableParametersHeadTr">
								<th class="text-center col-md-2" id="thParametersName">Name</th>
								<th class="text-center col-md-2">Data type</th>
								<th class="text-center col-md-2">Type</th>
								<th class="text-center col-md-2" id="thParametersTable">Table</th>
								<th class="text-center col-md-2" id="thParametersColumn">Column</th>
								<th class="text-center col-md-2" id="thParametersReferencial">Reference</th>
							</tr>
						</thead>
						<tbody id="tableParametersBody">
							<c:forEach var="parameterValue" items="${instancedMetric.parameterValues}" varStatus="loop">
								<tr>

									<!-- Parameter name -->
									<td style="text-align: center">
										<form:label path="parameterValues[${loop.index}].parameter.name">${parameterValue.parameter.name}</form:label>
									</td>

									<!-- Parameter type -->
									<td style="text-align: center">
										<form:label path="parameterValues[${loop.index}].parameter.dataType" cssClass="cssSpan">${parameterValue.parameter.dataType.text}</form:label>
									</td>
									<td style="text-align: center">
										<form:label path="parameterValues[${loop.index}].parameter.parameterType"
											cssClass="cssSpan">${parameterValue.parameter.parameterType.text}</form:label>
									</td>

									<c:if
										test="${parameterValue.parameter.parameterType == 'ATTRIBUTE' || parameterValue.parameter.parameterType == 'COLUMN_NAME'}">


										<!-- Table name -->

										<td style="text-align: center">
											<form:select path="parameterValues[${loop.index}].attribute.attributeTable.name"
												class="form-control"
												onchange="UsersRequestsHandler.instancedMetricsColumnsSet(${instancedMetric.dataModel.id},this.value, select${parameterValue.parameter.name}Column)">
												<form:option value="">...</form:option>
												<form:options items="${tables}" itemLabel="name" itemValue="name" />
											</form:select>
										</td>

										<!-- Column name -->
										<td style="text-align: center">
											<form:select id="select${parameterValue.parameter.name}Column"
												path="parameterValues[${loop.index}].attribute.name" class="form-control">
												<form:option value="">...</form:option>
												<c:forEach items="${tables}" var="table" varStatus="status">
													<c:if test="${table.name eq parameterValue.attribute.attributeTable.name}">
														<form:options items="${table.attributesColumns}" itemLabel="nameType" itemValue="name"></form:options>
													</c:if>
												</c:forEach>
											</form:select>
										</td>
										<td></td>
									</c:if>

									<c:if test="${parameterValue.parameter.parameterType == 'TABLE_NAME'}">
										<!-- Table name -->
										<td style="text-align: center">
											<form:select path="parameterValues[${loop.index}].attribute.name" class="form-control">
												<form:option value="">...</form:option>
												<form:options items="${tables}" itemLabel="name" itemValue="name" />
											</form:select>
										</td>
										<td></td>
										<td></td>
									</c:if>


									<c:if test="${parameterValue.parameter.parameterType == 'REFERENCE'}">
										<td></td>
										<td></td>
										<td>
											<form:input path="parameterValues[${loop.index}].referenceValue" type="text"
												class="form-control" maxlength="45" />
										</td>
									</c:if>

									<c:if test="${parameterValue.parameter.parameterType == 'CONNECT_TO_DB'}">
										<td></td>
										<td></td>
										<td></td>
									</c:if>
								</tr>
							</c:forEach>
						</tbody>
					</table>
				</div>
				<div class="row form-actions" align="center">
					<c:choose>
						<c:when test="${not empty instancedMetric.dateTimeResult}">
							<a class="btn btn-success" data-toggle="modal" data-target="#confirmationModal">
								<span class="glyphicon glyphicon-ok"></span>
								Save
							</a>
						</c:when>
						<c:otherwise>
							<button type="submit" class="btn btn-success">
								<span class="glyphicon glyphicon-ok"></span>
								Save
							</button>
						</c:otherwise>

					</c:choose>
				</div>

				<div class="modal fade" id="confirmationModal" tabindex="-1" role="dialog"
					aria-labelledby="exampleModalLabel" aria-hidden="true">
					<div class="modal-dialog modal-sm" role="document">
						<div class="modal-content">
							<div class="modal-header" style="border: none;">
								<label> Edit instanced metrics</label>
								<button type="button" class="close" data-dismiss="modal" aria-label="Close">
									<span aria-hidden="true">&times;</span>
								</button>
							</div>
							<div class="modal-body" style="border: none;">
								This instanced metrics has been executed, if it is edited, the execution will be deleted. <br>
								<br> Continue editing?
							</div>
							<div class="modal-footer" style="border: none;">
								<button type="submit" class="btn btn-danger btn-sm">
									Yes <i class="glyphicon glyphicon-warning-sign"></i>
								</button>
								<button type="button" data-dismiss="modal" class="btn btn-sm" style="width: 70px">No</button>
							</div>
						</div>
					</div>
				</div>
			</div>
		</form:form>
	</div>

</body>
</html>