<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1"
	pageEncoding="ISO-8859-1"%>

<!DOCTYPE html>

<html lang="en">

<title>Instanced Metric</title>

<head>

<script
	src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>


<link rel="stylesheet"
	href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<link rel="stylesheet" type="text/css"
	href="resources/css/kiuPlusCss.css">

<script
	src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>

<link rel="stylesheet" href="resources/css/dataTables.bootstrap.min.css">
<script src="resources/js/jquery.dataTables.min.js"></script>
<script src="resources/js/dataTables.bootstrap.min.js"></script>


<script src="resources/GraphicHandler.js" /></script>
<script src="resources/UsersRequestsHandler.js"></script>
<script src="resources/ComunicationHandler.js" type="text/javascript"></script>
<script src="resources/Main.js" type="text/javascript"></script>

<script type="text/javascript">
	$(window).on('load', function() {
		$(".loader").fadeOut("slow");
	});
	

	$(document).ready(function() {
		menuSideReLoadQualityModel(${instancedMetric.dataModel.id}, "InstancedMetric", ${instancedMetric.id});
	});
	
	
	var modal = document.getElementById('myModal');

	// Get the button that opens the modal
	var btn = document.getElementById("myBtn");

	// Get the <span> element that closes the modal
	var span = document.getElementsByClassName("close")[0];

	// When the user clicks on the button, open the modal 
	btn.onclick = function() {
	    modal.style.display = "block";
	}

	span.onclick = function() {
	    modal.style.display = "none";
	}

	// When the user clicks anywhere outside of the modal, close it
	window.onclick = function(event) {
	    if (event.target == modal) {
	        modal.style.display = "none";
	    }
	}
</script>
</head>

<body class="bodyCss" style="height: 80%">
	<div id="loader" class="loader"></div>
	<div>
		<c:if test="${error != null }">
			<div class="alert alert-danger">${error}</div>
		</c:if>
		<div class="col-md-9">
			<h3>Instanced Metric: ${instancedMetric.name}</h3>
		</div>

		<div class="col-md-3" align="right" style="margin-top: 10px">
			<a class="btn btn-primary  btn-"
				href="qualityModelInstancedMetricEditPage?idInstancedMetrics=${instancedMetric.id}">
				<span class="glyphicon glyphicon-pencil"></span>
				Edit
			</a>

			<c:choose>
				<c:when test="${not empty instancedMetric.dateTimeResult}">
					<a class="btn btn-danger  btn-md" data-toggle="modal"
						data-target="#confirmationDeleteModal">
						<span class="glyphicon glyphicon-trash"></span>
						Delete
					</a>
				</c:when>
				<c:otherwise>
					<a class="btn btn-danger  btn-md" data-toggle="modal"
						data-target="#confirmationModal"
						onclick="setUrlOkModal('${pageContext.request.contextPath}/qualityModelInstancedMetricDeletePage?id=${instancedMetric.id}', 'Instanced Metric', '${instancedMetric.name}'); return false;">
						<span class="glyphicon glyphicon-trash"></span>
						Delete
					</a>
				</c:otherwise>
			</c:choose>

		</div>
		<div class="col-md-12">
			<hr>
		</div>
		<!-- 			<div class="col-md-12" style="text-align: center;"> -->
		<!-- 				<hr> -->
		<%-- 				<span class="cssSpanTitle">${instancedMetric.name}</span> --%>
		<!-- 			</div> -->
		<div class="control-label col-md-12 col-md-offset-0">
			<div class="form-group row">
				<label class="col-md-2 col-form-label">Data Model </label>
				<div class="col-md-5" style="text-align: left">${instancedMetric.dataModel.name}</div>
			</div>

			<div class="col-md-12">
				<hr>
			</div>
			<div class="form-group row">
				<label class="col-md-2 col-form-label">Dimension </label>
				<div class="col-md-5" style="text-align: left">${instancedMetric.method.metrics.factor.dimension.name}</div>
			</div>
			<div class="form-group row">
				<label class="col-md-2 col-form-label">Factor </label>
				<div class="col-md-5" style="text-align: left">${instancedMetric.method.metrics.factor.name}</div>
			</div>

			<div class="form-group row">
				<label class="col-md-2 col-form-label">Metrics </label>
				<div class="col-md-5" style="text-align: left">${instancedMetric.method.metrics.name}</div>
			</div>
			<div class="form-group row">
				<label class="col-md-2 col-form-label">Method </label>
				<div class="col-md-5" style="text-align: left">${instancedMetric.method.name}</div>
			</div>
			<div class="form-group row">
				<label class="col-md-2 col-form-label">Granularity </label>
				<div class="col-md-5" style="text-align: left">${instancedMetric.method.metrics.granularity.text}</div>
			</div>


			<div class="col-md-12">
				<hr>
			</div>
			<div class="form-group row">
				<label class="col-md-2 col-form-label">Web Service Url </label>
				<div id="divUrl" class="col-md-5" style="text-align: left">${instancedMetric.method.operation.webService.url}</div>
			</div>
			<div class="form-group row">
				<label class="col-md-2 col-form-label">Operation </label>
				<div id="divOperation" class="col-md-5" style="text-align: left">${instancedMetric.method.operation.name}</div>
			</div>

			<div class="form-group row">
				<label class="col-md-3 col-form-label">Operation parameters</label>
				<br>
				<div class="cssDescription">Data for execute the instance
					metric</div>
			</div>
			<div>
				<c:choose>
					<c:when test="${empty instancedMetric.parameterValues}">
						<div>The method has no parameters</div>
					</c:when>
					<c:otherwise>

						<div class=" panel panel-default center-block"
							id="divParameterNotEmpty"
							onload="GraphicHandler.visbilityTable(${instancedMetric.parameterValues})">
							<table id="tableParameters" class="table table-striped ">
								<thead>
									<tr>
										<th class="text-center col-md-3">Name</th>
										<th class="text-center col-md-2">Data type</th>
										<th class="text-center col-md-2">Type</th>
										<th class="text-center col-md-3">Table</th>
										<th class="text-center col-md-4">Column</th>
										<th class="text-center col-md-4">Reference</th>

									</tr>
								</thead>
								<tbody id="tableParametersBody">
									<c:forEach var="parameterValue"
										items="${instancedMetric.parameterValues}" varStatus="loop">
										<tr>
											<td style="text-align: center">
												<label>${parameterValue.parameter.name}</label>
											</td>
											<td style="text-align: center">${parameterValue.parameter.dataType.text}</td>
											<td style="text-align: center">${parameterValue.parameter.parameterType.text}</td>
											<!-- 	Columnas -->

											<c:if
												test="${parameterValue.parameter.parameterType == 'ATTRIBUTE' || parameterValue.parameter.parameterType == 'COLUMN_NAME'}">


												<td style="text-align: center">${parameterValue.attribute.attributeTable.name}</td>

												<td style="text-align: center">${parameterValue.attribute.nameType}</td>
												<td></td>
											</c:if>

											<!-- 	Tablas -->
											<c:if
												test="${parameterValue.parameter.parameterType == 'TABLE_NAME'}">
												<td style="text-align: center">${parameterValue.attribute.name}</td>
												<td></td>
												<td></td>
											</c:if>

											<c:if
												test="${parameterValue.parameter.parameterType == 'REFERENCE'}">
												<td></td>
												<td></td>
												<td style="text-align: center">${parameterValue.referenceValue}</td>
											</c:if>

											<c:if
												test="${parameterValue.parameter.parameterType == 'CONNECT_TO_DB'}">
												<td></td>
												<td></td>
												<td></td>
											</c:if>

										</tr>
									</c:forEach>
								</tbody>
							</table>
						</div>
					</c:otherwise>
				</c:choose>
			</div>
		</div>
	</div>
	<!-- 				Modal -->
	<div id="popUpYesNo">
		<jsp:include page="../common/popUpDeleteYesNo.jsp" />
	</div>
	<div class="modal fade" id="confirmationDeleteModal" tabindex="-1"
		role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
		<div class="modal-dialog modal-sm" role="document">
			<div class="modal-content">
				<div class="modal-header" style="border: none;">
					<label> Delete instanced metrics</label>
					<button type="button" class="close" data-dismiss="modal"
						aria-label="Close">
						<span aria-hidden="true">&times;</span>
					</button>
				</div>
				<div class="modal-body" style="border: none;">
					This instanced metrics has been executed, if it is deleted, the
					execution will be deleted. <br> <br> Continue deleting?
				</div>
				<div class="modal-footer" style="border: none;">
					<a class="btn btn-danger btn-sm" data-toggle="modal"
						href="qualityModelInstancedMetricDeletePage?id=${instancedMetric.id}">
						<span class="glyphicon glyphicon-trash"></span>
						Yes
					</a>

					<button type="button" data-dismiss="modal" class="btn btn-sm"
						style="width: 70px">No</button>
				</div>
			</div>
		</div>
	</div>
</body>
</html>