<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<!DOCTYPE html>
<html lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">

<script type="text/javascript">
	$(document).ready(function() {

		$('a').click(function(e) {
			redirectHref($(this).attr('href'));

		});

	});
</script>

<style type="text/css">

span {
	color: #848383;
}

#divMenu ul {
	padding: 0px;
	margin: 0px;
	list-style: none;
}

#divMenu a {
	color: #cecece;
	padding-left: 0px;
}

.a_text {
	padding-left: 5px;
	margin-left: 10px;
}


.li_ppal {
	border-bottom: 1px solid #171616;
	border-radius: 0px;
	padding-left: 0px;
	margin: 0px;
	background-color: #383838;
	min-width: 100%;
}

.li_sub_menu {
	background-color: #222;
	border-radius: 0px;
	padding: 0px;
	margin: 0px;
	padding-left: 10px;
	padding-top: 5px;
	border: none;
}

#divMenu a:hover {
	color: #d3d1d1;
	background-color: transparent;
}

#divMenu a:focus {
	color: #d3d1d1;
	background-color: transparent;
}

/* #divMenu a:hover, span:hover, a:focus, span:focus { */
/* 	color: #fffcfc; */
/* 	background-color: transparent; */
/* } */

</style>

</head>
<body>
	<div id="divMenu"
		style="width: 300px; float: left; max-height: 95vh; overflow-y: auto; height: -webkit-fill-available; background-color: #383838;">
		<div class="nav-side-menu">

			<div class="navbar-header" style="padding-left: 0px; background-color: #2e2d2d; min-width: 100%">
				<a data-toggle="collapse" class="navbar-brand"
					href="#mnuqualityModelDataModelShowPage?id=${dataModel.id}"
					style="padding: 15px; margin: 0px" aria-expanded="true">
					 	${fn:substring(dataModel.name, 0, 30)}</a>

				<a href="#mnuqualityModelDataModelShowPage?id=${dataModel.id}" style="float: right;">
					<span class="glyphicon glyphicon-eye-open" style="padding: 15px; padding-top: 15px;"> </span>
				</a>
			</div>
			<div id="menu" class="collapse navbar-collapse"
				style="margin: 0px; padding: 0px; min-width: 100%">

				<ul class="nav navbar-nav" id="idElements">
					<li class="panel li_ppal">

						<a data-toggle="collapse" class="collapse-toggle a_text" href="#"
							 data-target="#ulDatabase" data-parent="#idElements">
							<img src="resources/images/icon_database.png" width="20px" /> Database
							<c:if test="${not empty database.name}">
								<span class="glyphicon glyphicon-chevron-down" style="padding: 1px; padding-top: 5px;"> </span>
							</c:if>
						</a>
						<c:if test="${not empty database.name}">
							<ul role="menu" class="collapse" id="ulDatabase">
								<li class="li_sub_menu">
									<a data-toggle="collapse" class="collapse-toggle a_text" href="#" data-target="#ulTables">
										${fn:substring(database.name, 0, 25)}
									
										<c:if test="${not empty database.attributesTable}">
											<span class="glyphicon glyphicon-chevron-down" style="padding-right: 10px; padding-top: 5px">
											</span>
										</c:if>
									</a>

									<ul class="collapse" id="ulTables">
										<c:forEach var="table" items="${database.attributesTable}">
											<li class="li_sub_manu">

												<a data-toggle="collapse" class="collapse-toggle a_text" href="#" data-target="#ulTables${table.name}">
													
													${fn:substring(table.name, 0, 24)}
													<c:if test="${not empty table.attributesColumns}">
														<span class="glyphicon glyphicon-chevron-down" style="padding-right: 10px; padding-top: 5px"> </span>
													</c:if>
												</a>

												<!-- Columns -->
												<ul class="collapse" id="ulTables${table.name}">
													<c:forEach var="column" items="${table.attributesColumns}">
														<li class="li_sub_menu">
														
															<a class="a_text">${fn:substring(column.name, 0, 23)}</a>
														</li>
													</c:forEach>
												</ul>
											</li>
										</c:forEach>
									</ul>
								</li>
							</ul>
						</c:if>
					</li>
					<li class="panel li_ppal">
						<a data-toggle="collapse" class="collapse-toggle a_text" href="#" data-target="#ulDimensions"
							data-parent="#idElements">
							Instanced Metrics
							<c:if test="${not empty  dimensions}">
								<span class="glyphicon glyphicon-chevron-down" style="padding: 1px; padding-top: 5px;">
								</span>
							</c:if>
						</a>
						<ul id="ulDimensions" class="collapse">
							<c:forEach var="dimension" items="${dimensions}">

								<li class="panel li_sub_menu">
									<a href="#" data-target="#ulDimension${dimension.id}" data-toggle="collapse"
										data-parent="#ulDimensions" class="collapse-toggle a_text">
										<label style="max-width: 200px">
										${fn:substring(dimension.name, 0, 25)}
										</label>
										<span class="glyphicon glyphicon-chevron-down" style="padding-right: 10px; padding-top: 5px">
										</span>
									</a>
									<ul id="ulDimension${dimension.id}" class="collapse">
										<c:forEach var="factor" items="${dimension.factors}">
											<li class="panel li_sub_menu">
												<a href="#" data-target="#ulFactor${factor.id}" data-toggle="collapse"
													data-parent="#ulDimension${dimension.id}" class="collapse-toggle a_text">
													${fn:substring(factor.name, 0, 24)}
											
													<span class="glyphicon glyphicon-chevron-down" style="padding-right: 10px; padding-top: 5px">
													</span>

												</a>
												<ul id="ulFactor${factor.id}" class="collapse">
													<c:forEach var="metrics" items="${factor.metrics}">
														<li class="panel li_sub_menu">
															<a href="#" data-target="#ulMetrics${metrics.id}" data-toggle="collapse"
																data-parent="#ulFactor${factor.id}" class="collapse-toggle a_text">
																${fn:substring(metrics.name, 0, 23)}
																
																<span class="glyphicon glyphicon-chevron-down"
																	style="padding-right: 10px; padding-top: 5px"> </span>
															</a>
															<ul id="ulMetrics${metrics.id}" class="collapse">
																<c:forEach var="method" items="${metrics.methods}">
																	<li class="panel li_sub_menu">
																		<a href="#" data-target="#ulMethod${method.id}" data-toggle="collapse"
																			data-parent="#ulMetrics${metrics.id}" class="collapse-toggle a_text">
																			${fn:substring(method.name, 0, 22)}
																			
																			<span class="glyphicon glyphicon-chevron-down"
																				style="padding-right: 10px; padding-top: 5px"> </span>
																		</a>
																		<ul id="ulMethod${method.id}" class="collapse">
																			<c:forEach var="instancedMetric" items="${method.instancedMetrics}">
																				<li class="panel li_sub_menu">
																					<a href="#mnuqualityModelInstancedMetricShowPage?id=${instancedMetric.id}"
																						id="instancedMetric${instancedMetric.id}" data-toggle="collapse" class="a_text">
																						${fn:substring(instancedMetric.name, 0, 21)}
																						 
																					</a>
																					<a href="#mnuqualityModelInstancedMetricShowPage?id=${instancedMetric.id}" >
																						<span class="glyphicon glyphicon-eye-open" style="padding-right: 10px; padding-top: 5px"> </span>
																					</a>
																				</li>
																			</c:forEach>
																		</ul>
																	</li>
																</c:forEach>
															</ul>
														</li>
													</c:forEach>
												</ul>
											</li>
										</c:forEach>
									</ul>
								</li>

							</c:forEach>
						</ul>
					</li>

					<li class="panel li_ppal">
						<a data-toggle="collapse" class="collapse-toggle a_text" href="#" data-target="#ulAggregations"
							aria-expanded="false" data-parent="#idElements">
							Aggregations
							<c:if test="${not empty aggregations}">
								<span class="glyphicon glyphicon-chevron-down" style="padding: 1px; padding-top: 5px;"> </span>
							</c:if>
						</a>
						<ul id="ulAggregations" class="collapse">
							<c:forEach var="aggregation" items="${aggregations}">

								<li class="panel li_sub_menu">
									<a href="#mnuqualityModelAggregationShowPage?id=${aggregation.id}"
										data-target="#ulAggregations${aggregation.id}" id="aggregation${aggregation.id}"
										data-toggle="collapse" class="a_text"> 	${fn:substring(aggregation.name, 0, 25)} </a>

									<a href="#mnuqualityModelAggregationShowPage?id=${aggregation.id}">
										<span class="glyphicon glyphicon-eye-open"> </span>
									</a>
								</li>
							</c:forEach>
						</ul>
					</li>
					
					<li class="panel li_ppal">
						<a data-toggle="collapse" class="collapse-toggle a_text" href="#" data-target="#ulComposedIMs"
							aria-expanded="false" data-parent="#idElements">
							Composed Instanced Metrics
							<c:if test="${not empty composedIMs}">
								<span class="glyphicon glyphicon-chevron-down" style="padding: 1px; padding-top: 5px;"> </span>
							</c:if>
						</a>
						<ul id="ulComposedIMs" class="collapse">
							<c:forEach var="composedIM" items="${composedIMs}">
								<li class="panel li_sub_menu">
									<a href="#mnuqualityModelComposedIMShowPage?id=${composedIM.id}"
										data-target="#ulComposedIMs${composedIM.id}" id="composedIMs${composedIM.id}"
										data-toggle="collapse" class="a_text"> 	${fn:substring(composedIM.name, 0, 25)} </a>

									<a href="#mnuqualityModelComposedIMShowPage?id=${composedIM.id}">
										<span class="glyphicon glyphicon-eye-open"> </span>
									</a>
								</li>
							</c:forEach>
						</ul>
					</li>
					
				</ul>
			</div>
		</div>
		<script type="text/javascript">
		menuSideQualityModelOpen('${type}', ${idElement});
		</script>

	</div>

</body>
</html>


<!-- 	<li class="panel col-md-12"> -->

<!-- 									<a data-toggle="collapse" class="collapse-toggle" href="#" -->
<!-- 										style="display: -webkit-inline-box;" data-target="#ulInstancedMetrics" -->
<!-- 										aria-expanded="true"> -->
<!-- 										<img src="resources/images/icon_database.png" width="20px" /> Instanced Metrics -->
<!-- 										<b class="caret"></b> -->
<!-- 									</a> -->
<!-- 									Agregar metrica instanciada -->
<%-- 									<a href="#mnuqualityModelInstancedMetricCreatePage?idDataModel=${idDataModel}" --%>
<!-- 										style="display: inline-flex;"> -->
<!-- 										<span class="glyphicon glyphicon-plus"> </span> -->
<!-- 									</a> -->
<!-- 									<div id="accordion" style="display: inline; position: relative;"> -->
<!-- 										<ul id="ulInstancedMetrics" role="menu" class="collapse"> -->
<%-- 											<c:forEach var="instancedMetrics" items="${instancedMetricsList}"> --%>
<!-- 												<li class="panel col-md-12"> -->

<!-- 													<a data-toggle="collapse" class="collapse-toggle" href="#" -->
<%-- 														style="display: -webkit-inline-box;"> ${instancedMetrics.name} </a> --%>
<!-- 													Ver metrica instanciada -->
<%-- 													<a href="#mnuqualityModelInstancedMetricShowPage?id=${instancedMetrics.id}"> --%>
<!-- 														<span class="glyphicon glyphicon-eye-open"> </span> -->
<!-- 													</a> -->
<!-- 													Editar metrica instanciada -->
<%-- 													<a href="#mnuqualityModelInstancedMetricEditPage?id=${instancedMetrics.id}"> --%>
<!-- 														<span class="glyphicon glyphicon-edit"> </span> -->
<!-- 													</a> -->
<!-- 												</li> -->
<%-- 											</c:forEach> --%>

<!-- 										</ul> -->
<!-- 									</div> -->
<!-- 								</li> -->