/**
 * 
 */
function ComunicationHandler() {

	this.GetRandomNumber = function(success_callback, error_callback) {
		$.ajax({
			type : 'GET',
			url : '/GetRandomNumber.html',
			success : function(data) {
				success_callback(data);
			},
			error : function(response, error, errorThrown) {
				error_callback(response.responseText);
			},
			cache : false
		});
	}

	// ******************************* Menu ******************************** //

	// Obtiene las dimensiones, factores, metricas y metodos para mostrarlos en
	// el menu
	this.dimensionsMenuGet = function(success_callback, error_callback) {
		$.ajax({
			type : 'GET',
			url : 'dimensionsMenuGet',
			contentType : 'application/json',
			dataType : 'json',
			success : function(data) {
				success_callback(data);
			},
			error : function(response, error, errorThrown) {
				error_callback(response.responseText);
			},
			cache : false
		});
	}

	// **********************************************************************//

	// ***************************** ABM Methods *************************** //

	// Valida el web service y obtiene su operaciones desde el servidor
	this.urlWebServiceValidate = function(success_callback, error_callback) {
		$.ajax({
			type : 'GET',
			url : 'urlWebServiceValidate',
			data : {
				url : $("#txtWebServiceUrl").val()
			},
			contentType : 'application/json',
			dataType : 'json',
			success : function(data) {
				success_callback(data);
			},
			error : function(response, error, errorThrown) {
				error_callback(response.responseText);
			},
			cache : false
		});
	}

	// Obtiene las operaciones del web service desde el servidor
	this.operationsWebServiceGet = function(success_callback, error_callback) {
		$.ajax({
			type : 'GET',
			url : 'operationsWebServiceGet',
			contentType : 'application/json',
			dataType : 'json',
			success : function(data) {
				success_callback(data);
			},
			error : function(response, error, errorThrown) {
				error_callback(response);
			},
			cache : false
		});
	}

	// Obtiene la operacion identificada con el nombre
	this.operationGet = function(operationName, success_callback, error_callback) {
		$.ajax({
			type : 'GET',
			url : 'operationGet',
			contentType : 'application/json',
			dataType : 'json',
			data : {
				operationName : operationName
			},
			success : function(data) {
				success_callback(data);
			},
			error : function(response, error, errorThrown) {
				error_callback(response);
			},
			cache : false
		});
	}

	// Obtiene el JSONObject llamado method con la informacion del metodo
	// indicado, metrics con la metrica del metodo y webService con la info del
	// ws del metodo
	this.methodGet = function(idMethod, success_callback, error_callback) {
		$.ajax({
			type : 'GET',
			url : 'methodGet',
			contentType : 'application/json',
			dataType : 'json',
			data : {
				idMethod : idMethod
			},
			success : function(data) {
				success_callback(data);
			},
			error : function(response, error, errorThrown) {
				error_callback(response);
			},
			cache : false
		});
	}

	// **********************************************************************//

	// ********************* Database Test Connection ********************* //

	// Verifica que con el string de conexion se pueda conectar a una base de
	// datos
	this.qualityModelConnectDatabaseTestConnection = function(success_callback) {
		$.ajax({
			type : 'GET',
			url : 'qualityModelConnectDatabaseTestConnection',
			data : {
				name : $("#nameDatabase").val(),
				url : $("#url").val(),
				user : $("#user").val(),
				password : $("#password").val(),
				schema : $("#schema").val(),
				system : $("#system").val()
			},
			contentType : 'application/json',
			dataType : 'json',
			success : function(data) {
				success_callback(data);
			},
			cache : false
		});
	}

	// **********************************************************************//

	// ************************* Instanced metrics **************************//

	// Obtiene los factores de la dimension
	this.factorsGet = function(idDimension, success_callback) {
		$.ajax({
			type : 'GET',
			url : 'factorsGet',
			data : {
				idDimension : idDimension
			},
			contentType : 'application/json',
			dataType : 'json',
			success : function(data) {
				success_callback(data);
			},

			cache : false
		});
	}

	// Obtiene las metricas del factor
	this.metricsGet = function(idFactor, success_callback, error_callback) {
		$.ajax({
			type : 'GET',
			url : 'metricsGet',
			data : {
				idFactor : idFactor
			},
			contentType : 'application/json',
			dataType : 'json',
			success : function(data) {
				success_callback(data);
			},
			error : function(response, error, errorThrown) {
				error_callback(response);
			},
			cache : false
		});
	}

	// Obtiene los metodos de la metrica
	this.methodsGet = function(idMetrics, success_callback, error_callback) {
		$.ajax({
			type : 'GET',
			url : 'methodsGet',
			data : {
				idMetrics : idMetrics
			},
			contentType : 'application/json',
			dataType : 'json',
			success : function(data) {
				success_callback(data);
			},
			error : function(response, error, errorThrown) {
				error_callback(response.responseText);
			},
			cache : false
		});
	}

	// Obtiene los parametros basicos del metodo
	this.methodParametersGet = function(idDataModel, idMethod, success_callback, error_callback) {
		$.ajax({
			type : 'GET',
			url : 'methodParametersGet',
			data : {
				idMethod : idMethod,
				idDataModel : idDataModel
			},
			contentType : 'application/json',
			dataType : 'json',
			success : function(objects) {
				success_callback(objects, idDataModel);
			},
			error : function(response, error, errorThrown) {
				error_callback(response);
			},
			cache : false
		});
	}

	this.columnsFind = function(idDataModel, tableName, success_callback, error_callback) {
		$.ajax({
			type : 'GET',
			url : 'columnsFind',
			data : {
				tableName : tableName,
				idDataModel : idDataModel
			},
			contentType : 'application/json',
			dataType : 'json',
			success : function(objects) {
				success_callback(objects, idDataModel);
			},
			error : function(response, error, errorThrown) {
				error_callback(response);
			},
			cache : false
		});
	}

	// **********************************************************************//

	// ************************* Aggregation **************************//

	// Obtien las agregaciones identificadas con los ids de aggregationsIds
	// this.aggregationsGet = function(aggregationsIds, success_callback,
	// error_callback) {
	// $.ajax({
	// type : 'GET',
	// url : 'aggregationsGet',
	// data : {
	// aggregationsIds : aggregationsIds
	// },
	// contentType : 'application/json',
	// success : function(objects) {
	// success_callback(objects);
	// },
	// error : function(response, error, errorThrown) {
	// error_callback(response.responseText);
	// },
	//
	// cache : false
	// });
	// }

	// this.instancedMetricsFind = function(idDataModel, selectRow, type,
	// success_callback, error_callback) {
	//
	// $.ajax({
	// type : 'GET',
	// url : 'instancedMetricsFind',
	// data : {
	// idDataModel : idDataModel,
	// index : selectRow,
	// type : type,
	// },
	// contentType : 'application/json',
	// dataType : 'json',
	// success : function(objects) {
	// success_callback(objects, idDataModel);
	// },
	// error : function(response, error, errorThrown) {
	// error_callback(response);
	// },
	// cache : false
	// });
	// }

	// this.instancedMetricsGet = function(idsInstancedMetrics,
	// success_callback, error_callback) {
	//
	// $.ajax({
	// type : 'GET',
	// url : 'instancedMetricsGet',
	// data : {
	// idsInstancedMetrics : idsInstancedMetrics
	// },
	// contentType : 'application/json',
	// dataType : 'json',
	// success : function(objects) {
	// success_callback(objects);
	// },
	// error : function(response, error, errorThrown) {
	// error_callback(response);
	// },
	// cache : false
	// });
	// }

	// envia al servidor el tipo de parametro que eligio el usuario para
	// actualizar la lista de valores al tipo correspondiente
	this.aggregationTypeParameterSet = function(selectRow, typeParameter, success_callback, error_callback) {
		$.ajax({
			type : 'GET',
			url : 'aggregationTypeParameterSet',
			data : {
				index : selectRow,
				typeParameter : typeParameter
			},
			contentType : 'application/json',
			success : function() {
				success_callback();
			},
			error : function(response, error, errorThrown) {
				error_callback(response);
			},
			cache : false
		});
	}

	// envia al servidor la operacion seleccionada para que se asignen los
	// parametros de los valores a la agregacion
	this.aggregationOperationSelect = function(nameOperation, success_callback, error_callback) {
		$.ajax({
			type : 'GET',
			url : 'aggregationOperationSelect',
			data : {
				nameOperation : nameOperation
			},
			contentType : 'application/json',
			dataType : 'json',
			success : function(object) {
				success_callback(object);
			},
			error : function(response, error, errorThrown) {
				error_callback(response);
			},
			cache : false
		});
	}

	// this.aggregationIMSet = function(nameInstancedMetric, error_callback) {
	// $.ajax({
	// type : 'GET',
	// url : 'aggregationIMSet',
	// data : {
	// nameInstancedMetric : nameInstancedMetric
	// },
	// contentType : 'application/json',
	// dataType : 'json',
	// error : function(response, error, errorThrown) {
	// error_callback(response);
	// },
	// cache : false
	// });
	// }
	//	
	// **********************************************************************//
	// composed IM
	// *********************************************************************//

	// envia al servidor la operacion seleccionada para que se asignen los
	// parametros de los valores a la agregacion
	this.composedIMOperationSelect = function(nameOperation, success_callback, error_callback) {
		$.ajax({
			type : 'GET',
			url : 'composedIMOperationSelect',
			data : {
				nameOperation : nameOperation
			},
			contentType : 'application/json',
			dataType : 'json',
			success : function(object) {
				success_callback(object);
			},
			error : function(response, error, errorThrown) {
				error_callback(response);
			},
			cache : false
		});
	}

	this.composedIMTypeParameterSet = function(selectRow, typeParameter, success_callback, error_callback) {
		$.ajax({
			type : 'GET',
			url : 'composedIMTypeParameterSet',
			data : {
				index : selectRow,
				typeParameter : typeParameter
			},
			contentType : 'application/json',
			success : function() {
				success_callback();
			},
			error : function(response, error, errorThrown) {
				error_callback(response);
			},
			cache : false
		});
	}

	
	this.instancedMetricsGet = function(idDataModel, success_callback, error_callback) {
		$.ajax({
			type : 'GET',
			url : 'instancedMetricsGet',
			data : {
				idDataModel : idDataModel
			},
			contentType : 'application/json',
			dataType : 'json',
			success : function(object) {
				success_callback(object);
			},
			error : function(response, error, errorThrown) {
				error_callback(response);
			},
			cache : false
		});
	}

	// **********************************************************************//
	// Ejecutar modelo de datos
	// *********************************************************************//

	// this.qualityModelDataModelExecuteAjax = function(instancedMetricsIds,
	// aggregationsIds, reloadData, success_callback, error_callback) {
	// $.ajax({
	// type : 'GET',
	// url : 'qualityModelDataModelExecuteAjax',
	// data : {
	// instancedMetricsIds : instancedMetricsIds,
	// aggregationsIds : aggregationsIds,
	// reloadData : reloadData,
	// },
	// contentType : 'application/json',
	// success : function(objects) {
	// success_callback(objects);
	// },
	// error : function(response, error, errorThrown) {
	// error_callback(response.responseText);
	// },
	//
	// cache : false
	// });
	// }

	// this.qualityModelDataModelValidateExecuteAjax =
	// function(instancedMetricsIds, aggregationsIds, success_callback,
	// error_callback) {
	// $.ajax({
	// type : 'GET',
	// url : 'qualityModelDataModelValidateExecuteAjax',
	// data : {
	// instancedMetricsIds : instancedMetricsIds,
	// aggregationsIds : aggregationsIds
	// },
	// contentType : 'application/json',
	// success : function(objects) {
	// success_callback(objects);
	// },
	// error : function(response, error, errorThrown) {
	// error_callback(response.responseText);
	// },
	//
	// cache : false
	// });
	// }

	// **********************************************************************//
	// Ejecutar metricas instanciadas
	// *********************************************************************//

	this.executeInstancedMetricsAjax = function(idDataQualityModel, instancedMetricsIds, reloadData, success_callback, error_callback) {
		$.ajax({
			type : 'GET',
			url : 'executeInstancedMetricsAjax',
			data : {
				instancedMetricsIds : instancedMetricsIds,
				reloadData : reloadData,
				idDataQualityModel : idDataQualityModel,
			},
			contentType : 'application/json',
			success : function(objects) {
				success_callback(objects);
			},
			error : function(response, error, errorThrown) {
				error_callback(response.responseText);
			},

			cache : false
		});
	}

	this.executeInstancedMetricsValidateAjax = function(instancedMetricsIds, success_callback, error_callback) {
		$.ajax({
			type : 'GET',
			url : 'executeInstancedMetricsValidateAjax',
			data : {
				instancedMetricsIds : instancedMetricsIds
			},
			contentType : 'application/json',
			success : function(objects) {
				success_callback(objects);
			},
			error : function(response, error, errorThrown) {
				error_callback(response.responseText);
			},

			cache : false
		});
	}

	// **********************************************************************//
	// Ejecutar aggregations
	// *********************************************************************//

	/*
	 * this.executeAggregationsValidateAjax = function(aggregationsIds,
	 * success_callback, error_callback) { $.ajax({ type : 'GET', url :
	 * 'executeAggregationsValidateAjax', data : { aggregationsIds :
	 * aggregationsIds }, contentType : 'application/json', success :
	 * function(objects) { success_callback(objects); }, error :
	 * function(response, error, errorThrown) {
	 * error_callback(response.responseText); },
	 * 
	 * cache : false }); }
	 */

	this.executeAggregationsAjax = function(idDataQualityModel, aggregationsIds, deleteIMResults, success_callback, error_callback) {
		$.ajax({
			type : 'GET',
			url : 'executeAggregationsAjax',
			data : {
				aggregationsIds : aggregationsIds,
				idDataQualityModel : idDataQualityModel,
				deleteIMResults : deleteIMResults,
			},
			contentType : 'application/json',
			success : function(objects) {
				success_callback(objects);
			},
			error : function(response, error, errorThrown) {
				error_callback(response.responseText);
			},

			cache : false
		});
	}
	// **********************************************************************//
	// Ejecutar composed IM
	// *********************************************************************//

	this.executeComposedIMAjax = function(idDataQualityModel, composedIMIds, deleteIMResults, success_callback, error_callback) {
		$.ajax({
			type : 'GET',
			url : 'executeComposedIMAjax',
			data : {
				composedIMIds : composedIMIds,
				idDataQualityModel : idDataQualityModel,
				deleteIMResults : deleteIMResults,
			},
			contentType : 'application/json',
			success : function(objects) {
				success_callback(objects);
			},
			error : function(response, error, errorThrown) {
				error_callback(response.responseText);
			},

			cache : false
		});
	}

	// **********************************************************************//
	// Resultado de ejecutar modelo de datos
	// *********************************************************************//

	this.executeDataQulityModelResultAjax = function(idDataModel, success_callback, error_callback) {
		$.ajax({
			type : 'GET',
			url : 'executeDataQulityModelResultAjax',
			data : {
				idDataModel : idDataModel,
			},
			contentType : 'application/json',
			success : function(objects) {
				success_callback(objects);
			},
			error : function(response, error, errorThrown) {
				error_callback(response.responseText);
			},

			cache : false
		});
	}

	// this.dataQualityModelExecutePage = function(idDataQualityModel, type,
	// success_callback, error_callback) {
	// $.ajax({
	// type : 'GET',
	// url : 'dataQualityModelExecutePage',
	// data : {
	// idDataQualityModel : idDataQualityModel,
	// type : type
	// },
	// contentType : 'application/json',
	// success : function(objects) {
	// success_callback(objects);
	// },
	// error : function(response, error, errorThrown) {
	// error_callback(response.responseText);
	// },
	//
	// cache : false
	// });
	// }

}
