/**
 * 
 */

/**
 * @returns
 */
function UsersRequestsHandler() {

	this.GetRandom = function() {
		ComunicationHandler.getRandomNumber(function(data) {
			GraphicHandler.showResult(data);
		}, function(error_msg) {
			GraphicHandler.ShowError(error_msg);
		});
	}

	// **************************** ABM Methods **************************** //

	// Valida el web service, carga las operaciones y los parametros.
	this.methodUrlWebServiceValidate = function(connectToDB, granularity) {
		GraphicHandler.showLoader();
		ComunicationHandler.urlWebServiceValidate(function(data) {
			GraphicHandler.operationsWebServiceLoad(data);
			if (data.length > 0) {
				GraphicHandler.methodParametersLoad(data[0], connectToDB, granularity);
			}
		}, function(error_msg) {
			GraphicHandler.methodUrlError(error_msg);
		});

	}

	// Pedido desde la pagina para los parametros de la operacion seleccionada
	this.methodParametersGet = function(connectToDB, granularity) {
		$("#errorOperationParameters").css('display', 'none');
		GraphicHandler.showLoader();
		var operationSel = $('#cbOperations').val();
		ComunicationHandler.operationGet(operationSel, function(operation) {
			GraphicHandler.methodParametersLoad(operation, connectToDB, granularity);
		}, function(error_msg) {
			GraphicHandler.methodUrlError(error_msg);
		});

		// GraphicHandler.operationsWebServiceMethodGet(operationSel,
		// connectToDB, granularity);

	}

	// **********************************************************************//

	// ********************* Database Test Connection ********************* //

	// Verifica que con el string de conexion se pueda conectar a una base de
	// datos
	this.qualityModelConnectDatabaseTestConnection = function() {
		GraphicHandler.showLoader();
		// Verifica que se ingreso el nombre y el string de conexion
		var error = "";
		if ($("#url").val() == "") {
			error += "The url can not be empty.";
		}

		if ($("#system").val() == "") {
			if (error != "") {
				error += " <br />";
			}
			error += "Select the system";
		}

		$('#divResponse').removeClass($('#divResponse').attr("class"));
		if (error == "") {
			$('#divResponse').text("");
			ComunicationHandler.qualityModelConnectDatabaseTestConnection(function(data) {
				GraphicHandler.qualityModelConnectDatabaseTestConnection(data)
			});
		} else {
			$('#divResponse').html(error);
			$('#divResponse').removeClass($('#divResponse').attr("class"));
			$('#divResponse').addClass("alert alertValidation alert-danger col-md-8");

			GraphicHandler.hideLoader();
		}
	}

	// **********************************************************************//

	// ************************* Instanced metrics **************************//

	// Muestra en el combobox los factores de la dimension
	this.factorsGet = function(idDimension) {
		if (idDimension != 0) {
			GraphicHandler.showLoader();
			ComunicationHandler.factorsGet(idDimension, function(data) {
				GraphicHandler.factorsGet(data)
			});
		} else {
			GraphicHandler.factorsGet();
		}
	}

	// Muestra en el combobox las metricas del factor
	this.metricsGet = function(idFactor) {
		if (idFactor != 0) {
			GraphicHandler.showLoader();
			ComunicationHandler.metricsGet(idFactor, function(data) {
				GraphicHandler.metricsGet(data);
			}, function(error_msg) {
				GraphicHandler.messageError(error_msg, "#lblError");
			});
		} else {
			GraphicHandler.metricsGet();
		}
	}

	// Muestra en el combobox los metodos de la metricas
	this.instancedMetricsMethodsGet = function(idMetrics) {
		if (idMetrics != 0) {
			GraphicHandler.showLoader();
			ComunicationHandler.methodsGet(idMetrics, function(data) {
				GraphicHandler.instancedMetricsMethodsSet(data);
			}, function(error_msg) {
				GraphicHandler.messageError(error_msg, "#lblError");
			});
		} else {
			GraphicHandler.instancedMetricsMethodsSet();
		}
	}

	// Muestra los parametros del metodo
	this.instancedMetricsParametersSet = function(idDataModel, idMethod) {
		$("#parameterValuesError").css('display', 'none');
		if (idMethod != 0) {
			GraphicHandler.showLoader();
			ComunicationHandler.methodParametersGet(idDataModel, idMethod, function(object) {
				GraphicHandler.instancedMetricsParametersSet(object, idDataModel);
			}, function(error_msg) {
				GraphicHandler.messageError(error_msg, "#lblErrorParameter");
			});
		} else {
			GraphicHandler.visbilityTable("");
			GraphicHandler.hideLoader();
		}
	}

	// Agrega los selects con las columnas de la tabla

	this.instancedMetricsColumnsSet = function(idDataModel, tableName, selectParameterColumn) {
		GraphicHandler.showLoader();
		if (tableName != "") {
			GraphicHandler.showLoader();
			ComunicationHandler.columnsFind(idDataModel, tableName, function(object) {
				GraphicHandler.instancedMetricsColumnsSet(object, selectParameterColumn, tableName);
			}, function(error_msg) {
				GraphicHandler.messageError(error_msg, "#lblError");
			});
		} else {
			GraphicHandler.instancedMetricsColumnsSet("", selectParameterColumn, "");
			GraphicHandler.hideLoader();
		}
	}
	// **********************************************************************//

	// ************************* Aggregations **************************//

	// Valida el web service, carga las operaciones y los parametros de la
	// primer operacion.
	this.aggregationUrlWebServiceValidate = function(idDataModel) {
		GraphicHandler.showLoader();
		ComunicationHandler.urlWebServiceValidate(function(data) {
			GraphicHandler.operationsWebServiceLoad(data);
			if (data.length > 0) {
				UsersRequestsHandler.aggregationParametersLoad(data[0].name, idDataModel);
			}
		}, function(error_msg) {
			GraphicHandler.methodUrlError(error_msg);
		});
	}

	// Muestra los parametros de la operacion seleccionada
	this.aggregationParametersLoad = function(nameOperation, idDataModel) {

		GraphicHandler.showLoader();

		// Carga en la agregacion la operacion y los parametros values
		ComunicationHandler.aggregationOperationSelect(nameOperation, function(operation) {
			GraphicHandler.aggregationParametersLoad(operation, idDataModel)
		}, function(error_msg) {
			GraphicHandler.messageError(error_msg, "#lblError");
		});
		$('#parameterValues.errors').empty();
	}

	// Obitene las tablas o columnas dependiendo del tipo de parametro que
	// selecciono el usuario
	// idSelectParameterType: Indica la fila que modifico
	// Si typeParameter = REFERENTIAL: agrego un campo para ingresar el valor
	// = ATTRIBUTE: cargo las tablas
	// = CONNECT_TO_DB: no hace nada
	this.aggregationTypeParameterChange = function(idDataModel, typeParameter, parameterName, selectRow) {

		GraphicHandler.showLoader();

		// if (typeParameter == "TABLE_NAME" || typeParameter == "COLUMN_NAME")
		// {
		// $('#MIError').empty();
		// $('#MIError').css('display', 'none');
		//
		// if ($('#cbInstancedMetric1').val() == -1) {
		// $('#MIError').append("Select the instanced metric 1\r\n");
		// $('#MIError').css('display', '');
		// }
		//
		// if (!$('#cbInstancedMetric2').prop("hidden") &&
		// $('#cbInstancedMetric2').val() == -1) {
		// $('#MIError').append("Select the instanced metric 2");
		// $('#MIError').css('display', '');
		// }
		//
		// if ($('#MIError').val() == "") {
		//				
		// GraphicHandler.aggregationAttributeIMLoad(idDataModel, parameterName,
		// selectRow);
		// }
		// }

		// if (typeParameter == "REFERENCE") {
		ComunicationHandler.aggregationTypeParameterSet(selectRow, typeParameter, function() {
			GraphicHandler.aggregationAttributeLoad(parameterName, typeParameter, selectRow);
		}, function(error_msg) {
			GraphicHandler.messageError(error_msg, "#lblError");
		});
		// }

		// if (typeParameter == "CONNECT_TO_DB" || typeParameter == "") {
		// // Oculto los otros campos
		// ComunicationHandler.aggregationTypeParameterSet(selectRow,
		// typeParameter, function() {
		// GraphicHandler.aggregationAttributeConnectToDBLoad(parameterName);
		// }, function(error_msg) {
		// GraphicHandler.messageError(error_msg, "#lblError");
		// });
		//
		// }
		GraphicHandler.hideLoader();
	}

	this.aggregationLoadParameterIM = function() {

		$('[id*=cbInstancedMetrics]').empty();
		$('[id*=cbInstancedMetrics]').append(GraphicHandler.aggregationAttributeIMLoadOption());

	}

	// this.aggregationIMChange = function(nameInstancedMetric){
	// ComunicationHandler.aggregationIMSet(nameInstancedMetric,
	// function(error_msg) {
	// GraphicHandler.messageError(error_msg, "#lblError");
	// });
	//
	// }

	// **********************************************************************//
	// **************************** Composed IM *****************************//

	// Valida el web service, carga las operaciones y los parametros de la
	// primer operacion.
	this.composedIMUrlWebServiceValidate = function(idDataModel) {
		GraphicHandler.showLoader();
		ComunicationHandler.urlWebServiceValidate(function(data) {
			GraphicHandler.operationsWebServiceLoad(data);
			if (data.length > 0) {
				UsersRequestsHandler.composedIMParametersLoad(data[0].name, idDataModel);
			}
		}, function(error_msg) {
			GraphicHandler.methodUrlError(error_msg);
		});
	}

	// Carga en cada uno de los parametros la lista de metricas instanciadas
	// seleccionadas por el usuario
	this.composedIMLoadParameterIM = function() {

		$('[id*=cbParameterInstancedMetrics]').empty();
		$('[id*=cbParameterInstancedMetrics]').append(GraphicHandler.composedIMAttributeComboboxLoad());

	}

	// Muestra los parametros de la operacion seleccionada
	this.composedIMParametersLoad = function(nameOperation, idDataModel) {

		GraphicHandler.showLoader();

		// Carga en la agregacion la operacion y los parametros values
		ComunicationHandler.composedIMOperationSelect(nameOperation, function(operation) {
			GraphicHandler.composedIMParametersLoad(operation, idDataModel)
		}, function(error_msg) {
			GraphicHandler.messageError(error_msg, "#lblError");
		});
		$('#parameterValues.errors').empty();
	}

	// Obitene las tablas o columnas dependiendo del tipo de parametro que
	// selecciono el usuario
	// idSelectParameterType: Indica la fila que modifico
	// Si typeParameter = REFERENTIAL: agrego un campo para ingresar el valor
	// = ATTRIBUTE: cargo las tablas y las metricas instanciadass
	// = CONNECT_TO_DB: no hace nada
	this.composedIMTypeParameterChange = function(idDataModel, typeParameter, parameterName, selectRow) {

		GraphicHandler.showLoader();

		ComunicationHandler.composedIMTypeParameterSet(selectRow, typeParameter, function() {
			GraphicHandler.composedIMAttributeLoad(parameterName, typeParameter, selectRow);
		}, function(error_msg) {
			GraphicHandler.messageError(error_msg, "#lblError");
		});

		GraphicHandler.hideLoader();
	}

	this.composedIMAddIM = function(idDataModel) {
		ComunicationHandler.instancedMetricsGet(idDataModel, function(instancedMetrics) {
			GraphicHandler.composedIMAddIM(instancedMetrics);
		}, function(error_msg) {
			GraphicHandler.messageError(error_msg, "#lblError");
		});

	}

	// **********************************************************************//
	// Ejecutar modelo de datos
	// *********************************************************************//

	// Carga la tabla con las metricas instanciadas en la pagina para
	// seleccionar las metricas instanciadas a ejecutar
	// dimensions: lista de dimemensiones que tienen las metricas instanciadas
	// agupadas por metodos, metricas, factores y dimensiones
	// contextPath: pagina donde se invoca la funcion para mostrar mensaje de
	// error
	this.executeInstanceMetricsLoadTable = function(dimensions, contextPath) {
		GraphicHandler.executeInstanceMetricsLoadTable(dimensions, contextPath);
	}
	
	
	this.showInfoInstancedMetrics = function(idMethod, instancedMetricName){
		ComunicationHandler.methodGet(idMethod, function(data) {
			GraphicHandler.showInfoInstancedMetrics(data, instancedMetricName);
		}, function(error_msg) {
			GraphicHandler.messageError(error_msg, "#lblError");
		});
		
	}

	this.qualityModelDataModelValidateExecuteAjax = function(typeExecute) {
		GraphicHandler.showLoader();
		var instancedMetricsIds = [];
		var aggregationsIds = [];
		var i = 0;
		$('input[name="instancedMetricsIds"]:checkbox:checked').each(function() {
			instancedMetricsIds[i] = $(this).val();
			++i;
		});
		i = 0;
		$('input[name="aggregationsIds"]:checkbox:checked').each(function() {
			aggregationsIds[i] = $(this).val();
			++i;
		});

		if (instancedMetricsIds.length == 0 && aggregationsIds.length == 0) {
			if (typeExecute == 'IMPartialAgreg') {
				GraphicHandler.messageError("Select instanced metrics and aggregations for execute.", "divError");
			} else {
				GraphicHandler.messageError("Select aggregations for execute.", "divError");
			}
		} else {
			ComunicationHandler.qualityModelDataModelValidateExecuteAjax(instancedMetricsIds, aggregationsIds,
					function(response) {
						GraphicHandler.qualityModelDataModelValidateExecuteAjax(response);
					}, function(error_msg) {
						GraphicHandler.messageError(error_msg, "#lblError");
					});
		}
	}

//	this.qualityModelDataModelExecuteAjax = function(reloadData) {
//		GraphicHandler.showLoader();
//		var instancedMetricsIds = [];
//		var aggregationsIds = [];
//		var i = 0;
//		$('input[name="instancedMetricsIds"]:checkbox:checked').each(function() {
//			instancedMetricsIds[i] = $(this).val();
//			++i;
//		});
//		i = 0;
//		$('input[name="aggregationsIds"]:checkbox:checked').each(function() {
//			aggregationsIds[i] = $(this).val();
//			++i;
//		});
//
//		ComunicationHandler.qualityModelDataModelExecuteAjax(instancedMetricsIds, aggregationsIds, reloadData,
//				function(response) {
//					GraphicHandler.qualityModelDataModelExecuteResultLoad(response);
//				}, function(error_msg) {
//					// GraphicHandler.qualityModelDataModelExecuteResultLoad(error_msg);
//					GraphicHandler.messageError(error_msg, "#lblError");
//				});
//	}

	this.qualityModelDataModelExecuteReloadDataModal = function() {

		$('#modalReloadData').modal();
	}

	this.dataQualityModelExecutePage = function() {
		GraphicHandler.showLoader();

		var idDataQualityModel = $('#cbDataQualityModel').val();
		var type = $('#cbType').val();

		if (idDataQualityModel != 0 && type != "") {
			$('#divResult').hide();
			$('#divSelectIMAgg').load(
					'dataQualityModelExecutePage?idDataQualityModel=' + idDataQualityModel + '&type=' + type);
			$('#divSelectIMAgg').show();

		}
		GraphicHandler.hideLoader();

	}

	// **********************************************************************//
	// Execute instanced metrics
	// *********************************************************************//

	this.executeInstancedMetricsSelectPage = function() {
		GraphicHandler.showLoader();

		var idDataQualityModel = $('#cbDataQualityModel').val();
		if (idDataQualityModel > 0) {
			$('#divResult').hide();
			$('#divSelectIM').load('executeInstancedMetricsSelectPage?idDataQualityModel=' + idDataQualityModel);
			$('#divSelectIM').show();
		}
		GraphicHandler.hideLoader();

	}

	this.executeInstancedMetricsValidateAjax = function(idDataModel) {
		GraphicHandler.showLoader();
		var instancedMetricsIds = [];
		var i = 0;
		$('input[name="instancedMetricsIds"]:checkbox:checked').each(function() {
			instancedMetricsIds[i] = $(this).val();
			++i;
		});
		i = 0;

		if (instancedMetricsIds.length == 0) {

			GraphicHandler.messageError("Select instanced metrics for execute.", "divError");

		} else {
			ComunicationHandler.executeInstancedMetricsValidateAjax(instancedMetricsIds, function(response) {
				GraphicHandler.executeInstancedMetricsValidateAjax(idDataModel, response);
			}, function(error_msg) {
				GraphicHandler.messageError(error_msg, "#lblError");
			});
		}
	}

	this.executeInstancedMetricsAjax = function(idDataQualityModel, reloadData) {
		GraphicHandler.showLoader();
		var instancedMetricsIds = [];
		var i = 0;
		$('input[name="instancedMetricsIds"]:checkbox:checked').each(function() {
			instancedMetricsIds[i] = $(this).val();
			++i;
		});
		i = 0;

		ComunicationHandler.executeInstancedMetricsAjax(idDataQualityModel, instancedMetricsIds, reloadData,
				function(response) {
					GraphicHandler.qualityModelDataModelExecuteResultLoad(response);
				}, function(error_msg) {

					GraphicHandler.messageError(error_msg, "#lblError");
				});
	}

	// **********************************************************************//
	// Execute agregations
	// *********************************************************************//

	this.executeAggregationsSelectPage = function() {
		GraphicHandler.showLoader();

		var idDataQualityModel = $('#cbDataQualityModel').val();
		$('#divResult').hide();
		if (idDataQualityModel > 0) {
			$('#divSelectIM').load('executeAggregationsSelectPage?idDataQualityModel=' + idDataQualityModel);
			$('#divSelectIM').show();
		} else {
			$('#divSelectIM').hide();
		}
		GraphicHandler.hideLoader();

	}

	this.executeAggregationsValidate = function(idDataModel) {
		GraphicHandler.showLoader();
		var aggregationsIds = [];
		var i = 0;
		$('input[name="aggregationsIds"]:checkbox:checked').each(function() {
			aggregationsIds[i] = $(this).val();
			++i;
		});

		if (aggregationsIds.length == 0) {

			GraphicHandler.messageError("Select aggregations for execute.", "divError");

		} else {
			GraphicHandler.executeAggregationsDeleteIMResult(idDataModel);
		}
	}

	this.executeAggregationsAjax = function(idDataQualityModel, deleteIMResults) {
		GraphicHandler.showLoader();
		var aggregationsIds = [];
		var i = 0;
		$('input[name="aggregationsIds"]:checkbox:checked').each(function() {
			aggregationsIds[i] = $(this).val();
			++i;
		});

		ComunicationHandler.executeAggregationsAjax(idDataQualityModel, aggregationsIds, deleteIMResults, function(response) {
			GraphicHandler.qualityModelDataModelExecuteResultLoad(response);
		}, function(error_msg) {

			GraphicHandler.messageError(error_msg, "#lblError");
		});
	}

	
	// **********************************************************************//
	// Execute composed IM
	// *********************************************************************//

	this.executeComposedIMSelectPage = function() {
		GraphicHandler.showLoader();

		var idDataQualityModel = $('#cbDataQualityModel').val();
		$('#divResult').hide();
		if (idDataQualityModel > 0) {
			$('#divSelectcComposedIM').load('executeComposedIMSelectPage?idDataQualityModel=' + idDataQualityModel);
			$('#divSelectcComposedIM').show();
		} else {
			$('#divSelectcComposedIM').hide();
		}
		GraphicHandler.hideLoader();

	}

	this.executeComposedIMValidate = function(idDataModel) {
		GraphicHandler.showLoader();
		var composedIMIds = [];
		var i = 0;
		$('input[name="composedIMIds"]:checkbox:checked').each(function() {
			composedIMIds[i] = $(this).val();
			++i;
		});

		if (composedIMIds.length == 0) {

			GraphicHandler.messageError("Select composed instanced metrics for execute.", "divError");

		} else {
			GraphicHandler.executeComposedIMDeleteIMResult(idDataModel);
		}
	}

	this.executeComposedIMAjax = function(idDataQualityModel, deleteComposedIMResults) {
		GraphicHandler.showLoader();
		var composedIMIds = [];
		var i = 0;
		$('input[name="composedIMIds"]:checkbox:checked').each(function() {
			composedIMIds[i] = $(this).val();
			++i;
		});

		ComunicationHandler.executeComposedIMAjax(idDataQualityModel, composedIMIds, deleteComposedIMResults, function(response) {
			GraphicHandler.qualityModelDataModelExecuteResultLoad(response);
		}, function(error_msg) {

			GraphicHandler.messageError(error_msg, "#lblError");
		});
	}
	
	// **********************************************************************//
	// Resultado de ejecucion
	// *********************************************************************//

	this.executeDataQulityModelResultAjax = function() {

		var idDataQualityModel = $('#cbDataQualityModel').val();
		if (idDataQualityModel != 0) {
			ComunicationHandler.executeDataQulityModelResultAjax(idDataQualityModel, function(response) {
				GraphicHandler.executeDataQulityModelResultLoad(response);
			}, function(error_msg) {
				GraphicHandler.messageError(error_msg, "#lblError");
			});
		}

		// TODO: mostrar mensaje de error de seleccionar elementos
	}

	// **********************************************************************//
	// Mostrar modelo de datos
	// *********************************************************************//

	// Carga la tabla con las metricas instanciadas
	// dimensions: lista de dimemensiones que tienen las metricas instanciadas
	// agupadas por metodos, metricas, factores y dimensiones
	// contextPath: pagina donde se invoca la funcion para mostrar mensaje de
	// error
	this.instanceMetricsLoadTable = function(dimensions, contextPath) {
		GraphicHandler.instanceMetricsLoadTable(dimensions, contextPath);
	}

	
}
